
#line 3 "lex.yy.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 0
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern yy_size_t yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    #define YY_LINENO_REWIND_TO(dst) \
            do {\
                const char *p;\
                for ( p = yy_cp-1; p >= (dst); --p)\
                    if ( *p == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
yy_size_t yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,yy_size_t len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
#if defined(__GNUC__) && __GNUC__ >= 3
__attribute__((__noreturn__))
#endif
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	(yytext_ptr) -= (yy_more_len); \
	yyleng = (size_t) (yy_cp - (yytext_ptr)); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 402
#define YY_END_OF_BUFFER 403
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_acclist[1225] =
    {   0,
      403,  401,  402,  383,  401,  402,  383,  384,  402,  401,
      402,  401,  402,  401,  402,  276,  401,  402,  253,  401,
      402,  311,  401,  402,  356,  401,  402,  345,  401,  402,
      351,  401,  402,  360,  401,  402,  320,  401,  402,  399,
      400,  401,  402,  344,  401,  402,  385,  401,  402,  308,
      401,  402,  287,  401,  402,  272,  401,  402,  386,  401,
      402,  355,  401,  402,  388,  401,  402,  388,  401,  402,
      388,  401,  402,  388,  401,  402,  388,  401,  402,  388,
      401,  402,  388,  401,  402,  388,  401,  402,  388,  401,
      402,  388,  401,  402,  388,  401,  402,  388,  401,  402,

      388,  401,  402,  388,  401,  402,  388,  401,  402,  388,
      401,  402,  388,  401,  402,  388,  401,  402,  388,  401,
      402,  388,  401,  402,  388,  401,  402,  388,  401,  402,
      388,  401,  402,  388,  401,  402,  290,  401,  402,  271,
      401,  402,   54,  401,  402,    4,  401,  402,  374,  401,
      402,  367,  401,  402,    2,  402,    3,  402,    1,    2,
      402,  383,  288,  389,  393,  394,  395,  396,  400,  399,
      400,   37,  251,  391,  289,  390,  286,  237,  392,  388,
      388,  388,  388,  388,  388,  388,  388,  358,  388,  388,
      388,  388,  388,  388,  359,  388,  388,  388,  388,  388,

      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  361,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  362,  388,  363,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  364,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  378,  388,  388,   97,
      288,  393,  395,  357,    5,  251,  289,  237,  388,  338,
      388,  388,  339,  388,  388,  340,  388,  341,  388,  388,

      342,  388,  388,  388,  343,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  346,  388,  347,  388,  257,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  366,  388,  279,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  348,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  262,  388,  388,  388,  388,  388,
      388,  388,  388,  349,  388,   89,  388,  350,  388,  352,
      388,  388,  388,  388,  388,  353,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,

      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  337,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  354,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  398,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  316,  388,  317,  388,  230,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      318,  388,  388,  388,  388,  388,  319,  388,  388,  388,
      388,  388,  388,  323,  388,  324,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,

      388,  388,  325,  388,  388,  388,  388,  326,  388,  388,
      388,  388,  388,  388,  264,  388,  388,  327,  388,  388,
      388,  328,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  300,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  329,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  330,  388,  388,  388,  388,  331,
      388,  332,  388,  370,  388,  388,  301,  388,  388,  388,
      388,  388,  388,  388,  388,  333,  388,  388,  388,  388,
      388,  334,  388,  388,  388,  335,  388,  388,  388,  302,

      388,  388,  388,  388,   51,  388,  388,  388,  388,  388,
      388,  388,  303,  388,  388,  388,  388,  388,  375,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  273,
      388,  388,  388,  388,  304,  388,  305,  388,  388,  388,
      306,  388,  388,  388,  388,  368,  388,  307,  388,  388,
      388,  388,  388,  388,   59,  388,  388,  388,   48,   49,
      388,  388,  309,  388,  310,  388,  231,  388,  388,  388,
      388,  312,  388,  313,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  372,

      388,  388,  388,  388,  120,  388,  322,  388,  388,  388,
      388,  388,  388,   47,  388,  138,  371,  388,  388,  314,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      315,  388,  388,  388,  388,  388,  365,  388,  388,  265,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  277,  388,  388,  376,  388,  388,
      388,  388,  388,  388,  278,  388,  388,  388,  280,  388,
      281,  388,  388,  388,  388,  388,  388,  388,  282,  388,
      388,  283,  388,  388,  388,  336,  388,  388,  388,  284,
      388,  285,  388,  274,  388,  388,  388,  388,  388,  388,

      291,  388,  388,  388,  388,  388,  388,  388,  292,  388,
      293,  388,  388,  388,  294,  388,  295,  388,  296,  388,
      119,  388,  388,  388,  388,  388,  388,  388,  297,  388,
      388,  298,  388,  299,  388,  388,  388,  388,  388,  275,
      132,  388,  252,  388,  388,  388,  381,  388,  388,  254,
      388,  388,  388,   46,  255,  388,  388,  388,  256,  388,
      259,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  261,  388,  388,  250,  388,  269,
      388,  258,  388,  388,  388,   75,  388,  388,  388,  388,
      388,  388,  388,  267,  388,  116,  114,  388,  115,  388,

      388,  388,  388,  388,  388,   39,  388,  270,  388,   90,
      388,  388,  388,  388,  388,  388,  388,  388,  239,  388,
      240,  388,  388,  241,  388,   60,  388,  380,  388,  388,
      388,  388,  388,  242,  388,  243,  263,  388,  244,  388,
      233,  388,  245,  247,  232,  388,  388,  248,  388,  388,
      388,  118,  388,  249,  388,  388,  388,  388,   83,  388,
      148,  388,   50,  388,  268,  388,  229,  388,  388,  234,
      388,  235,  236,  388,  202,  388,  388,  388,  238,   68,
       91,  112,  246,   76,   52,  388,  388,  117,  379,  388,
      388,  377,  388,  373,  388,   82,  388,  150,  152,  140,

      147,  218,  266,  388,  126,  388,  219,  193,   38,  388,
      388,  369,  388,  221,   77,  222,  223,  224,  388,  388,
       67,  226,  388,  388,  163,   74,  388,  154,  144,  149,
      151,  139,  387,  397,  111,  110,  227,  208,    7,  209,
       41,  210,  388,  388,  211,  212,   29,  213,  214,  215,
       86,  388,  321,  388,   80,  156,  146,  160,  142,  153,
      143,  141,   66,   84,   85,   93,  216,   43,  170,  198,
        6,  199,  201,  125,   98,  388,  388,   71,   28,   61,
      228,  196,  388,   79,   81,  158,  162,  155,  145,  159,
      204,   40,   44,   45,  203,  200,  122,  388,  388,  220,

       70,  217,   31,   30,   34,  137,   95,  225,  205,   72,
      388,  157,  161,  123,  188,  189,   27,   99,  260,  388,
      388,   87,   32,   34,  135,  195,  206,   92,  164,  382,
       42,  121,   64,   19,   14,   23,   73,  124,  388,   69,
      186,  129,  207,  113,   53,  104,  100,  130,  102,  388,
       33,   36,  136,  133,   88,   55,  185,  103,  106,  131,
      181,    8,   26,  101,  388,  194,  134,   62,   56,  197,
      182,  183,  105,   20,   15,   24,  388,   35,   65,  168,
      109,  388,  169,   63,    9,   25,  192,  388,   96,  167,
      191,  108,   21,   16,  128,  388,  187,  190,  107,   22,

       10,   17,  180,   78,  127,  184,   18,   11,   57,  173,
      166,  179,  176,   58,  178,  165,   12,   94,  175,  172,
       13,  177,  174,  171
    } ;

static yyconst flex_int16_t yy_accept[2282] =
    {   0,
        1,    1,    1,    1,    1,    2,    4,    7,   10,   12,
       14,   16,   19,   22,   25,   28,   31,   34,   37,   40,
       44,   47,   50,   53,   56,   59,   62,   65,   68,   71,
       74,   77,   80,   83,   86,   89,   92,   95,   98,  101,
      104,  107,  110,  113,  116,  119,  122,  125,  128,  131,
      134,  137,  140,  143,  146,  149,  152,  155,  157,  159,
      162,  163,  163,  165,  165,  167,  167,  169,  169,  169,
      169,  169,  170,  170,  172,  173,  173,  175,  177,  177,
      178,  178,  180,  180,  180,  181,  182,  183,  184,  185,
      186,  187,  188,  190,  191,  192,  193,  194,  195,  197,

      198,  199,  200,  201,  202,  203,  204,  205,  206,  207,
      208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
      218,  219,  220,  221,  222,  223,  224,  226,  227,  228,
      229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
      239,  240,  241,  242,  244,  246,  247,  248,  249,  250,
      251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
      261,  262,  263,  264,  265,  267,  268,  269,  270,  271,
      272,  273,  274,  275,  276,  277,  279,  280,  280,  280,
      281,  282,  283,  284,  284,  284,  285,  285,  286,  287,
      288,  289,  289,  289,  290,  292,  293,  295,  296,  298,

      300,  301,  303,  304,  305,  307,  308,  309,  310,  311,
      312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
      322,  324,  326,  328,  329,  330,  331,  332,  333,  334,
      335,  336,  337,  338,  340,  342,  343,  344,  345,  346,
      347,  348,  349,  350,  351,  352,  354,  355,  356,  357,
      358,  359,  360,  361,  362,  362,  363,  364,  365,  367,
      367,  368,  369,  370,  371,  372,  373,  374,  376,  378,
      380,  382,  383,  384,  385,  386,  388,  389,  390,  391,
      392,  392,  393,  394,  395,  396,  397,  398,  399,  400,
      401,  402,  403,  404,  405,  406,  407,  408,  409,  410,

      411,  412,  414,  415,  416,  417,  418,  419,  420,  421,
      422,  424,  425,  426,  427,  427,  428,  429,  430,  430,
      431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
      441,  442,  443,  443,  443,  443,  444,  444,  445,  445,
      446,  447,  448,  449,  450,  450,  451,  452,  453,  454,
      455,  456,  458,  460,  462,  463,  464,  465,  466,  467,
      468,  469,  470,  471,  473,  474,  475,  476,  477,  479,
      480,  481,  482,  483,  484,  486,  488,  489,  489,  490,
      491,  492,  493,  494,  495,  496,  497,  498,  499,  500,
      501,  501,  502,  503,  505,  506,  507,  508,  510,  511,

      512,  512,  512,  513,  514,  515,  517,  518,  520,  520,
      521,  522,  524,  525,  526,  527,  528,  528,  528,  529,
      530,  531,  532,  533,  533,  534,  535,  535,  537,  538,
      539,  540,  540,  540,  541,  542,  543,  544,  545,  546,
      548,  549,  550,  551,  552,  553,  554,  555,  556,  557,
      558,  558,  559,  560,  561,  561,  562,  563,  564,  565,
      567,  568,  569,  570,  570,  572,  574,  576,  576,  576,
      576,  577,  579,  580,  580,  581,  582,  583,  584,  585,
      586,  586,  588,  589,  590,  591,  592,  594,  595,  596,
      598,  598,  598,  598,  599,  599,  600,  600,  602,  603,

      604,  604,  605,  606,  607,  608,  609,  610,  611,  612,
      613,  615,  616,  617,  618,  619,  621,  622,  623,  624,
      625,  626,  627,  628,  629,  630,  631,  632,  633,  634,
      634,  635,  635,  636,  637,  638,  639,  639,  640,  642,
      643,  644,  645,  647,  649,  649,  649,  650,  651,  653,
      654,  655,  656,  658,  658,  658,  660,  661,  662,  663,
      664,  664,  664,  664,  665,  665,  667,  667,  668,  669,
      670,  671,  672,  672,  673,  675,  677,  677,  679,  679,
      679,  679,  679,  679,  679,  680,  681,  682,  682,  682,
      684,  686,  687,  688,  689,  690,  691,  692,  693,  694,

      695,  696,  697,  698,  699,  700,  702,  702,  703,  704,
      705,  706,  706,  706,  706,  706,  706,  706,  706,  706,
      706,  706,  706,  707,  709,  710,  711,  712,  713,  714,
      715,  716,  716,  716,  717,  719,  719,  719,  719,  719,
      719,  719,  719,  719,  720,  722,  723,  723,  724,  725,
      726,  726,  727,  728,  729,  730,  731,  733,  733,  734,
      734,  734,  734,  735,  735,  735,  735,  735,  736,  736,
      736,  737,  739,  739,  740,  742,  743,  744,  745,  746,
      747,  748,  749,  749,  750,  751,  752,  753,  754,  755,
      757,  758,  760,  761,  762,  763,  764,  764,  764,  764,

      764,  764,  764,  764,  765,  765,  767,  768,  769,  771,
      771,  771,  773,  774,  775,  776,  777,  777,  777,  778,
      779,  779,  781,  782,  782,  782,  782,  784,  785,  786,
      786,  786,  786,  788,  788,  788,  788,  788,  789,  790,
      792,  792,  794,  794,  794,  794,  794,  795,  795,  795,
      795,  796,  797,  798,  798,  798,  799,  800,  801,  803,
      804,  805,  806,  807,  808,  809,  811,  813,  814,  815,
      815,  817,  819,  821,  821,  822,  822,  822,  822,  822,
      822,  822,  822,  822,  822,  822,  822,  822,  822,  822,
      823,  824,  825,  826,  826,  827,  828,  828,  828,  828,

      828,  828,  828,  828,  828,  828,  829,  831,  831,  831,
      831,  831,  831,  831,  832,  834,  834,  834,  836,  837,
      838,  839,  839,  839,  839,  839,  839,  840,  841,  841,
      841,  841,  841,  841,  841,  841,  841,  841,  842,  842,
      843,  843,  843,  845,  846,  847,  849,  850,  850,  852,
      853,  854,  855,  855,  857,  858,  859,  861,  863,  863,
      864,  865,  866,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  868,  868,  869,  870,  870,  870,  870,
      871,  872,  873,  873,  873,  874,  875,  875,  875,  875,
      875,  875,  875,  877,  878,  878,  878,  879,  879,  879,

      879,  879,  880,  882,  882,  882,  882,  882,  882,  882,
      882,  882,  882,  884,  885,  885,  885,  885,  886,  888,
      889,  890,  891,  891,  891,  892,  892,  893,  894,  894,
      896,  896,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  899,  901,  902,  903,  904,
      904,  905,  906,  906,  906,  907,  907,  907,  907,  907,
      907,  907,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  910,
      912,  913,  913,  913,  913,  913,  913,  913,  914,  914,
      914,  914,  914,  914,  914,  914,  914,  914,  914,  914,

      914,  914,  914,  915,  916,  917,  917,  918,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  921,  923,  923,  923,  924,  924,  926,  928,
      928,  928,  928,  928,  928,  928,  928,  928,  928,  930,
      930,  931,  931,  931,  931,  931,  932,  933,  934,  934,
      934,  934,  936,  937,  937,  937,  937,  937,  937,  939,
      941,  941,  941,  941,  941,  941,  941,  943,  943,  943,
      943,  943,  943,  943,  944,  944,  945,  947,  947,  947,
      947,  947,  947,  947,  948,  948,  948,  948,  950,  950,
      951,  952,  952,  952,  953,  953,  953,  953,  953,  953,

      953,  953,  953,  953,  953,  954,  956,  957,  957,  958,
      959,  959,  959,  959,  959,  960,  960,  960,  960,  961,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  963,  963,  963,
      963,  963,  963,  963,  963,  963,  963,  963,  963,  963,
      963,  963,  963,  963,  963,  964,  964,  964,  964,  965,
      967,  969,  969,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  973,  973,

      975,  975,  975,  975,  976,  976,  977,  978,  979,  979,
      979,  979,  979,  979,  979,  979,  979,  979,  980,  980,
      981,  981,  981,  981,  982,  982,  982,  983,  983,  984,
      984,  984,  984,  985,  985,  986,  986,  986,  987,  987,
      987,  987,  987,  987,  988,  988,  988,  989,  989,  989,
      989,  989,  989,  989,  989,  989,  990,  990,  991,  992,
      992,  994,  996,  996,  996,  996,  996,  997,  997,  997,
      998,  999, 1000, 1000, 1000, 1000, 1001, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1003, 1005,
     1005, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
     1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
     1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
     1007, 1007, 1007, 1007, 1008, 1008, 1009, 1009, 1010, 1010,
     1010, 1010, 1010, 1011, 1012, 1014, 1014, 1015, 1015, 1015,
     1015, 1015, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1017, 1017, 1017, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1020, 1020, 1020, 1020, 1020, 1020, 1021, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1024, 1025,

     1025, 1026, 1026, 1026, 1026, 1026, 1026, 1028, 1029, 1029,
     1030, 1030, 1030, 1031, 1032, 1032, 1032, 1032, 1033, 1033,
     1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033,
     1033, 1033, 1034, 1035, 1035, 1035, 1035, 1035, 1036, 1037,
     1037, 1037, 1037, 1037, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1039, 1039, 1039, 1039, 1039, 1039, 1040, 1040,
     1040, 1040, 1040, 1041, 1041, 1041, 1041, 1041, 1041, 1041,
     1041, 1041, 1041, 1041, 1042, 1043, 1044, 1045, 1045, 1045,
     1046, 1046, 1046, 1046, 1047, 1047, 1047, 1047, 1047, 1047,

     1048, 1048, 1048, 1048, 1049, 1049, 1049, 1049, 1049, 1049,
     1049, 1050, 1050, 1050, 1050, 1051, 1051, 1051, 1051, 1051,
     1051, 1052, 1052, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1054, 1055, 1055, 1055, 1056, 1056, 1056, 1056,
     1057, 1058, 1059, 1060, 1061, 1061, 1062, 1062, 1063, 1063,
     1063, 1064, 1065, 1066, 1066, 1066, 1066, 1066, 1066, 1067,
     1068, 1068, 1068, 1068, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1070, 1070, 1070, 1070, 1070, 1071, 1071, 1071, 1071, 1071,
     1072, 1072, 1072, 1072, 1072, 1072, 1073, 1073, 1074, 1074,

     1074, 1074, 1074, 1074, 1075, 1075, 1076, 1076, 1076, 1077,
     1078, 1078, 1078, 1079, 1079, 1079, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1081, 1081, 1081, 1082, 1082, 1083, 1083, 1083, 1083,
     1083, 1083, 1083, 1083, 1083, 1083, 1083, 1084, 1084, 1084,
     1085, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1093, 1093, 1093, 1093,
     1093, 1093, 1093, 1094, 1095, 1095, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1097, 1097,

     1097, 1097, 1097, 1098, 1098, 1098, 1098, 1099, 1100, 1100,
     1101, 1102, 1102, 1103, 1104, 1105, 1105, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1107, 1107, 1107, 1107, 1107, 1108,
     1109, 1109, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1112, 1112, 1112, 1112, 1113, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1115, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1117, 1117, 1117, 1117, 1117, 1117,
     1117, 1118, 1118, 1118, 1118, 1118, 1118, 1119, 1119, 1119,
     1119, 1119, 1121, 1122, 1123, 1123, 1125, 1125, 1125, 1125,

     1125, 1125, 1125, 1125, 1125, 1126, 1126, 1126, 1126, 1126,
     1127, 1127, 1127, 1127, 1127, 1127, 1128, 1128, 1128, 1128,
     1128, 1129, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1131, 1131, 1131, 1131, 1131, 1132, 1132, 1132, 1132, 1133,
     1133, 1133, 1133, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1135, 1135, 1135, 1136, 1136, 1137, 1137, 1137,
     1138, 1138, 1139, 1139, 1139, 1139, 1140, 1140, 1140, 1140,
     1140, 1140, 1141, 1141, 1141, 1141, 1141, 1142, 1143, 1143,
     1143, 1143, 1143, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1145, 1145, 1145, 1145, 1146, 1146, 1147,

     1147, 1147, 1147, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1149, 1149, 1150, 1150, 1151, 1151, 1152, 1152, 1153,
     1153, 1153, 1154, 1155, 1155, 1155, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1157, 1157, 1157,
     1157, 1158, 1158, 1158, 1159, 1159, 1160, 1161, 1161, 1161,
     1161, 1161, 1161, 1161, 1161, 1161, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1163, 1163, 1164, 1164, 1164, 1165, 1166,
     1167, 1167, 1167, 1168, 1168, 1168, 1168, 1169, 1169, 1169,
     1169, 1169, 1169, 1169, 1169, 1170, 1170, 1171, 1172, 1173,

     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1175, 1175, 1176, 1176, 1176, 1177, 1177,
     1177, 1178, 1179, 1179, 1179, 1179, 1179, 1179, 1179, 1179,
     1179, 1179, 1179, 1179, 1179, 1179, 1179, 1179, 1179, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1181, 1181, 1182,
     1182, 1182, 1182, 1182, 1182, 1183, 1183, 1183, 1183, 1183,
     1183, 1183, 1183, 1183, 1183, 1183, 1183, 1183, 1183, 1183,
     1183, 1183, 1184, 1185, 1185, 1185, 1185, 1185, 1185, 1185,
     1185, 1185, 1185, 1185, 1186, 1187, 1188, 1189, 1189, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1191, 1191, 1192, 1192, 1192,
     1193, 1194, 1194, 1195, 1195, 1195, 1197, 1197, 1197, 1197,
     1197, 1197, 1197, 1197, 1197, 1197, 1197, 1197, 1197, 1198,
     1198, 1198, 1198, 1198, 1199, 1199, 1199, 1199, 1199, 1199,
     1199, 1199, 1199, 1199, 1199, 1199, 1199, 1199, 1199, 1199,
     1199, 1199, 1199, 1199, 1199, 1199, 1199, 1199, 1199, 1200,
     1201, 1201, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1205, 1205,

     1205, 1205, 1205, 1205, 1205, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1207, 1207, 1207, 1207, 1207,
     1207, 1208, 1209, 1209, 1209, 1209, 1209, 1209, 1209, 1209,
     1209, 1209, 1209, 1210, 1210, 1210, 1211, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1213, 1213, 1214, 1214,
     1214, 1215, 1215, 1216, 1216, 1216, 1216, 1216, 1216, 1217,
     1218, 1218, 1219, 1219, 1220, 1220, 1220, 1220, 1220, 1221,
     1221, 1221, 1221, 1222, 1223, 1223, 1223, 1223, 1224, 1225,
     1225
    } ;

static yyconst YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    1,    1,    1,    1,    7,    8,
        9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
       16,   16,   16,   16,   16,   19,   16,   20,   21,   22,
       23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
       33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
       43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
       53,    1,   54,    1,   55,   56,   57,   58,   59,   60,

       61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
       71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
       81,   82,   83,   84,   85,   86,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst YY_CHAR yy_meta[87] =
    {   0,
        1,    2,    2,    2,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    2,    1,    3,    3,    3,    3,    1,
        1,    1,    1,    1,    1,    1,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    1,    1,    3,    1,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    1,    1,    1,    1
    } ;

static yyconst flex_uint16_t yy_base[2292] =
    {   0,
        0,    0,   84,   85,  829,10515,   87,   90,   93,  797,
      756,   96,10515,10515,   99,10515,  748,   88,10515,   94,
      729,10515,  115,  119,  122,  713,  711,  156,  210,  265,
      320,  371,  426,  212,  233,  320,  270,  375,  425,  444,
      497,  551,  489,  437,  598,  536,  548,  322,   96,  541,
      599,10515,  630,10515,10515,  160,10515,10515,10515,10515,
      130,  321,10515,  643,10515,  640,  620,  317,   83,  147,
      612,  136,  162,  409,10515,  394,10515,10515,  519,10515,
      537,10515,  547,   81,    0,  617,  648,  616,  665,  670,
      691,  712,  724,  725,  748,  774,  759,  792,  794,  813,

      820,  846,  866,  859,  862,  899,  908,  932,  940,  917,
      959,  968,  979,  986, 1021, 1025, 1027, 1061, 1074, 1077,
     1084, 1127, 1085, 1126, 1134, 1144, 1219, 1167, 1162, 1182,
     1194, 1221, 1209, 1241, 1260, 1267, 1286, 1214, 1292, 1282,
     1301, 1333, 1342, 1348, 1352, 1354, 1387, 1393, 1402, 1408,
     1458, 1413, 1461, 1481, 1476, 1513, 1515, 1521, 1518, 1536,
     1568, 1570, 1573, 1576, 1621, 1595, 1623, 1657, 1642, 1646,
      666, 1686, 1697, 1703, 1680, 1683, 1720,  511,  364,10515,
    10515,10515,  523,  520,   97,10515,  515,10515,10515,10515,
    10515,   94,  119, 1717, 1770, 1758, 1782, 1776, 1755, 1767,

     1779, 1819, 1821, 1825, 1863, 1847, 1868, 1876, 1872, 1881,
     1907, 1922, 1923, 1935, 1957, 1966, 1977, 1975, 1972, 2023,
     1818, 1981, 1894, 2032, 2030, 2043, 2038, 2072, 2077, 2084,
     2103, 2098, 2127, 2170, 2142, 2092, 2155, 2170, 2031, 2179,
     2185, 2191, 2199, 2215, 2241, 2282, 2237, 2243, 2286, 2269,
     2265, 2287, 2300, 2325,  869, 2338, 2339, 2344, 2379,  915,
      152, 2355, 2390, 2391, 2397, 2410, 2441, 2439, 2445, 2483,
     2467, 2483, 2487, 2490, 2494, 2535, 2496, 2527, 2545, 2541,
     1073, 2556, 2577, 2594, 2593, 2595, 2602, 2608, 2637, 2616,
     2652, 2658, 2666, 2683, 2684, 2700, 2712, 2759, 2718, 2743,

     2744, 2788, 2752, 2773, 2801, 2794, 2823, 2837, 2822, 2841,
     2890, 2871, 2875, 2880, 2920, 2930, 2937, 2940,  370, 2942,
     2979, 2982, 2994, 3027, 3029, 3001, 2932, 3035, 3060, 3050,
     3062,10515,  215,  222,  215, 3077,  907, 3083,  263, 3089,
     3110, 3120, 3164, 3149,  427, 3165, 3170, 3166, 3208, 3214,
     3216, 3222, 3227, 3261, 3233, 3269, 3274, 3003, 3275, 3149,
     3282, 3290, 3303, 3284, 3316, 3337, 3331, 3341, 3343, 3349,
     3363, 3380, 3388, 3394, 3432, 3416, 3433,  601, 3437, 3438,
     3476, 3475, 3484, 3480, 3526,  252, 3503, 3499, 3522, 3537,
     2839, 3536, 3544, 3549, 3559, 3577, 3584, 3582, 3604, 3610,

      251,  268, 3619, 3630, 3652,    0, 3656, 3705,  266,  270,
     3708, 3690, 3701, 3740, 3716, 3755,  549,  682, 3728, 3791,
     3750, 3776, 3796,  401, 3788, 3803, 3878, 3815, 3852, 3860,
     3875,  316,  306, 3898, 3908, 3931, 3933, 3954, 3659, 3805,
     3940, 3984, 3985, 3997, 3998, 3999, 4041, 4045, 3867, 4056,
     1470, 4060, 4073, 4069, 4140, 4090, 4195, 4196, 4197, 4201,
     4212, 4205, 4214,  772, 4250, 4255, 4256,  331,  366,  379,
     4261, 4267, 4272, 4341, 4265, 4315, 4317, 4356, 4363, 4335,
     1025, 4375, 4382, 4402, 4408, 4397, 4435, 4443, 4483, 4447,
      390,  414,  427, 4468,  428, 4488,  436, 4523, 4503, 4535,

     1034, 4515,10515, 4541, 4538, 4561, 4543, 4583, 4563, 4601,
     4603, 4608, 4623, 4629, 4648, 4693, 4669, 4674, 4689, 4705,
     4726, 4739, 4740, 4744, 4753, 4760, 4778, 4788, 4799, 4874,
     4823,  447, 4811, 4835, 4861, 4880, 3795, 4884, 4895,  462,
     4921, 4932, 4929, 4936,  468,  477, 4940, 4880, 4942, 5011,
     4955, 4989, 4991,  502,  507, 4994, 5026, 5001, 5029, 5048,
     1440,  489,  517,  520, 5080, 5041, 3217, 5066, 5076,10515,
    10515, 5087, 1660, 5081, 5108, 5123,  559, 5126, 1868,  558,
      764,  600,  609,  646, 5138, 5140, 5147,  678,  685, 5149,
     5168, 5186, 5183, 5189, 5207, 5240, 5243, 5246, 5222, 5249,

     5282, 5294, 5300, 5303, 5306, 5309,  682, 5321, 5341, 5252,
    10515, 2927, 5391, 5397, 5416, 5422, 5445, 5487, 5494, 5512,
     5520, 5552, 5570, 5523, 5557, 5561, 5559, 5608, 5612,10515,
     5410,  681,  697,10515, 5609, 1974,    0,  711,  727,  737,
      786,  790,  787, 5612, 5616, 5621, 5696, 5657, 5669, 5662,
      808, 5707, 5716, 5740, 5748, 5681, 5785, 5796, 5775,  802,
      924,  925, 5810,  920, 2950,  933, 4824, 5837, 1389,  968,
     5843, 5875, 3083, 5787, 5849, 5859, 5888, 5869, 5931, 5897,
     5909, 5929, 1399, 5965, 5950, 5954, 5956, 5986, 5976, 6031,
     6004, 6010, 6025, 6016, 6028, 6079,  966, 1010, 1037, 1028,

     1061, 1086, 1081, 6077, 1125, 6067, 6086, 6121, 6099, 1121,
     1134, 6130, 6143, 1141, 1186, 6134, 1208, 1238, 6145, 6149,
     4640, 6181, 6202, 1237, 1257, 3884, 6219, 6190, 6215, 1296,
      651, 1315,    0, 1318, 1329, 1358, 1396, 6224, 6233, 6198,
     1387, 6272, 1407, 1412, 1423, 1447,10515, 1459, 1456, 1467,
     6267, 6276, 6314, 1518, 1531, 6313, 6322, 6315, 6318, 6325,
     6360, 6400, 6405, 6381, 6415, 6379, 6420, 6427, 6455, 1530,
     6447, 6452, 6473, 3167, 2113, 1306, 2835, 3525, 6523, 6541,
     6549, 6567, 6595, 6613, 6641, 6659, 6689, 6707, 2382, 6529,
     6271, 6700, 6614, 3439, 6692, 6726, 1542, 2285, 1565, 1572,

     1579, 1622, 1628, 1647, 1686, 6708, 6713, 1710, 1698, 2392,
     1709, 1744, 6793, 6783, 6796, 1731, 5946, 6744, 6775, 6801,
     6832, 4000, 1760, 1753, 2536, 1807, 6544,10515, 1858, 1896,
     3755, 1911, 1954, 1997, 2009, 2025, 3987,10515, 2041, 6843,
     6869, 2096, 6653, 6655, 6852, 6845, 6855, 4224, 6880, 6892,
     6909, 2646, 6976, 6930, 6924, 6969, 6926, 7011, 3629, 7012,
     7053, 6996, 6999, 5386, 2116, 2111, 2118, 2149, 2151, 2178,
     2187, 2213, 7052, 2224, 7054, 7061, 2291, 2289, 3908, 2300,
     2323, 7057, 2334, 2354, 7064, 7102, 2365, 3872, 2381, 2440,
     2441, 4725, 7076, 7108, 2535, 4350,10515, 2551, 2544, 2601,

     2605, 7116, 7121, 2623, 4755, 2659, 2651, 2661, 2677, 2708,
     2716, 2728, 7133, 7159, 3953, 2740, 2746, 7202, 7142, 7210,
     7216, 7164, 5188, 4044, 7208, 5476, 7221, 7252, 2764,    0,
     3035,10515, 4152, 4835, 7289, 7295, 7320, 7339, 7345, 7385,
     7407, 7413, 7431, 2490,    0,    0, 7423, 7209, 7434, 2783,
     7438, 7443, 2798, 5517,10515, 2806, 2839, 2850, 2864, 2883,
     2903, 7471, 2926, 2977, 3006, 3077, 3102, 3117, 3156, 3155,
     3532, 3206, 3222, 4241, 5040, 3219, 3274, 3278, 7489, 7491,
     7494, 3309, 3336, 3345, 3364, 3414, 3842, 7526,  467, 3412,
     3429, 3443, 3465, 3475, 3488, 3550, 3555, 3596, 4143, 3594,

     3590, 3594, 7517, 7508, 7546, 3634, 7547, 7593, 6317, 3636,
     3643, 3663, 6437, 3669, 3685, 3850, 4418, 3708, 3710, 3932,
     7597, 7575, 7599, 7622, 3925, 7628, 5714, 7581, 7617, 3932,
     3979, 3976, 4013, 4056, 4048, 4067, 4096, 4084, 7642, 4123,
     7653, 6921, 4127, 4251, 4269, 4274, 4262, 7678, 4265, 4310,
     5490, 7659,10515, 4313, 4330, 4745, 4347, 4376,    0, 7687,
     4381, 4405, 4443, 4457, 4471, 4484, 7695, 4493, 4522, 4550,
     4551, 4542, 4577,10515, 4587, 4888, 7700, 4581, 4617, 4607,
     5419, 5748, 5661, 7706, 4633, 4660, 4648, 7704, 4666, 7773,
     7752, 4668, 5465, 5888, 7781, 7811, 7830, 7851, 7857, 7878,

     7886, 7907, 7913, 5842, 7907, 7758, 7908, 4666, 7759, 7915,
     4735, 4765, 4790, 4811,10515, 4820, 4858, 4861, 7923, 4861,
     4877, 4916, 4920, 4933, 4935, 4930, 4959, 4985, 4998, 5012,
     5021, 5066, 5049, 5066, 5062, 5090, 7956, 5091, 5118, 5113,
     5121, 5239, 6093, 5541,  439, 5163, 5180, 5176, 5190, 5223,
     5236, 5250, 5245, 5259,10515, 5321, 5309, 5408, 7960, 7962,
     7964, 5407, 7968, 8009, 5416, 5425, 5470, 5487, 5523, 5507,
     5544, 5570, 5567, 5576, 5587, 5616, 5629, 5652, 5669, 5681,
     5693, 5705, 6617, 5716, 5725, 5729, 5782, 7983, 5781, 5799,
     5786, 5789, 5826, 5818, 5869, 5883, 5889,10515, 5907, 8010,

     5907, 5936, 5960,10515, 5971, 6005, 6026, 8016, 6113, 6028,
     6071, 6059, 6070, 6786, 6078, 6074, 7362,10515, 6098,10515,
     6126, 6172, 6163,10515, 6147,  400,10515, 6190,10515, 6254,
     6320, 6257,10515, 6278,10515, 6329, 6338, 8018, 6367, 6387,
     6467, 6387, 7453, 8021, 6378, 6530,10515, 8085, 8103, 8109,
     8132, 8152, 8139, 8172, 8201, 8207, 6401, 8167, 8202, 6447,
     8204, 8208, 6456, 6473, 6493, 6536,10515, 6540, 6549, 8212,
    10515, 6543, 6562, 6587, 6586, 6594, 6596, 6620, 6618, 6656,
     6671, 6678, 6705, 6710, 6706, 6743, 6761, 6900, 6761, 6770,
     6774, 6791, 7260, 6787, 6836,  422,  381, 6842, 6865, 6895,

     6908, 6896, 6920, 6509, 6941, 6934, 6947,10515, 8227, 6950,
     8249, 6955, 6955, 6998, 7036, 7038, 7072, 6644, 7079, 7116,
     7122, 7110, 7147, 7164, 7155, 7193, 7193, 7204, 7203, 7222,
     7247,  370,  368, 8163, 7262, 7272, 7284, 7277, 7297, 7323,
     6812, 7310, 7333,10515, 7315, 7102, 7367,10515, 7366, 7367,
     7379, 7408, 7412, 7426, 8253, 8072, 7325, 7412, 7436, 7463,
     7484,10515, 7490,  348,  327, 7355, 8288, 7501, 7389, 8249,
    10515, 7516, 7518,10515, 7561, 7568, 7589, 7582, 7579, 7607,
     8281, 7597, 7635, 8315, 7647, 7638, 8303,10515, 8336, 8356,
     8382, 8385, 8391, 7649, 8414, 8433, 7673, 8421, 8430, 7698,

    10515, 7684, 7696, 7707, 7724, 7728, 8427,10515, 7757, 7744,
     7764, 7762,10515, 7811, 7831, 7849, 7858, 7875, 7884, 7891,
     7900, 7948, 7959, 7963, 7972, 7416, 7848, 7965, 7967, 7984,
     7997,10515,10515, 8011, 8026, 8033, 8035,10515,10515, 8129,
     8106, 8029, 8073,10515, 8103, 8132, 8128, 8119, 8138, 8173,
     8439, 8167, 8187, 8188, 8222, 8259, 8257, 8258, 8269, 8135,
     8284,10515, 8296, 8378,  312,  286,  255,10515, 8496, 8303,
     8319, 8304,10515, 8330, 8355, 8462, 8421, 8416, 8433, 8515,
     8430, 8448, 8466,10515,10515, 8458, 8468, 8481, 8518,10515,
     8479, 8496, 8498,10515,  248,  201,  202, 8523, 8405,10515,

     8517, 8547, 8527,10515, 8545, 8566, 8525, 8513, 8569, 8514,
    10515, 8527, 8528, 8535,10515, 8538, 8538, 8548, 8548, 8551,
    10515, 8543, 8591, 8616, 8625, 8556, 8645, 8670, 8566, 8679,
     8700,10515, 8645, 8574, 8569,10515, 8572, 8596, 8591, 8624,
    10515, 8630,10515,10515, 8648, 8640, 8662,10515, 8670, 8671,
    10515,10515,10515, 8679, 8673, 8724, 8735, 8687,10515,10515,
     8682, 8696, 8690,10515, 8701, 8742, 8745, 8700, 8705, 8714,
     8715, 8715, 8595, 8730, 8737, 8719, 8723, 8729, 8736,10515,
     8726, 8744, 8748, 8726,10515, 8776, 8752, 8754, 8806,10515,
     8807, 8811, 8815, 8826, 8821,10515, 8734,10515, 8654, 8744,

     8749, 8776, 8785,10515, 8785,10515, 8775, 8817, 8819, 8820,
     8820, 8822, 8810, 8854, 8828,10515, 8851, 8855, 8874, 8878,
     8834, 8859, 8849, 8836, 8848, 8833, 8906, 8839, 8845, 8864,
    10515, 8869, 8862,10515, 8866,10515, 8876, 8917, 8921, 8942,
     8884, 8951, 8969, 8896, 8987, 9015, 8917, 8891, 8933,10515,
     8937,10515,10515,10515, 8924,10515, 8925,10515, 8939, 8955,
     8950, 8965, 8966, 9041, 8972,10515, 8965, 8975, 9045, 8994,
     8979, 9052,10515,10515, 8986,10515, 8990, 9060, 8991, 8991,
     9012, 9018, 9038, 9028, 9040, 9070, 9076, 9036, 9054, 9083,
     9091, 9048, 9099, 9107, 9118, 9129, 9113,10515, 9106, 9055,

     9059, 9079,10515, 9137, 9108, 9114, 9105,  113, 9120,10515,
    10515, 9151,10515,10515,10515, 9147,10515, 9169, 9141, 9126,
     9129, 9119, 9138,10515, 9135, 9142, 9125, 9134,10515,10515,
     9145,10515, 9150, 9207, 9210, 9162, 9163, 9232, 9213, 9250,
     9275, 9198, 9177, 9188, 9237,10515,10515, 9196, 9216, 9255,
     9209, 9224, 9278, 9233,10515,10515, 9238, 9237, 9293, 9263,
     9254, 9266, 9251, 9262, 9305, 9273, 9281, 9282, 9266, 9275,
     9319, 9333, 9344,10515, 9291, 9348, 9354, 9279,  100,  139,
    10515, 9343, 9356,  682, 9297, 9322,10515, 9318, 9378, 9325,
     9320,    0, 9341,10515, 9335,10515, 9401, 9369, 9373, 9407,

     9386, 9358, 9368, 9428,10515, 9359, 9378, 9391, 9393,10515,
     9388, 9394, 9441, 9434, 9408,10515, 9447, 9444, 9464, 9470,
    10515,10515, 9485, 9427, 9433, 9501, 9444, 9450, 9454,10515,
     9450, 9466, 9460, 9453,10515, 9510, 9458, 9531,10515, 9462,
     9479, 9541,10515, 9544, 9471, 9479, 9491, 9493, 9497, 9504,
     9507,10515, 9546, 9557,10515, 9564,10515, 9568, 9574,10515,
     9518,10515, 9518, 9530, 9527, 9530, 9548, 9586, 9604, 9608,
      142,10515, 9551, 9607, 9568, 9581,10515,10515, 9587, 9582,
     9632, 9628,10515, 9592, 9593, 9606, 9597, 9599, 9650, 9615,
     9657, 9612,10515, 9611, 9615, 9621,10515, 9635,10515, 9627,

     9644, 9679,10515, 9636, 9643, 9649, 9695, 9629, 9644, 9644,
     9660, 9646, 9671, 9658, 9669, 9699, 9710,  871, 9723, 9727,
    10515, 9687,10515, 9703, 9691, 9705,10515, 9739,10515, 9751,
     9769,10515,10515, 9717, 9721,10515, 9772, 9709, 9712, 9715,
     9717, 9720, 9709, 9780, 9732, 9753,10515, 9792, 9743, 9743,
    10515, 9750, 9757,10515, 9767,10515,10515, 9770, 9760, 9755,
     9765, 9764, 9765, 9765, 9773,10515, 9763, 9778, 9768, 9784,
      308,  808,10515, 9826,10515,  703, 9771,10515, 9775,10515,
     9839, 9843,10515,   85, 9794, 9785,10515, 9808, 9805, 9817,
     9833, 9866, 9863, 9844,10515, 9831, 9810,10515,10515,10515,

     9843, 9835, 9832, 9831, 9849, 9840, 9843, 9843, 9839, 9836,
     9849, 9837,10515, 9873,10515, 9881, 9903,10515, 9911, 9861,
     9892,10515, 9895, 9886, 9894, 9899, 9894, 9885, 9911, 9898,
     9906, 9912, 9903, 9919, 9903, 9908, 9947, 9902,10515, 9924,
     9911, 9926, 9918, 9908, 9916, 9932,10515, 9940,10515, 9982,
     9986,  806, 9997, 9935, 9941, 9944, 9961, 9992, 9961, 9964,
    10015, 9966, 9981, 9979, 9980, 9983, 9980, 9992, 9999, 9983,
     9989,10515,10515, 9985, 9982, 9982, 9995,10000, 9992, 9988,
      853, 1065,10027,10515,10515,10515, 9994, 9997,10515,10045,
    10005,10070,10074,10025,10028,10023,10033,10052,10082,10041,

    10055,10061,10047,10061,10515,10054,10515,10042,10097,10100,
    10515,10109,10515,10113,10117,    0,10063,10077,10072,10081,
    10112,10108,10112,10108,10103,10094,10119,10147,10515,   73,
    10120,10150,10111,10515,10129,10156,10159,10162,10148, 1192,
    10137,10140,10144,10154,10142,10162,10152,10146,10149,10197,
    10148,10168,10155,10165,10202,10205,10164,10171,10515,10515,
      892,10515,10212,10172,10184,10185,10232,10190,10202,10206,
    10192,10247,10250,10212,10208,10217,10217,10229,10255,10226,
    10233,10515,10263,10279,10224,10227,10242,10262,10247,10515,
    10285,10246,10306,10252,10256,10246,10253,10515,10275,10264,

    10270,10281,10309, 1412,10515,10271,10281,10286,10284,10328,
    10293,10289,10310,10300,10515,10305,10302,10313,10304,10298,
    10515,10515,10338,10319,10325,10331,10321,10329,10359,10337,
    10336,10340,10515,10344,10345,10515,10515,10367,10347,10333,
    10357,10356,10365,10395,10365,10515,10408,10515,10345,  893,
    10515,10369,10515,10357,10374,10377,10378,10412,10515,10515,
    10410,10515,10367,10515,10392,10382,10393,10428,10515,10401,
    10397,10408,10515,10515,10390,10410,10390,10515,10515,10515,
    10486,10489,10492,10495,  112,10497,10499,10502,10505,10508,
    10511

    } ;

static yyconst flex_int16_t yy_def[2292] =
    {   0,
     2280,    1, 2281, 2281, 2280, 2280, 2280, 2280, 2280, 2282,
     2283, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   28,   29,
       29,   29,   29,   29,   29,   32,   36,   36,   29,   29,
       29,   36,   42,   43,   43,   29,   36,   40,   29,   29,
       29, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2282, 2280, 2283, 2280, 2280, 2280, 2280,
     2284, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2285,   29,   29,   40,   40,   36,
       40,   47,   47,   47,   36,   36,   96,   96,   96,   96,

       96,   42,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   43,   96,   96,
       40,   40,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
      169,  169,  169,  169,   96,   96,   96, 2280, 2280, 2280,
     2280, 2280, 2280, 2283, 2280, 2280, 2284, 2280, 2280, 2280,
     2280, 2280, 2280,   96,   96,   96,   96,   96,   96,   96,

       96,  169,  169,  169,  169,  169,  169,  169,  169,  169,
      169,  169,  169,  169,  169,   96,   96,   96,   96,   96,
       96,   96,  169,  169,  169,  169,  169,   96,   96,  169,
      169,  169,  169,  169,  169,  169,  169,   96,   96,   96,
       96,  169,  169,  169,  169,  169,  169,  169,  169,  169,
      169,  169,  169,  169, 2280,  169,  169,  169,   29, 2280,
     2285,   96,   96,  169,  169,  169,  169,  169,  169,  169,
      169,   96,   96,   96,   96,   96,  169,  169,  169,  169,
     2280,  169,  169,  169,   96,   96,  169,  169,  169,  169,
      169,  169,  169,  169,  169,  169,  169,  169,  169,  169,

      169,  169,   96,   96,   96,  169,  169,  169,  169,  169,
      169,   96,   96,   96, 2280,   96,   96,   96, 2280,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   42,   96,
       96, 2280, 2280, 2280, 2280,   96, 2280,   96, 2280,   96,
       96,  169,  169,  169, 2280,  169,  169,  169,  169,  169,
      169,  169,  169,  169,  169,  169,  169,   96,  169,   96,
       96,   96,  169,   96,   96,   96,   96,   96,   96,   96,
      169,  169,  169,  169,  169,  169,  169, 2280,  169,  169,
      169,   96,   96,   96,   96, 2285,   96,   96,   96,   96,
     2280,  169,   96,   96,   96,   96,   96,   96,   96,   96,

     2280, 2280,   96,   96,   96, 2285,   96,   96, 2280, 2285,
       96,   96,   96,   96,   96,   96, 2280, 2280,   96,   96,
       96,   96,   96, 2280,   96,   96, 2280,   96,   96,   96,
       96, 2280, 2280,   96,   96,   96,   96,   96,  169,  169,
      169,  169,  169,  169,  169,  169,  169,  169,  169,  169,
     2280,  169,  169,  169, 2280,   96,  169,  169,  169,  169,
      169,   96,  169, 2280,  169,  169,  169, 2280, 2280, 2280,
      169,  169,  169, 2280,   96,   96,   96,   96,   96,   96,
     2280,   96,   96,   96,   96,   96,   96,   96,   96,   96,
     2280, 2280, 2280,   96, 2280,   96, 2280,   96,   96,   96,

     2280,   96, 2280,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,  169,
      169,  169,  169,  169,   96,   96,   96,   96,   96, 2280,
       96, 2280,   96,   96,   96,   96, 2280,   96,   96, 2285,
       96,   96,   96,   96, 2280, 2280,   96,  169,  169,  169,
       96,   96,   96, 2280, 2280,   96,   96,   96,   96,   96,
     2280, 2280, 2280, 2285, 2280,   96, 2280,   96,   96, 2280,
     2280,   96, 2280,   96,   96,   96, 2280,   96, 2280, 2280,
     2280, 2280, 2280, 2280,  169,  169,   96, 2280, 2280,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,

       96,   96,   96,   96,   96,   96, 2280,   96,   96,  169,
     2280, 2280, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286,  169,  169,  169,  169,  169,  169,  169, 2280,
       96, 2280, 2280, 2280,   96, 2280,  474, 2280, 2280, 2280,
     2280, 2280, 2280,   96,   96,   96, 2280,   96,   96,   96,
     2280,   96,   96,   96,   96,   96,   96, 2280,   96, 2280,
     2280, 2280,   96, 2280, 2280, 2280, 2280,   96, 2280, 2280,
       96,   96, 2280,   96,   96,  169,  169,   96,   96,   96,
       96,   96, 2280,   96,   96,   96,   96,  169,   96,   96,
       96,   96,   96,   96,   96,   96, 2280, 2280, 2280, 2280,

     2280, 2280, 2280,   96, 2280,   96,  169,  169,  169, 2280,
     2280,  169,  169, 2285, 2285,  169, 2280, 2280,  169,  169,
     2280,  169,  169, 2280, 2280, 2280,  169,  169,  169, 2280,
     2280, 2280, 2285, 2280, 2280, 2280, 2280,  169,  169,  169,
     2280,  169, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
      169,  169,  169, 2280, 2280,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96, 2280,
       96,   96,   96, 2280, 2280, 2280, 2280, 2287, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2280,   96,
      169,  169,  169, 2280,  169,  169, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280,  169,  169, 2280, 2280, 2280,
     2280, 2280, 2280,  169,  169, 2280, 2280,  169,  169,  169,
      169, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96,
     2280, 2280,   96,   96,   96,   96,   96, 2280,   96,  169,
      169, 2280, 2280,  169,  169,  169,  169,  169, 2280,  169,
      169,   96,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280,   96, 2280,   96,   96, 2280, 2280, 2280, 2285,
     2285,   96, 2280, 2280,   96,   96, 2280, 2280, 2280, 2280,
     2280, 2280,   96,  169, 2280, 2280, 2280, 2280, 2280, 2280,

     2280,  169,  169, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280,  169,  169, 2280, 2280, 2280,  169,  169,  169,
      169,  169, 2280, 2280,  169, 2280,  169,  169, 2280, 2285,
     2280, 2280, 2280, 2280, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2280, 2285, 2285,  169,   96,   96, 2280,
       96,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96,   96,
       96, 2280, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280,   96,  169,  169, 2280,  169,  169, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280,  169,  169, 2280, 2280,  169, 2280,  169,  169, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,  169, 2280,
      169, 2280, 2280, 2280, 2280, 2285, 2285,  169, 2280, 2280,
     2280,  169, 2280, 2280, 2280, 2280, 2280, 2280, 2285,  169,
     2280, 2280, 2280, 2280, 2280, 2280,  169, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280,  169, 2280, 2280, 2280,
     2280, 2280, 2280,  169, 2280, 2280, 2280,  169, 2280,  169,
      169, 2280, 2280, 2280, 2286, 2286, 2286, 2286, 2286, 2286,

     2286, 2286, 2286, 2280,  169,  169,  169, 2280,   96,   96,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96,   96,
       96, 2280,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96,

     2280, 2280, 2280, 2280, 2280, 2285, 2285,   96, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2280,
     2280, 2280, 2280,   96, 2280, 2280, 2280, 2286, 2286, 2286,
     2286, 2286, 2280, 2286, 2286, 2286, 2280,   96,   96, 2280,
       96,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,   96, 2280,
       96, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2288, 2289, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2285, 2285,   96, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2290, 2291, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
       96, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2286, 2286,
     2280, 2286, 2286, 2280, 2286, 2286, 2280,   96,   96, 2280,

     2280, 2280, 2280, 2280, 2280, 2280,   96, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2288, 2280, 2289, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2285, 2285, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2290, 2280, 2291, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280,   96, 2286, 2286, 2280, 2286, 2286, 2280, 2286,
     2286, 2280,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2285, 2285,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2286, 2286,
     2280, 2280, 2286, 2280, 2286, 2286,   96, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2285, 2285, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2286, 2280, 2280, 2286, 2280, 2286,
     2286,   96, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2285, 2285, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2286, 2280, 2280, 2280, 2280, 2280, 2286, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2285, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2286, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2285, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2285, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2285, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2285, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2285, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2285, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,    0,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280

    } ;

static yyconst flex_uint16_t yy_nxt[10602] =
    {   0,
        6,    7,    8,    7,    9,   10,   11,   12,   13,   14,
       15,   16,   17,   18,   19,   20,   20,   20,   20,   21,
       22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
       32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
       42,   43,   37,   44,   45,   46,   47,   48,   49,   50,
       51,   37,   52,   53,    6,   54,   28,   29,   30,   31,
       32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
       42,   43,   37,   44,   45,   46,   47,   48,   49,   50,
       51,   37,   55,   56,    6,   57,   59,   59,   61,   61,
       61,   61,   61,   61,   62,   62,   62,   68,   68,   68,

       70,   70,   70,   72,   72,   72,   72,   73, 1852,   74,
       74,   74,   74,  185,   85,   63,   76,   76,   76, 1853,
       79,   79,   79,   81,   81,   81,  173, 2153,  193,  174,
      175,   61,   61,   61,  333,  334,   86,   77,   78, 2023,
       69,   80, 1854,  185,   82,  335,   86, 1855,   70,   70,
       70,   72,   72,   72,   72, 1930,  173,  186,  193,  174,
      175,  179,  179,  179,  333,  334,   86, 1793,   60,   60,
       69,   85,   85,   85,   85,  335,   86,   72,   72,   72,
       72,  410,   86,   86,   87,   88,   86,   89,   86,   86,
       86,   86,   86,   90,   86,   91,   86,   92,   86,   86,

       93,   86,   94,   95,   86,   86,   86,   86, 1496, 1616,
       85,  410,   86,   86,   87,   88,   86,   89,   86,   86,
       86,   86,   86,   90,   86,   91,   86,   92,   86,   86,
       93,   86,   94,   95,   86,   86,   86,   86,   86,   86,
       96,   86,   86,  180,   97,  491,   86,   86,  492,   86,
       98,   86,   86, 1496,   86,  122,   86,   86,  493,  123,
       99, 1466,   86,   86,  339,  339,  339,   86,   86,   86,
       96,   86,   86,  124,   97,  491,   86,   86,  492,   86,
       98,   86,   86,   86,   86,  122,   86,   86,  493,  123,
       99,  100,   86,   86, 1590,   86,  540,   86,  101,   86,

      554,  555,   86,  124,  497,  102,  562,   86,  103,   86,
      564,  104,  563,   86,   86,   86, 2013, 1466,   68,   68,
       68,  100,   62,   62,   62,   86,  540, 2014,  101,   86,
      554,  555,   86, 1496,  497,  102,  562,   86,  103,   86,
      564,  104,  563,  181,   86,   86,  105,  106,  172,  588,
      107,   86,  125, 1496,  108,  589,   86,  126,   86,  127,
      109,   69,   86,  110,  128,  179,  179,  179,  632,   86,
       86,  319,  319,  319, 1466, 1466,  105,  106,  172,  588,
      107,   86,  125,  474,  108,  589,   86,  126,   86,  127,
      109,   69,   86,  110,  128,   76,   76,   76,  632,   86,

       86,   86,  424,  424,  424,   86,  633,   86,  111,  112,
      113,   86,   86,  634,   86,  114,  189,  190,  660,   86,
      115,   86,   73,  129,   74,   74,   74,   74,  345,  345,
      345,   86,  577, 1433,  503,   86,  633,   86,  111,  112,
      113,   86,   86,  634,   86,  114, 1432,  180,  660,   86,
      115,   86,  116,  129, 1373,  130,   86,  661,  117,  131,
      118,  662,  577,  119, 1296,  132,  120,  151,  664,  121,
      134,   86,  133,  135,   86,   86,   86,  152,  136,  666,
       86,  705,  116,  153,  137,  130,   86,  661,  117,  131,
      118,  662, 1145,  119,   86,  132,  120,  151,  664,  121,

      134,   86,  133,  135,   86,   86,   86,  152,  136,  666,
       86,  705,  714,  153,  137,  717,   86,  188,  718,  147,
       79,   79,   79,  148,   86,  138,  183,  139,   86,  184,
      724,   86,  149,  725,  731,  150,  332,  140,   81,   81,
       81,   80,  714,  141,  142,  717,   86,   86,  718,  147,
      417,  417,  417,  148,  732,  138,  570,  139,   86,  191,
      724,   86,  149,  725,  731,  150,  162,  140,  733,  163,
      164,   86,  192,  141,  142,   86,  165,   86,  143,  166,
       86,   86,  168,   86,  732,   86,  167,  169,   86,  170,
      144,  176,  171,  743,  145,   86,  162,  146,  733,  163,

      164,   86,  378,  378,  378,   86,  165,  745,  143,  166,
       86,   86,  168,   86,  188,   86,  167,  169,   86,  170,
      144,  176,  171,  743,  145,   86,  184,  146,  154,  177,
      532,  155,  156,   86,  748,  749,  157,  745,  158,   86,
      159,   86,   86,  160,  161,  195,  183,   86,  182,   86,
       86,   86,  896,  896,  896,  178,   86,   86,  154,  177,
      532,  155,  156,   86,  748,  749,  157,   86,  158,   86,
      159,   86,   86,  160,  161,  195,  194,   86,   86,   86,
       86,   86,   86,  418,  418,  418,   86,   86,   86,  571,
     1857,   86,  750,   86,   86, 1858,  324,   86,   86,   86,

      325, 1859,   86,   86,  754,   86,  194,  197,   86,   86,
      196, 2018,   86,  755,   86,  198, 2019,   86,   86,  770,
      199,   86,  750,   86,   86,   86,  324,  797,   86,   86,
      325,   86,   86,   86,  754,   86,   84,  197,   83,   86,
      196,  200,  798,  755,   86,  198,   86,   86,   75,  770,
      199,   86,  202,  201,  800,   86,   86,  797,   86,   86,
       71,   86,   67,   86,   86,   86,   86,  801,   86,   86,
      203,  200,  798,  464,  464,  464,   86,  802,  204,  630,
      205,   86,  202,  201,  800,   86,   86,   86,   86,   86,
       86,  209,   86,   86,   86,   86,   86,  801,   86,   86,

      203,  746,   65,  747,   86,  206,  207,  802,  204, 2083,
      205,   86,  803,   86, 2084,   86, 2015,   86,   86,  208,
       86,  209,   86,   86,   86,   86,   86, 2016, 2280,  804,
      805,  746,  210,  747,   86,  206,  207,   86,  816,  211,
     2280,   86,  803,   86,   86,   86,  213,  828,   86,  208,
      214,   86,   86,   86,   86,   86,   86,  212,   86,  804,
      805, 2111,  210, 2280, 2280,   86, 2112,   86,  816,  211,
      255,  255,  255,   86,   86,   86,  213,  828, 2280, 1973,
      214,   86,   86, 1974,  215,  216, 2280,  212,   86,   86,
       86,   86,  217,   86,   86,   86,  218,   86,   86,  401,

     2182, 2260,  219,   86,   86, 2183, 2261,  220,  337,  337,
      337,   86,  221,  402,  215,  216,  260,  260,  260,   86,
       86,   86,  217,   86,   86,  222,  218,   86,   86,  401,
       86,   86,  219, 2280,   86,  495,  223,  220, 2280,  224,
       86,   86,  221,  402,   86,  225, 2280, 2280,   86,   86,
      829,  830,  226,   86,  409,  222, 2280,  231,  227,  832,
       86,   86,   86,   86,   86,  495,  223,  834,  229,  224,
       86,   86,   86, 2280,   86,  225,  228,   86,   86,   86,
      829,  830,  226,   86,  409,   86,  230,  231,  227,  832,
       86,   86,   86,   86,   86,  233, 2280,  834,  229,   86,

       86,   86,   86,  232,   86, 2280,  228,   86,  234,  839,
       86,   86,  865,   86,  235,   86,  230,   86,   86, 2280,
       86,   86, 2280, 2280,   86,  233,  481,  481,  481,   86,
       86,   86, 2280,  232,   86,  501,  501,  501,  234,  839,
       86,   86,  865,   86,  235, 2280, 2280,   86,   86,  236,
      866,  237,   86,   86,   86,  238,   86,   86,   86,   86,
      670,   86,  240,  867,  241, 2280,  239,  868, 2280,  651,
       86, 2280,   86, 2113,  281,  281,  281, 2280, 2280,  236,
      866,  237,   86,   86, 2114,  238,   86,   86,   86,   86,
      670,  242,  240,  867,  241,   86,  239,  868,  243,  651,

       86,  432,   86,  433,  244,   86,   86,   86,   86,   86,
      247,  869,  870,   86,  245,  872,   86,   86,   86,   86,
      246,  242,   86, 2280,  248,   86, 2280, 2280,  243,  871,
       86,  432,  251,  433,  244,   86,   86,   86,   86,   86,
      247,  869,  870,   86,  245,  872,   86,   86,   86,   86,
      246,  874,   86,  249,  248,  877,   86,   86,   86,  871,
       86,   86,  251, 2280, 2280,   86,   86,  250,  260,  260,
      260,   86,  252,  253,  878,   86,   86, 2280,  254,   86,
      880,  874, 2280,  249, 2280,  877,   86,   86,   86,   86,
     2280,   86, 2280,   86,   86,   86,   86,  250,   86,   86,

     2162,   86,  252,  253,  878,   86,   86,   86,  254,   86,
      880, 2163,   86,  262,   86, 2280,  261, 2280, 2280,   86,
      255,  255,  255,   86,   86,   86,   86,   86,   86,   86,
      263,  881,  264, 2280, 2280,  266, 2280,   86,  883,   86,
       86,   86,   86,  262,   86,   86,   86,  274,  256,  265,
       86,   86,   86,   86,   86,   86,   86,   86,  257,   86,
      263,  881,  264,  258,  259,  266,   86,  884,  883,   86,
       86,   86,   86,   86,  889,   86,   86,  274,  256,  265,
       86,   86,   86,   86,   86, 2280,  267, 2280,  257,   86,
      268,   86,   86,  258,  259, 2280,   86,  884,   86,   86,

      890, 2280,   86,   86,  889,   86,  270,  776,  776,  776,
      269, 2280,   86,   86,   86,  271,  267,   86,   86,  777,
      268,   86,   86,   86,   86,  272,  895,  276,   86,   86,
      890,  273,   86,   86, 2280,   86,  270,   86,  277,  278,
      269,  275,   86,   86,   86,  271,   86,   86,   86,  281,
      281,  281,  897,   86,   86,  272,  895,  276,  898,  279,
     2280,  273,   86,   86,   86,   86, 2280,   86,  277,  278,
     2280,  275, 2280,   86,   86,  899,   86,  280,   86,   86,
       86,  282,  897,   86,   86,   86,   86,   86,  898,  279,
      669,  669,  669,   86,   86,   86,  838,   86,  900,  283,

      683,  683,  683,   86,   86,  899,  852,  280,   86,   86,
       86,  282, 2280,   86,   86,   86,   86,   86,   86,   86,
     2222,  285,  901,   86,   86,   86,  904,   86,  900,  283,
      284, 2223,   86,   86,   86,  287,  286,  906,   86,   86,
       86,  561,  561,  561,   86,   86,  907,   86,   86,   86,
      296,  285,  901,   86,   86,   86,  904,  908,   86, 2280,
      284,  297,   86,   86,   86,  287,  286,  906,   86,   86,
       86,  451,  451,  451,   86,   86,  907,   86, 2280, 2280,
      296,  909, 2280,   86,  288,  730,  289,  908,   86,  290,
       86,  297,   86,   86, 2280,  910, 2280,  291,  607,  292,

      298,  911,  293,  294,  912,  295,   86,   86,   86,  299,
      303,  909,   86,   86,  288,  730,  289, 2280,  300,  290,
       86,  304,   86,   86,  301,  910,  302,  291,  607,  292,
      298,  911,  293,  294,  912,  295,   86,   86,   86,  299,
      303,  306,   86,   86,   86,  305,   86,   86,  300,   86,
       86,  304,   86,   86,  301,  308,  302,  916,   86,  307,
       86,  917,  309,   86,  929, 2280,   86,   86,   86, 2280,
     2280,  306, 2280, 2280,   86,  305,   86,   86, 2280,   86,
       86,   86,   86,   86, 2280,  308,  953,  916,   86,  307,
       86,  917,  309,   86,  929,  310,   86,   86,   86,   86,

       86,   86,   86,  313,   86,   86,  311,   86,   86,  955,
     2280,   86,  956,   86,  314,   86,  953,  957,   86,  312,
     2280,   86,  315,  315,  315,  310,   86,   86, 2280,   86,
       86,   86,   86,  313,   86,   86,  311,   86,   86,  955,
       86,  317,  956,   86,  314,   86, 2280,  957,   86,  312,
      316,   86,   86,   86,   86,   86,   86,   86,  319,  319,
      319,  573,  573,  573,  318,  958,   86,  959,   86,  320,
       86,  317, 2280,   86,   86,  323,  321,   86,   86,  322,
      316, 2280,   86,   86,   86,   86,  741,   86,   86,   86,
     2280,   86,  960, 2280,  318,  958,   86,  959,   86,  320,

     2280, 2280,   86,   86,   86,  323,  321,   86,   86,  322,
     2280,   86,   86,   86,   86,   86,  741,   86,   86,   86,
       86,   86,  960,  326,   86,  330,  961,  328,   86,  327,
       86,   86,   86,  329,   86, 2280,  963,   86,  964,  967,
       86,   86,   86,   86,   86,   86,  331,  336,   86,   86,
       86,   86,   86,  326,   86,  330,  961,  328,   86,  327,
       86,   86,   86,  329,   86,   86,  963,   86,  964,  967,
       86,  337,  337,  337,  968,  976,  331,  336,   86,   86,
     2280,   86,   86,  339,  339,  339,   86,   86,  338,   86,
       86, 2280,   86,  983, 2280,   86,  984, 2280,   86,   86,

       86,   86,   86,   86,  968,  976,  340,   86,   86,  341,
       86,   86,   86,   86,   86,   86,   86,   86,  338,   86,
       86,   86, 2280,  983,   86, 2280,  984,   86,   86,   86,
       86,   86,   86,   86, 2280, 2280,  340,   86,   86,  341,
       86,   86,   86,   86,   86,   86,   86,  987,   86,   86,
       86,   86,   86,  342,   86,   86,   86,   86,   86,   86,
     2280,  343,   86,   86,  345,  345,  345, 2280,  344,  579,
      579,  579, 2280, 2280,   86, 2280,   86,  987,   86,   86,
       86,   86,   86,  342,   86,   86,   86,  346,   86,   86,
       86,  343,   86,   86, 2280,   86,  989,   86,  344,   86,

       86, 2280,  347,   86,   86,   86,  349, 2280,   86,   86,
       86,   86,  744,   86,   86,   86,  350,  346,  351, 2280,
       86,   86, 2280,  990,  348,   86,  989,   86,  365,   86,
       86,   86,  347,   86,   86,   86,  349,  352,   86,   86,
       86,   86,  744,   86,   86,   86,  350, 2280,  351,   86,
       86,   86,  353,  990,  348,  992,   86,   86,  365,   86,
       86,   86,   86,  355,   86, 2280,  354,  352, 2280,   86,
     2280,   86,   86, 2280,   86,  636,  636,  636, 2280,   86,
       86, 2280,  353, 2280,   86,  992,   86,   86,  993,   86,
       86,   86,   86,  355,   86,  356,  354,   86,   86,   86,

      799,  361,   86,   86,   86,  357,   86,   86,   86,   86,
      358,  359,   86,   86,   86,  362,  360,   86,  993, 2280,
       86,   86,   86, 2280,   86,  356,   86,   86,   86, 2280,
      799,  361, 2280,   86,   86,  357,   86,   86,   86,   86,
      358,  359,   86,   86,  994,  362,  360,   86,  995,  363,
       86,  996,   86,  364,   86,   86,   86,   86,  366,   86,
      367,  384,   86,   86,  368,   86,   86,   86,   86,   86,
       86,  369,   86, 2280,  994,  370,   86,   86,  995,  363,
       86,  996,  998,  364,   86,   86, 2280,   86,  366,   86,
      367,  384,   86,   86,  368,   86,   86,   86,   86,   86,

       86,  369,   86,   86,   86,  370,   86,   86,   86,   86,
       86,  374,  998,  371,  931,  931,  931,  372,   86,   86,
      932,   86,   86,  373, 2280,   86,   86, 2280,  376,  380,
       86, 2280,   86,   86,   86,   86, 1002,   86,   86,   86,
       86,  374, 2280,  371,  375, 1031, 2280,  372,   86,   86,
     1032,   86,   86,  373,   86,   86,   86,  377,  376,  380,
       86,   86,   86, 1033,   86,   86, 1002,   86,  379,   86,
       86,  378,  378,  378,  375, 1031,   86, 2280, 1034,   86,
     1032, 2280,   86,  381,   86, 2280, 2280,  377, 2280,   86,
     1035,   86,   86, 1033,   86, 2280, 2280,   86,  379,   86,

     2280,   86,   86, 2280,   86, 1036,   86,   86, 1034,   86,
       86,   86,   86,  381,  382,  383,   86,   86,   86,   86,
     1035, 1037,   86,  385,   86,   86,   86,   86,  387, 2280,
       86,   86,   86,   86,   86, 1036,  388,   86, 2280,  386,
       86,   86,   86, 1038,  382,  383,   86,   86,   86,   86,
     2280, 1037,   86,  385,   86,   86,   86, 2280,  387,  389,
       86, 1040, 2280,   86,   86,  393,  388,  390,   86, 2280,
       86,   86,   86, 1038,   86,   86, 2280,   86,   86,   86,
       86,  394,   86,  391,  391,  391,  954,  954,  954,  389,
     2280, 1040,   86, 2280,   86,  393,   86,  390,   86,  397,

       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,  394,  392,   86,   86,  396,   86, 1043, 1044,   86,
       86,   86,   86,   86,   86,  395,   86,   86, 1046,  397,
      398, 2280,   86,   86,   86, 2280,   86,   86, 2280,   86,
      399, 2280,  392,   86,   86,  396,   86, 1043, 1044,   86,
       86,   86,   86,   86,   86,  395, 2280,   86, 1046,   86,
      398,  400,   86, 1047,   86,   86,   86,   86,  403,  404,
      399,   86,   86,   86,  405,   86,   86, 1049,   86, 2280,
     1050,   86,   86,  789,  789,  789,   86,   86, 2280,   86,
     2280,  400,   86, 1047,  944,   86,   86,  406,  403,  404,

      411,   86,   86,   86,  405,   86,   86, 1049,   86,  407,
     1050,   86, 2280,   86, 2280, 1053,   86,   86,   86,  408,
      412,   86,   86, 2280,   86,  413,  965, 1055,   86,   86,
      411,   86,  966,  414,   86,   86, 2280,   86, 2280,  407,
      417,  417,  417,   86,   86, 1053, 2280,   86,   86,  408,
      412,   86,   86,  415,   86,  413,  965, 1055,   86,   86,
     2280,   86,  966,  414,   86,   86,   86,   86,   86,  416,
     1056, 2280,   86,   86,   86,   86,   86,   86,   86,   86,
     2280, 1057,   86,  415,  418,  418,  418, 2280,  424,  424,
      424, 1104, 1104, 1104,   86, 2280,   86,  420,   86,  416,

     1056,  421,   86,   86,   86,   86,   86, 2280,   86,   86,
       86, 1057,   86,  422,   86,   86,  425,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,  420,  423,  419,
       86,  421,   86,  428,   86,   86,  427,  427,  427,  426,
       86, 2280, 2280,  422,   86,   86,  425,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,  429,  423,  419,
       86,   86,   86,  428,   86,   86,   86,   86,   86,  426,
      985,  431,   86, 1061, 2280,   86,  986, 2280,   86,   86,
       86, 2280,   86,   86,   86, 1063,  434,  429,  430, 1064,
       86,   86, 2280,   86,   86, 2280,   86,   86,   86, 2280,

      985,  431,   86, 1061,   86,   86,  986,  435,   86,   86,
       86,   86,   86,   86,   86, 1063,  434, 2280,  430, 1064,
       86,   86,  436,   86,   86,   86,   86,   86,   86,   86,
     1065,   86, 1066,  438,   86,   86,   86,  435,  437,  439,
       86,   86,   86,   86,   86,  440,  442, 1009, 1009, 1009,
       86,   86,  436,   86,   86,   86,   86,   86,   86,   86,
     1065,   86, 1066,  438,   86,   86,   86, 1068,  437,  439,
       86,   86,   86,   86,   86,  440,  442,  441,  443,   86,
       86, 2280, 2280,   86, 1010,   86,   86, 2280, 2280,   86,
     2280, 2280,   86,   86,   86,   86, 1070, 1068,  444, 2280,

       86,   86, 1071,   86,   86, 1072,  445,  441,  443,   86,
       86,   86,  446, 1073, 1010,   86,   86,   86,   86,   86,
       86,   86,   86,   86,  448,   86, 1070,   86,  444,  447,
       86, 2280, 1071,   86,   86, 1072,  445,  449, 1074,   86,
       86,   86,  446, 1073, 1075,   86,  450,   86,   86,   86,
       86,   86,   86, 2280,  448,   86, 2280,   86,  452,  447,
      451,  451,  451, 2280,   86, 1076, 2280,  449, 1074,   86,
       86,   86, 1079,  453, 1075,   86,  450,   86,  454,   86,
       86,   86,   86,  456,   86,   86,   86, 1080,  452,  455,
      455,  455, 2280,   86, 1092, 1076,   86,   86, 2280,  457,

       86,   86, 1079,  453,   86,   86, 2280,   86,  454, 1108,
       86,   86, 2280,  456,   86,   86,   86, 1080,   86, 2280,
     2280,   86,   86,   86, 1092,   86,   86,   86,   86,  457,
     2280,  459,   86,   86,   86,   86,  933,  933,  933, 1108,
      391,  391,  391, 1111,  934,   86,   86,  458,   86,   86,
       86,   86,   86,  460, 1113,   86,   86,   86,   86,   86,
       86,  459,   86,   86,   86,  462, 1114,  461,   86,  545,
      463,   86, 2280, 1111,   86,   86,   86,  458,   86,   86,
       86, 2280, 2280,  460, 1113,  546,   86,   86, 1115,   86,
       86,  464,  464,  464,   86,  462, 1114,  461,   86,  545,

      463,   86,   86,   86,   86,   86,   86,   86,   86, 1116,
      467,   86,   86, 1117,  466,  546,  465,   86, 1115, 2280,
       86,  315,  315,  315,   86,   86, 2280,   86,  774,  774,
      774, 2280,   86,   86, 2280, 1118,   86,   86, 2280, 1116,
      467,   86,   86, 1117,  466, 2280,  465,   86,  468,  775,
       86,  665,  665,  665,   86,   86,  471,   86, 2280,  469,
      485,   86,   86,   86,   86, 1118,  470,  472,   86,   86,
      473,   86,   86,   86,   86,   86, 1120,   86,  468,  833,
     2280, 2280,   86, 2280, 2280,   86,  471,   86,  475,  469,
      485,   86,   86,   86,   86, 2280,  470,  472,   86,   86,

      473,   86,   86,   86,   86,   86, 1120,   86, 2280,  833,
       86,   86,   86,   86,   86,   86, 2280,   86,  475,  476,
      480,  477,  479, 1121,  478,   86,   86,   86,  481,  481,
      481, 2280,   86,   86,   86,   86,  931,  931,  931,   86,
       86,   86,  932,   86,   86, 1122,   86,  484,  514,  476,
      480,  477,  479, 1121,  478,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,   86,  483,   86,
      482,  486,   86, 2280,   86, 1122,   86,  484,  514, 2280,
       86,   86,   86,  489,  673,  673,  673,   86,   86,   86,
       86,   86, 2280,   86,   86,   86,   86,   86,  483,  487,

      482,  486,   86,  488,   86,  490,   86,   86,   86,   86,
       86,   86,   86,  489,   86,   86, 1123,   86,  494, 2280,
       86,   86,   86,   86,   86,   86,  496, 2280,   86,  487,
     1124,  842,  498,  488,   86,  490,   86,   86,   86,   86,
     2280,   86,   86, 1125,   86,   86, 1123,   86,  494,  499,
       86,   86,   86, 2280,  500,   86,  496,   86,   86, 2280,
     1124,  842,  498, 2280,   86,  501,  501,  501,  774,  774,
      774,   86,   86, 1125, 2280,  502,   86,   86, 2280,  499,
       86,   86, 1126,   86,  500,   86,   86,   86, 2280,  775,
     2280,   86,   86,   86,  516, 1127,  506,   86,   86,   86,

       86,   86,   86,   86,   86,  502,   86,   86,  504,  505,
       86,   86, 1126,   86, 2280, 2280,   86, 2280,  567,  567,
      567,   86,   86,   86,  516, 1127,  506,   86,   86,   86,
       86,   86,   86,   86,   86,   86, 1130,   86,  504,  505,
     2280,   86,   86,   86,  508,   86,  509,  507,   86,   86,
       86,   86, 1131,   86,   86,  736,   86, 2280, 2280,   86,
       86,   86,  737, 1134,   86,   86, 1130,   86, 2280,  511,
       86,   86,   86,   86,  508,   86,  509,  507,   86,   86,
       86,   86, 1131,   86,   86,  736,   86,  510,   86,   86,
       86,   86,  737, 1134,   86,   86,   86,   86,   86,  511,

       86,   86,   86,  512,  513, 2280,   86, 2280,   86,  515,
     2280,   86,   86,   86,   86,   86,   86,  510,   86, 1135,
      518,   86,   86, 1136, 2280,   86,   86,  517,   86,  520,
      519,   86,   86,  512,  513,   86,   86,   86,   86,  515,
       86,   86,   86,   86,   86,   86,   86,   86,   86, 1135,
      518,   86,   86, 1136,  521, 1138, 2280,  517, 2280,  520,
      519,   86,   86,   86, 2280,   86, 1139,   86,   86,   86,
       86, 1140,   86,   86,   86,   86,  523,   86,   86,  524,
       86,   86,   86,  522,  521, 1138,   86, 2280,   86,  525,
       86,   86,   86,   86,   86, 2280, 1139,   86,   86,   86,

      526, 1140,   86,   86,   86,   86,  523,   86, 1141,  524,
       86,   86,   86,  522,  527,   86,   86,   86,   86,  525,
       86,   86,   86, 2280,   86,   86,  528,   86,   86, 2280,
      526,  529, 2280,  530,  530,  530, 2280,   86, 1141, 2280,
      794,  794,  794,   86,  527,   86, 1142,   86, 2280, 1146,
       86,   86,   86,   86, 2280,   86,  528, 2280,   86,   86,
       86,  529,  531, 1147,   86,   86,   86,   86,  950,   86,
       86,   86,   86,   86,   86,   86, 1142, 2280,  533, 1146,
       86, 2280, 2280,   86,  534,  537,  537,  537, 1148,   86,
       86, 1149,  531, 1147,   86,   86,   86,   86,  950,   86,

       86,   86,   86,   86,   86,   86,   86,   86,  533, 1150,
       86,   86,   86,   86,  534,   86,   86, 1151, 1148,  538,
      536, 1149,  535, 2280, 2280,   86,  776,  776,  776,   86,
      542,   86,  541,   86,   86,   86,   86,   86,  777, 1150,
       86,   86,   86,   86,   86,   86,   86, 1151,   86,  538,
      536, 2280,  535,   86,   86,   86,  539,   86,   86,   86,
      542,   86,  541,   86,   86,   86, 1128,  543,   86,   86,
      547,   86, 1129,   86,   86,   86,   86, 1152,   86, 2280,
       86,   86,  544,   86,   86, 2280,  539,   86,   86,  548,
       86,   86, 2280,   86,   86, 1153, 1128,  543,   86,   86,

      547,   86, 1129,   86,  549,   86,   86, 1152,   86,   86,
       86,   86,  544,   86,   86,   86,   86, 2280,  550,  548,
       86,   86,   86,  551,   86, 1153, 1154,   86, 1156,   86,
      859,  859,  859, 1157,  549,   86,   86, 1158,   86,   86,
      553,   86,   86,   86,   86,   86,   86,  552,  550,   86,
       86,   86,   86,  551, 2280,   86, 1154,   86, 1156,   86,
     1025,   86,   86, 1157,   86,   86,   86, 1158,  556, 2280,
      553,   86,   86,  557, 1162,   86, 2280,  552, 2280,   86,
       86,   86, 1165,   86,   86,   86,   86,   86,  559, 1166,
     1025,   86,   86,  595,   86,  558,   86,   86,  556,  560,

     1167,   86, 2280,  557, 1162,   86,  561,  561,  561,  565,
      565,  565, 1165,   86,   86, 1171,   86,   86,  559, 1166,
     2280,   86,   86,  595, 1172,  558,   86,   86, 2280,  560,
     1167,   86,   86,   86, 1177,   86,   86,   86, 1178,   86,
       86,  567,  567,  567,  568, 1171,  566,   86,   86, 1179,
       86,   86,   86,   86, 1172, 2280,  831,  831,  831,   86,
       86,   86,   86,   86, 1177,   86,   86,   86, 1178,   86,
       86,   86,   86,  572,  568, 2280,  566,   86,   86, 1179,
       86,  574,   86,   86,  991,   86,   86,   86,  569,   86,
       86,   86,  573,  573,  573,   86,  537,  537,  537, 2280,

       86,   86,   86,  572,  579,  579,  579,   86,   86, 2280,
     2280,  574,   86, 2280,  991,   86,   86,   86,  569,   86,
       86,   86,   86,   86,  710,   86,  575,   86,   86,  576,
       86,  578,   86,   86,   86,   86,   86,   86,   86,   86,
      711,   86,   86, 1143, 1143, 1143,   86,   86,   86,   86,
       86,   86,   86,   86,  710, 2280,  575,   86,   86,  576,
       86,  578,   86,   86,   86,   86,   86, 2280, 2280,   86,
      711,   86,   86,  888,  888,  888,   86,   86,   86,  427,
      427,  427, 2280,   86,   86,  726,  726,  726,  586, 2280,
       86,   86,   86, 1173,  604,  585, 1174,   86,  605, 2280,

     2280,   86, 1054,  587,   86,   86,   86,   86,  580,  879,
      879,  879,  581,   86,   86,  582,  583,  584,  586,  891,
       86,   86,   86, 1173,  604,  585, 1174,   86,  605,   86,
       86,   86, 1054,  587,   86,   86,   86,   86,  580,   86,
       86,  590,  581,   86, 2280,  582,  583,  584, 2280,  891,
       86,  591, 1045,   86,  915,  915,  915, 2280, 2280,   86,
       86,  592,   86,   86,   86,   86, 1180,   86, 1187,   86,
       86,  590, 2280,   86,   86, 1190,   86,   86,   86,  593,
      594,  591, 1045,   86, 1078,   86,   86,  596,  837,  837,
      837,  592,   86,   86,   86,   86, 1180,   86, 1187,   86,

     2280,  822,  822,  822,   86, 1190,   86,   86,   86,  593,
      594,   86,   86, 1191, 1078,   86,   86,  596,   86,   86,
     1192,   86,   86,  598,   86,   86,   86,  597,  982,   86,
      997,   86,   86,   86,   86,   86,   86,  601, 2280, 1193,
      599,   86,   86, 1191,  600,  924,  924,  924,   86,   86,
     1192,   86,   86,  598,   86,   86,   86,  597,  982, 2280,
      997,   86,   86,   86,   86,   86,   86,  601,   86, 1193,
      599, 2280,   86, 2280,  600,   86, 2280, 2280,   86,   86,
     2280,  603,   86,   86,  602,  606, 1194,   86, 1195, 1087,
       86, 2280, 2280,   86,   86,  610,   86,   86,   86,  608,

       86,  609,   86,   86, 1196,   86,   86,   86,   86,   86,
       86,  603,   86,   86,  602,  606, 1194,   86, 1195, 1087,
       86,   86,   86,   86,   86,  610,   86,   86, 1197,  608,
       86,  609, 1198,   86, 1196,  623,   86,   86, 2280, 2280,
       86,  455,  455,  455,  999,  999,  999,  611, 2280,  612,
     1155,   86,   86,  933,  933,  933, 2280, 2280, 1197, 2280,
     2280,  934, 1198, 1199, 1203,  623,  613,  614,  615,  616,
      617,  613,  613,  613,  618,  613,  613,  619,  613,  613,
      613,  620,  613,  613,  613,  613,  621,  622,  613,  613,
      613,  613, 2280, 1199, 1203, 2280,  613,  614,  615,  616,

      617,  613,  613,  613,  618,  613,  613,  619,  613,  613,
      613,  620,  613,  613,  613,  613,  621,  622,  613,  613,
      613,  613,  624,   86,   86,  848,  848,  848,   86,   86,
       86,   86,   86,   86,  626,   86,   86,   86,   86,   86,
      625,   86,  974,  974,  974, 2280,   86, 2280,  629,   86,
      628,   86,  624,   86,   86,  627, 2280, 2280,   86,   86,
       86,   86,   86,   86,  626,   86,   86,   86,   86,   86,
      625,   86, 1006,  636,  636,  636,   86,   86,  629,   86,
      628,   86,   86,   86,   86,  627, 1132,   86,   86,   86,
       86, 1204,   86,   86,   86,   86,  644,   86,   86,   86,

      631,   86, 1006, 1205,   86, 1206,   86,   86, 1207,   86,
       86,  635,   86,   86,   86, 1209, 1132,   86,   86,   86,
       86, 1204,   86,   86,   86,   86,  644,   86,   86,   86,
      631,   86, 2280, 1205,   86, 1206,   86, 2280, 1207,   86,
       86,  635,  637,  637,  637, 1209,   86,   86,   86,   86,
     2280,  896,  896,  896,  645, 1210, 1212,  647,  647,  647,
       86, 2280,   86,  646, 2280, 2280,   86,   86,  638,  639,
     2280, 2280,  640,  641, 1213,  642,   86,   86,   86,   86,
      650, 1215,  643, 2280,  645, 1210, 1212,   86,   86, 1062,
       86,  649,   86,  646,   86,   86,   86,   86,  638,  639,

      648,   86,  640,  641, 1213,  642,   86,   86,   86, 2280,
      650, 1215,  643,   86,  652, 1216, 2280,   86,   86, 1062,
       86,  649, 1218, 2280,   86,   86,  655,   86,   86,   86,
      648,   86,  653,   86,   86, 2280,   86,   86,   86,   86,
       86,  654,   86,   86,  652, 1216, 1175,   86, 2280, 2280,
       86, 1219, 1218,   86, 2280, 2280,  655,   86,   86,   86,
     2280, 2280,  653,   86,   86,  656,   86,   86, 1176,   86,
       86,  654,   86,  657,   86,   86, 1175,   86,   86,   86,
       86, 1219, 1220,   86,  658,  658,  658, 1221,   86,  665,
      665,  665,   86, 2280, 2280,  656,   86,   86, 1176,   86,

       86, 1222, 2280,  657,   86,   86, 2280, 2280,   86,   86,
       86, 2280, 1220,  663,   86,   86, 2280, 1221,   86,   86,
       86, 1223,   86,  659,  667,  667,  667, 1224,   86,   86,
       86, 1222,  668,   86,   86,   86,  669,  669,  669,  673,
      673,  673, 2280,  663,   86,   86,   86,  671,   86,   86,
       86, 1223, 1225,  659,   86,   86, 2280, 1224,   86, 2280,
       86, 2280,  668,   86,   86,   86,   86,   86,   86,   86,
       86,  672,   86,   86,   86,   86,   86,  671,   86, 1226,
       86, 1227, 1225,   86,   86,   86,   86, 1228,  675,  677,
       86,  674,   86,   86,   86,   86,   86,   86,   86,   86,

       86,  672,   86,   86,   86,   86,   86, 1229,   86, 1226,
       86, 1227, 2280,   86,   86,   86,   86, 1228,  675,  677,
     1230,  674,   86,   86,   86,   86,  676, 1232,   86,  678,
     2280, 2280,   86,   86,   86,   86,   86, 1229,   86,   86,
       86,  721,  721,  721,   86,   86,   86, 1233,   86, 2280,
     1230,  680, 1234,  679,   86,   86,  676, 1232,   86,  678,
       86,   86,   86,   86,   86,   86, 2280,  887,   86,   86,
       86, 2280,  681, 1239,   86, 2280,   86, 1233,   86,   86,
       86,  680, 1234,  679,   86,   86, 1240,  682, 1241, 2280,
       86,   86, 1242,   86,  683,  683,  683,  887,   86,  684,

       86,   86,  681, 1239,   86,   86,   86, 1245, 2280,   86,
       86, 1260, 2280,  685,   86,  686, 1240,  682, 1241,   86,
       86,   86, 1242,   86,   86,   86,  892,  892,  892,  684,
       86,   86,   86, 2280,   86,   86,   86, 1245,   86,  687,
     2280, 1260,   86,  685,   86,  686, 1214, 1214, 1214,   86,
       86,   86,  688,   86,   86,   86,  905,  905,  905, 1058,
       86, 2280,   86,   86,   86, 1263,   86,   86,   86,  687,
      690,   86,   86,   86,   86, 2280,  689,   86,  691, 2280,
     2280,   86,  688,   86,   86,  692,  693, 2280, 2280, 1058,
       86,   86,   86,   86, 1069, 1263,   86,   86,   86, 2280,

      690,   86, 1264,   86,   86,   86,  689,   86,  691,   86,
       86,   86, 2280, 2280,   86,  692,  693,  694,  695,   86,
       86,   86,   86,   86, 1069,  667,  667,  667,   86,  696,
       86,   86, 1264,   86, 1265,   86, 1093, 1093, 1093,   86,
       86,  706,   86,   86,   86, 2280, 2280,  694,  695,   86,
       86, 1266,  704,   86,   86,   86,   86, 1094,  835,  696,
       86,   86, 2280,   86, 1265, 1267,   86,   86,   86,  836,
     2280,  706,   86,   86,   86,  530,  530,  530, 2280,  707,
       86, 1266,  704, 2280,   86,   86,   86, 2280,  835, 1231,
     1231, 1231,   86,   86, 2280, 1267,   86,   86,   86,  836,

      697, 1268,  698,  699, 1269, 1271,  708,   86,  700,  707,
       86,   86,   86,  712,  720,   86,   86,   86,  701,  702,
     1272,  703,   86,   86,  709,   86,   86,   86, 2280,  713,
      697, 1268,  698,  699, 1269, 1271,  708,   86,  700, 2280,
       86,   86,   86,  712,  720,   86,   86,   86,  701,  702,
     1272,  703,   86,   86,  709,   86,   86,   86,  716,  713,
       86,   86, 1273,   86,   86, 1274,   86,   86,   86,   86,
       86,   86,  719, 1275,   86,  715,   86,   86, 1276,   86,
     1277,   86,   86,   86, 2280,   86,   86,  722,  716, 2280,
       86,   86, 1273,   86,   86, 1274,   86,   86,   86,   86,

       86,   86,  719, 1275,   86, 1278,   86,   86, 1276,   86,
     1277,   86,  721,  721,  721,   86,   86,  722, 2280,  723,
       86,   86,   86,   86, 1279,   86,   86,  726,  726,  726,
       86, 2280,   86,   86,   86, 1278,   86, 1280,   86,   86,
     1281,  975,  975,  975, 2280,   86,  727, 1282,   86,  723,
       86,   86,   86,   86, 1279,   86,   86,   86,   86,  728,
       86,   86,   86,   86,   86, 2280,   86, 1280,   86,   86,
     1281,   86,   86,   86,   86,   86,  727, 1282,   86,   86,
       86,  565,  565,  565, 1133, 2280,   86,   86,   86,  728,
       86,   86, 1283,   86, 1284,  729, 2280,   86,   86,  738,

     1285,   86,   86,   86,   86, 1286,  739,   86,   86,   86,
       86,   86,   86,   86, 1133,  734,   86,  740,   86,   86,
      735,   86, 1283,   86, 1284,  729,   86,   86,   86,  738,
     1285,  742,   86, 1287, 1289, 1286,  739,   86,   86,   86,
       86,   86,   86,   86, 2280,  734, 1290,  740,   86,   86,
      735,   86, 1291,   86,   86,   86,   86,   86,   86, 2280,
     2280,  742,   86, 1287, 1289,   86, 1292,   86,   86,   86,
       86,   86,  751,  752,   86,   86, 1290,   86,   86,   86,
       86,   86, 1291,   86,   86,   86, 2280,   86,   86,  923,
      923,  923,  753, 1297,   86,   86, 1292,   86,   86,   86,

       86,   86,  751,  752,   86,   86, 1298,   86,   86,   86,
       86,   86, 2280,   86,   86,   86, 1085,   86,   86, 1299,
       86,   86,  753, 1297,   86,  756,  757, 1300,   86,   86,
       86,   86,  758, 1086,   86,  759, 1298, 2280,   86,   86,
     1293, 1293, 1293,   86,   86,   86, 1085,   86,   86, 1299,
       86,   86,   86,   86,   86,  756,  757, 1300,   86, 2280,
     1301,   86,  758, 1086,   86,  759, 1302,  763,   86,   86,
      760,   86,   86,  761,   86,   86,  762,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86, 1303,   86,  773,
     1301,   86,  764, 1304,   86, 2280, 1302,  763, 1305, 2280,

      760,   86,   86,  761,   86,   86,  762,   86,   86,   86,
       86,   86,  765,   86,   86,   86,   86, 1303,   86,  773,
     2280,   86,  764, 1304,   86,   86,   86,   86, 1305,  768,
      767,   86,   86,  766,   86,   86, 2280,   86,   86,   86,
       86,   86,  765,   86,   86,   86,  769, 1306,   86, 1307,
      771,   86,   86,   86,   86,   86,   86,   86, 2280,  768,
      767,   86,   86,  766,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86, 2280,   86,  769, 1306,   86, 1307,
      771,   86,   86,   86,   86, 2280,  772,  864,  864,  864,
     2280, 2280,  776,  776,  776, 2280,   86, 2280,  776,  776,

      776, 2280,   86,   86,  777, 2280,  778,  778,  778,  778,
      777, 2280,  778,  778,  778,  778,  772,  776,  776,  776,
     1081, 1081, 1081,  776,  776,  776, 1235, 1030, 2280,  777,
     2280,  778,  778,  778,  778,  777, 2280,  778,  778,  778,
      778,   86,   86,  780, 1308,  778,  776,  776,  776, 2280,
     1310,  778,  782, 1314, 1315,  796,  781, 1030,  777, 2280,
      778,  778,  778,  778, 2280, 2280, 1093, 1093, 1093, 2280,
      778,   86,   86,  780, 1308, 2280,  778,  926,  926,  926,
     1310, 2280,  782, 1314, 1315,  796,  781, 1094,  776,  776,
      776, 1051, 1051, 1051,  783,  776,  776,  776, 2280,  778,

      777, 2280,  778,  778,  778,  778, 2280,  777, 2280,  778,
      778,  778,  778,  776,  776,  776, 1316, 1089,  954,  954,
      954,  776,  776,  776,  783,  777, 1211,  778,  778,  778,
      778,  784, 1317,  777,  785,  778,  778,  778,  778, 2280,
     2280,  778, 1144, 1144, 1144, 1112, 1316, 1089,  778, 1318,
       86, 1319,  786,  776,  776,  776, 1211,   86, 2280,  787,
       86,  784, 1317, 2280,  785,  777,  778,  778,  778,  778,
      778,  789,  789,  789,  778, 1112, 2280, 2280,  788, 1318,
       86, 1319,  786, 1320,   86, 1295,   86,   86,   86,  787,
       86,   86,  791,   86,   86,  792,   86,   86,   86, 1321,

      790, 1322,  793, 1323,   86, 2280,  778,   86,  788,  794,
      794,  794, 2280, 1320,   86, 1295,   86, 2280,   86, 2280,
     1324,   86,  791,   86,   86,  792,   86,   86,   86, 1321,
      790, 1322,  793, 1323,   86,   86, 2280,   86,  795,   86,
       86,   86,   86,  806,   86,   86,   86,   86,   86,   86,
     1324,  807,   86,   86,   86, 1325, 1326,   86,  813,  813,
      813,   86, 1083, 1083, 1083,   86,   86, 2280,  795,   86,
       86,   86,   86,  806,   86,   86,   86,   86,   86,   86,
     2280,  807,   86,   86,   86, 1325, 1326,   86,   86,   86,
     1327,   86,  815,   86,   86, 2280,   86,  647,  647,  647,

       86,   86,   86, 1328, 2280,  814, 1237,   86,  817,  817,
      817, 1329,   86,   86,   86, 1027, 1027, 1027,   86,   86,
     1327, 2280,  815,   86,   86,  808,   86, 1330,  821,  809,
       86,   86,   86, 1328,  810,  814, 1237,   86,   86,   86,
      811, 1329,   86,   86,   86, 1331,  812,   86,   86, 1082,
     1082, 1082,   86, 1189, 2280,  808,   86, 1330,  821,  809,
      818,   86, 1335, 2280,  810, 1336,  819, 2280,   86,   86,
      811,   86,   86, 1337,  820, 1331,  812,   86,   86,   86,
       86, 2280,   86, 1189, 1236,   86,  822,  822,  822, 2280,
      818,   86, 1335,   86, 2280, 1336,  819,  658,  658,  658,

     2280,   86,   86, 1337,  820, 2280,   86,   86, 2280,   86,
       86,  831,  831,  831, 1236,   86,   86,   86,   86,   86,
       86,  827, 1338,   86,  823, 2280,  843, 1339,  824, 1340,
       86, 1341,   86,  825, 1342,  826,   86,   86,  837,  837,
      837,   86,   86, 1104, 1104, 1104,   86,   86,   86,   86,
       86,  827, 1338, 1343,  823,   86,  843, 1339,  824, 1340,
       86, 1341,   86,  825, 1342,  826, 2280, 1344,   86,   86,
     2280,   86,   86,  840,   86,   86,  841,  841,  841,  844,
       86,   86,   86, 1343, 2280,   86,   86, 1257,   86, 1246,
     1246, 1246, 2280,  845,   86, 1247,   86, 1344,   86,   86,

       86,   86, 2280,  840,   86,   86,   86,   86, 1345,  844,
       86,   86,   86, 1346,  847,   86,   86, 1257,   86, 2280,
       86, 1347,   86,  845,   86,   86,   86,  846,   86,   86,
       86,   86,  848,  848,  848,  850,   86,   86, 1345, 1348,
       86,   86,  849, 1346,  847,   86, 2280,  817,  817,  817,
       86, 1347,   86, 1349,   86,   86, 2280,  846,   86,   86,
       86,   86,   86,   86, 2280,  850,  853,  853,  853, 1348,
       86,   86,  849,  977,   86,  851,   86, 2280, 2280, 1350,
     2280,   86,   86, 1349,   86,   86,   86,   86,   86,  978,
       86,   86,   86,   86,  856,  854,   86,   86,  855,   86,

     1351,   86, 2280,  977,   86,  851,   86,   86,   86, 1350,
       86,   86,   86,   86, 2280,   86,   86,   86,   86,  978,
       86,  858, 1352,  857,  856,  854,   86,   86,  855,   86,
     1351,   86,  859,  859,  859,   86,   86,   86,   86, 1353,
       86,   86,   86,   86,  862, 2280, 2280,   86,   86,  860,
       86,  858, 1352,  857, 1354,   86,   86,   86, 1357,   86,
       86,   86,   86,   86, 2280,   86,   86,  863, 2280, 1353,
       86,   86,   86,   86,  862,  861,   86,   86,   86,  860,
      864,  864,  864, 2280, 1354,   86,   86,   86, 1357,   86,
       86,   86,   86,   86, 1143, 1143, 1143,  863,   86,   86,

       86, 1358, 1359,   86, 1360,  861,   86,  873,   86,   86,
       86,   86,   86,   86, 1356, 1356, 1356, 1362, 2280, 1363,
      875, 2280,   86,   86,   86, 2280,   86, 2280,   86,   86,
     1294, 1358, 1359,   86, 1360, 1368,   86,  873,   86,   86,
       86,   86,   86,   86,  879,  879,  879, 1362,   86, 1363,
      875,  876,   86,   86,   86,   86,   86,   86,   86, 2280,
     1294,   86,  882,   86,   86, 1368,   86,   86,   86, 1369,
       86,   86,   86, 1370, 1370, 1370,   86,   86,   86,   86,
       86,  876,   86,   86,  885,   86,   86,   86,   86,  886,
     2280,   86,  882, 1371,   86, 2280, 1372,   86,   86, 1369,

       86,   86,   86,  888,  888,  888,   86,   86,   86,   86,
       86, 2280,   86,   86,  885,   86,   86,   86,   86,  886,
      892,  892,  892, 1371,   86,   86, 1372,   86, 2280,   86,
     2280, 2280,   86,  893, 1374,   86,   86, 2280,   86,   86,
     2280,  894,   86, 2280, 2280,   86,   86,   86,   86,   86,
      902,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,  893, 1374,   86,   86,   86, 2280,   86,
       86,  894,   86,  905,  905,  905,   86,  903, 2280,   86,
      902,   86,   86,   86, 1375, 2280,   86, 2280,   86, 2280,
       86,   86, 2280, 2280,   86,  913, 1377,   86,   86,   86,

       86,   86,  914,   86,   86,   86,   86,  903,  947,   86,
       86, 2280, 1378,   86, 1375,  915,  915,  915, 1009, 1009,
     1009, 1231, 1231, 1231,   86,  913, 1377, 2280,   86,   86,
     2280,   86,  914,   86,   86,   86,   86, 2280,  947,   86,
       86,   86, 1378,   86,   86,   86,   86,   86,   86,   86,
       86,   86,  919,   86,   86, 1010,   86,   86,  918, 1379,
       86, 2280, 2280,   86, 1380,  920, 1376,   86,  921, 2280,
       86,   86, 2280, 2280,   86,   86,   86,   86,   86,   86,
       86,   86,  919,   86,   86, 1010,   86,   86,  918, 1379,
       86,   86,   86,   86, 1380,  920, 1376,   86,  921,  922,

       86,  923,  923,  923, 1382,   86,  924,  924,  924,  925,
       86,   86,   86,   86, 1383, 2280,  926,  926,  926, 1385,
     2280,   86,   86, 1388,   86, 2280,   86, 1397, 2280,  922,
     2280,   86,   86, 2280, 1382,   86,   86,   86, 2280,  925,
       86,   86,   86,   86, 1383,   86,   86,   86, 2280, 1385,
       86,   86,   86, 1388,   86,  927,   86, 1397,   86,   86,
       86,   86,   86, 1168, 1169,   86,   86,   86, 1384, 1384,
     1384, 1170,   86, 1400, 2280,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,  927,   86,   86,   86,   86,
       86,  930,   86, 1168, 1169,   86, 2280,   86,  928, 1401,

       86, 1170,   86, 1400,   86,   86, 2280, 2280,   86,   86,
     1440, 1440, 1440,   86,   86, 2280,   86,   86,   86, 1402,
     2280, 2280,   86, 1403,  776,  776,  776,   86,  928, 1401,
       86, 1246, 1246, 1246,   86,   86,  777, 1247,  778,  778,
      778,  778,  776,  776,  776,  945,  946, 2280,   86, 1402,
      776,  776,  776, 1403,  777, 2280,  778,  778,  778,  778,
       86,   86,  777, 1404,  778,  778,  778,  778,  776,  776,
      776, 1405,  935, 2280,   86,   86,   86,  778, 2280, 1406,
      777, 2280,  778,  778,  778,  778, 2280, 1408,  936,  988,
       86,   86, 2280, 1404,  937,  778,  776,  776,  776, 2280,

     2280, 1405,  935,  778,   86,   86,   86, 1409,  777, 1406,
      778,  778,  778,  778,  776,  776,  776, 1408,  936,  988,
     1410,  778, 1332, 1333,  937, 1411,  777, 2280,  778,  778,
      778,  778, 1334, 1334, 1334, 1334,  938, 1409, 1412, 2280,
     1413,   86,  776,  776,  776, 1451, 1451, 1451,   86,  778,
     1410,   86,  949,  939,  777, 1411,  778,  778,  778,  778,
      776,  776,  776, 1414, 1415, 2280,  938,  778, 1412,  940,
     1413,   86,  777, 2280,  778,  778,  778,  778,   86, 2280,
     2280,   86,  949,  939,   86,   86,   86, 1003, 2280, 2280,
      776,  776,  776, 1414, 1415,  778, 2280, 2280,   86,  940,

       86, 1416,  777,  941,  778,  778,  778,  778,  776,  776,
      776, 1417, 2280,  778,   86,   86,   86, 1003,  942,   86,
      777, 1418,  778,  778,  778,  778,   86,   86,   86,  951,
       86, 1416, 1419,  941,   86,   86, 1420,   86,  962,  948,
       86, 1417,   86,  778,  943,   86, 1421,   86,  942,   86,
       86, 1418,  952,   86, 2280, 2280,   86,   86, 2280,  951,
       86,  778, 1419,   86,   86,   86, 1420,   86,  962,  948,
       86,   86,   86, 1422,  943,   86, 1421,   86,   86, 2280,
       86,   86,  952,   86,  974,  974,  974, 1214, 1214, 1214,
       86, 1423, 2280,   86,  813,  813,  813,  975,  975,  975,

     2280,   86,   86, 1422, 1425, 2280, 1426, 2280,   86,   86,
       86,   86,   86, 1476, 1476, 1476, 2280,   86,  979, 1427,
       86, 1423,  969,   86, 1361, 1428,  970, 1430,   86, 2280,
       86,  971,   86,   86, 1425,   86, 1426,  972,   86,   86,
       86, 2280,   86,  973,  999,  999,  999,   86,  979, 1427,
       86,  980,  969,   86, 1361, 1428,  970, 1430,   86,   86,
       86,  971,  981,   86, 1431,   86,   86,  972,   86,   86,
      841,  841,  841,  973,   86,   86,   86,   86, 1004, 1434,
     2280,  980, 2280,   86,   86, 1005,   86,   86,   86,   86,
       86, 1435,  981, 2280, 1431, 2280,   86,   86, 1000,   86,

       86, 1288, 1288, 1288,   86,   86,   86,   86, 1004, 1434,
     1001,   86,   86,   86,   86, 1005,   86,   86,   86,   86,
       86, 1435, 1042, 1042, 1042,   86, 1007,   86, 1000,   86,
       86, 1021, 1021, 1021, 2280, 1436,   86, 2280, 1437, 1008,
     1001,   86,   86,   86, 1424, 1438,   86, 2280, 2280,   86,
     1439,   86, 1201,   86, 1022,   86, 1007,   86,   86,   86,
       86,   86, 1202,   86,   86, 1436,   86,   86, 1437, 1008,
     1441, 1442, 2280,   86, 1424, 1438,   86,  853,  853,  853,
     1439,   86, 1201,   86, 1022, 1443, 1444,   86,   86, 1445,
       86,   86, 1202,   86,   86, 1446,   86,   86, 2280, 1023,

     1441, 1442, 1011,   86, 1012, 1013,   86, 1014, 2280, 2280,
     1015, 2280, 1024, 1024, 1024, 1443, 1444, 1016, 2280, 1445,
     1017, 1018, 1019, 1020, 2280, 1446,   86,   86,   86, 1023,
       86,   86, 1011,   86, 1012, 1013,   86, 1014,   86,   86,
     1015, 1028, 1026, 1447, 1029,   86,   86, 1016,   86,   86,
     1017, 1018, 1019, 1020, 1027, 1027, 1027,   86,   86, 2280,
       86,   86, 1042, 1042, 1042, 1051, 1051, 1051,   86,   86,
     1448, 1028, 1026, 1447, 1029,   86,   86, 2280,   86,   86,
       86, 1039, 1449,   86,   86,   86,   86,   86,   86,   86,
       86, 2280,   86,   86, 1059,   86,   86,   86, 1450,   86,

     1448, 1041, 1048, 1480, 1480, 1480,   86,   86,   86,   86,
       86, 1039, 1449,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86, 1452,   86,   86,   86, 1450,   86,
     2280, 1041, 1048,   86,   86,   86,   86,   86,   86,   86,
     2280, 1052,   86,   86, 1453, 1060, 2280,   86,   86, 2280,
       86,   86, 1454,   86, 1452,   86, 2280, 1455,   86, 1067,
       86, 2280, 2280,   86,   86,   86, 2280,   86, 2280,   86,
       86, 1052,   86,   86, 1453, 1060,   86,   86,   86,   86,
       86, 2280, 1454,   86, 1456,   86,   86, 1455,   86, 1067,
       86,   86, 1084,   86, 1457, 1458,   86,   86,   86,   86,

       86,   86, 1077, 1081, 1081, 1081,   86, 2280, 2280,   86,
     2280, 1082, 1082, 1082, 1456, 2280,   86, 1083, 1083, 1083,
     2280,   86, 1084,   86, 1457, 1458,   86, 2280,   86,   86,
     1459,   86, 1077, 2280, 1460,   86,   86,   86, 1088,   86,
       86,   86,   86,   86,   86,   86, 1461,   86,   86, 2280,
       86, 1462, 1463,   86, 1106,   86, 2280, 1090,   86,   86,
     1459, 1293, 1293, 1293, 1460,   86,   86,   86, 1088,   86,
       86,   86,   86,   86,   86,   86, 1461,   86,   86,   86,
       86, 1462, 1463,   86, 1106,   86,   86, 1090,   86,   86,
      776,  776,  776, 2280, 1429, 1464,  776,  776,  776, 1470,

     1091, 1471,  777, 2280,  778,  778,  778,  778,  777,   86,
      778,  778,  778,  778, 1472, 1473,   86, 2280, 2280,   86,
     1095,  776,  776,  776, 1429, 1464, 1489, 1489, 1489, 1470,
     1091, 1471, 2280,  777, 1474,  778,  778,  778,  778, 1096,
      776,  776,  776,  778, 1472, 1473,  776,  776,  776,  778,
     1095, 1475,  777, 1477,  778,  778,  778,  778,  777, 1478,
      778,  778,  778,  778, 1474, 1479, 1097, 1364, 1365, 1096,
     1498, 1498, 1498, 1498,  778, 1366, 1098, 1367, 1367, 1367,
     1367, 1475, 1099, 1477, 2280, 2280,  776,  776,  776, 1478,
     1505, 1505, 1505,  778, 2280, 1479, 1097, 1481,  777,  778,

      778,  778,  778,  778, 2280, 1482, 1098, 1483,  776,  776,
      776, 1484, 1099, 2280,  776,  776,  776, 1556, 1556, 1556,
      777, 1100,  778,  778,  778,  778,  777, 1481,  778,  778,
      778,  778,  776,  776,  776, 1482, 2280, 1483, 1485,  778,
     2280, 1484, 1486, 1102,  777, 2280,  778,  778,  778,  778,
       86, 1100, 1101, 2280, 1243, 1243, 1243,   86, 2280, 1487,
       86,  778, 1490, 1105, 1107,   86,   86,  778, 1485,   86,
       86, 2280, 1486, 1102,   86,   86, 1491, 1103, 1109,   86,
       86, 1110, 1101,   86, 2280,  778, 2280,   86,   86, 1487,
       86, 2280, 1490, 1105, 1107,   86,   86, 2280, 2280,   86,

       86, 1386,   86,   86,   86,   86, 1491, 1103, 1109,   86,
     1492, 1110, 2280,   86, 1119, 2280,   86, 2280,   86, 2280,
       86,   86,   86,   86, 1493,   86,   86, 1144, 1144, 1144,
     1494, 1386,   86,   86,   86,   86,   86, 1137, 1504,   86,
     1492, 2280,   86, 2280, 1119, 1160,   86, 1159,   86,   86,
       86,   86,   86,   86, 1493,   86,   86,   86,   86, 2280,
     1494, 1509,   86, 1510,   86,   86,   86, 1137, 1504,   86,
     2280,   86,   86,   86,   86, 1160, 2280, 1159,   86,   86,
       86,   86, 2280,   86,   86, 2280, 1163,   86,   86, 1161,
     2280, 1509,   86, 1510, 1164, 1164, 1164, 2280, 1021, 1021,

     1021,   86,   86,   86,   86, 1511, 1183, 1512,   86,   86,
       86,   86,   86,   86,   86,   86, 1163, 1513,   86, 1161,
       86, 2280, 1514, 1024, 1024, 1024,   86,   86, 1181, 1515,
       86, 2280,   86,   86, 1516, 1511,   86, 1512,   86,   86,
     1182, 2280,   86, 1517,   86,   86, 2280, 1513,   86, 2280,
       86,   86, 1514, 2280,   86,   86,   86,   86, 1181, 1515,
       86, 1184,   86,   86, 1516,   86,   86, 1185, 1186,   86,
     1182, 1188, 1518, 1517,   86, 2280,   86, 1521, 1522,   86,
       86,   86, 2280, 1200,   86,   86,   86,   86, 2280, 1529,
       86, 1184,   86,   86, 1217,   86,   86, 1185, 1186,   86,

     1532, 1188, 1518, 2280, 2280,   86,   86, 1521, 1522,   86,
       86, 2280,   86, 1200,   86,   86,   86,   86, 1208, 1529,
       86,   86,   86,   86,   86, 1534,   86,   86, 1535,   86,
     1532,   86,   86,   86,   86,   86, 1238,   86,   86, 1536,
       86,   86,   86,   86,   86,   86, 2280, 1537, 1208, 2280,
     1538,   86,   86, 2280,   86, 1534, 2280,   86, 1535,   86,
     2280,   86,   86,   86,   86, 2280, 1238,   86,   86, 1536,
       86,   86, 1539,   86, 1243, 1243, 1243, 1537, 1244,   86,
     1538, 2280,  776,  776,  776,   86,   86, 1540, 1541,   86,
       86, 1261,   86, 1542,  777,   86,  778,  778,  778,  778,

       86, 2280, 1539, 2280,   86, 2280, 1543,   86, 1244,   86,
       86, 1248,  776,  776,  776,   86,   86, 1540, 1541,   86,
       86, 1261,   86, 1542,  777,   86,  778,  778,  778,  778,
       86,  776,  776,  776,   86,  778, 1543,   86, 2280, 2280,
       86, 1248, 2280,  777, 2280,  778,  778,  778,  778, 1557,
     1557, 1557,  776,  776,  776, 1544, 1249, 2280,  776,  776,
      776, 2280, 1250, 2280,  777,  778,  778,  778,  778,  778,
      777, 2280,  778,  778,  778,  778, 1545, 1251, 2280, 1253,
     1253, 1253, 1546, 1252,  778, 1544, 1249,  776,  776,  776,
     2280,  777, 1250,  778,  778,  778,  778, 1547, 2280,  777,

     2280,  778,  778,  778,  778,  778, 1545, 1251,  776,  776,
      776,  778, 1546, 1252,  776,  776,  776, 2280, 1254, 1548,
      777, 1549,  778,  778,  778,  778,  777, 1547,  778,  778,
      778,  778,  778, 1258,   86,   86, 1550, 2280, 2280, 1551,
      778,   86,   86, 1256,   86,   86,   86,   86, 1254, 1548,
     1255, 1549, 1259, 1270,   86,   86, 1262, 1288, 1288, 1288,
       86,  778, 2280, 1258,   86,   86, 1550,  778,   86, 1551,
     2280,   86,   86, 1256,   86,   86,   86,   86, 1552, 2280,
     1255, 2280, 1259, 1270,   86,   86, 1262,   86,   86, 1553,
       86,   86,   86,   86,   86,   86,   86, 1554,   86,   86,

       86,   86, 1555, 1309, 1558,   86, 1559,   86, 1552,   86,
     1164, 1164, 1164, 1311,   86,   86, 1560,   86,   86, 1553,
     2280,   86,   86,   86,   86,   86,   86, 1554,   86,   86,
       86,   86, 1555, 1309, 1558,   86, 1559,   86, 1312,   86,
     1561,   86,   86, 1311,   86,   86, 1560,   86,   86,   86,
       86, 1562,   86,   86, 1313,   86, 2280, 2280,   86, 1355,
     1563,   86, 1381,   86, 1387, 1564,   86, 1565, 1312, 1568,
     1561,   86,   86, 1356, 1356, 1356, 2280,   86,   86,   86,
       86, 1562,   86,   86, 1313,   86,  776,  776,  776, 1355,
     1563,   86, 1381,   86, 1387, 1564,   86, 1565,  777, 1568,

      778,  778,  778,  778,  776,  776,  776, 1567, 1567, 1567,
     1391, 1391, 1391, 1488, 1569, 2280,  777, 2280,  778,  778,
      778,  778,  777, 2280,  778,  778,  778,  778, 1389, 1570,
     1440, 1440, 1440,  776,  776,  776, 1586, 1586, 1586,  778,
     1253, 1253, 1253, 1488, 1569,  777, 1390,  778,  778,  778,
      778, 1566,  777,  776,  776,  776, 2280,  778, 1389, 1570,
     2280, 1571, 1572,  778, 1573,  777, 1392,  778,  778,  778,
      778, 1468, 2280,  776,  776,  776, 1390, 1394, 1469, 1469,
     1469, 1469, 2280, 1574, 2280,  777,  778,  778,  778,  778,
      778, 1571, 1572, 2280, 1573, 2280, 1392, 1393,   86,   86,

     1575, 1578,  776,  776,  776, 2280,  778, 1394,  776,  776,
      776, 2280, 1398, 1574,  777, 1395,  778,  778,  778,  778,
      777, 2280,  778,  778,  778,  778,  778, 1393,   86,   86,
     1575, 1578, 1579,   86,   86,   86,   86, 1580, 1396,   86,
       86, 1407, 1398,   86,   86, 1395, 1399,   86, 1581,   86,
     1370, 1370, 1370,   86, 2280,  778, 1506,   86,   86,   86,
     2280,  778, 1579,   86,   86,   86,   86, 1580, 1396,   86,
       86, 1407,   86,   86,   86, 2280, 1399,   86, 1581,   86,
       86,   86, 2280,   86,   86,   86, 2280,   86,   86,   86,
     1507, 1499, 1508, 1582,   86, 1583, 1500, 1584,   86, 1585,

     1501, 1366,   86, 1502, 1502, 1502, 1502, 1503, 2280, 2280,
       86,   86,   86,   86,   86,   86, 1384, 1384, 1384, 2280,
     1507, 2280, 1508, 1582,   86, 1583,   86, 1584,   86, 1585,
     1587, 2280, 1523, 1588,   86,   86, 2280,  776,  776,  776,
     1596, 2280,   86,   86, 2280, 1597, 1519, 1598,   86,  777,
     2280,  778,  778,  778,  778, 2280,   86,  776,  776,  776,
     1587, 1520, 1523, 1588,   86,   86, 1524, 1599, 2280,  777,
     1596,  778,  778,  778,  778, 1597, 1519, 1598,   86, 1589,
     1589, 1589, 1525, 1391, 1391, 1391,  776,  776,  776, 1600,
      778, 1520,  776,  776,  776,  777, 1524, 1599,  777, 2280,

      778,  778,  778,  778,  777, 2280,  778,  778,  778,  778,
      778, 2280, 1525, 1526, 2280,  776,  776,  776, 2280, 1600,
     1617, 1617, 1617, 1617, 1527, 1528, 2280,  777, 2280,  778,
      778,  778,  778, 2280,  776,  776,  776, 2280, 2280,  778,
     1451, 1451, 1451, 1526, 1530,  778,  777, 1602,  778,  778,
      778,  778,   86,   86, 1527, 1528, 1533, 2280,   86,   86,
     1603,   86,   86, 1476, 1476, 1476,   86, 1531,  778, 2280,
     1576, 1604,   86, 1606, 1530,   86, 1607, 1602, 2280, 2280,
     1577, 2280,   86,   86, 2280, 2280, 1533,  778,   86,   86,
     1603,   86,   86, 1601, 1608, 1609,   86, 1531, 1610, 1591,

     1576, 1604,   86, 1606, 1468,   86, 1607, 1611, 1592, 1593,
     1577, 1594, 1594, 1594, 1594, 1595, 1480, 1480, 1480, 1489,
     1489, 1489, 1613, 1601, 1608, 1609, 1614, 1615, 1610, 2280,
     2280, 1500, 1618, 1618, 1618, 1618, 2280, 1611, 1498, 1498,
     1498, 1498, 1620, 1620, 1620, 1620, 1505, 1505, 1505, 1605,
     1499, 1625, 1613, 1626, 1628, 1500, 1614, 1615, 1612, 1501,
     1366, 1629, 1502, 1502, 1502, 1502, 1619, 1622, 1622, 1622,
     1627, 1627, 1627, 1630, 1631, 1632, 1633, 2280, 1634, 1605,
     1621, 1625, 1635, 1626, 1628, 1636, 1637, 2280, 1612, 2280,
     1641, 1629, 1638, 1638, 1638, 1644, 1678, 1678, 1678, 2280,

     1648, 2280, 2280, 1630, 1631, 1632, 1633, 1623, 1634, 1624,
     1621, 2280, 1635, 2280, 1649, 1636, 1637,  776,  776,  776,
     1641, 1650,   86,   86, 1651, 1644,  776,  776,  776,  777,
     1648,  778,  778,  778,  778, 1652,   86, 1623,  777, 1624,
      778,  778,  778,  778, 1649, 1639, 1642, 1642, 1642, 2280,
     2280, 1650,   86,   86, 1651, 1699, 1699, 1699,  777, 1640,
      778,  778,  778,  778, 2280, 1652,   86, 2280, 1653, 2280,
      778,  776,  776,  776, 1654, 1639,   86, 1647, 1655,  778,
      776,  776,  776,  777, 1656,  778,  778,  778,  778, 1640,
       86, 1657,  777, 2280,  778,  778,  778,  778, 1653,  778,

     1658,  776,  776,  776, 1654, 1659,   86, 1647, 1655, 2280,
     1643, 1660, 1661,  777, 1656,  778,  778,  778,  778, 1664,
       86, 1657, 1665, 1645,  778, 1556, 1556, 1556, 1666, 1667,
     1658, 1668, 1673,  778, 2280, 1659, 1557, 1557, 1557, 1646,
     1643, 1660, 1661, 1669, 1669, 1669, 1567, 1567, 1567, 1664,
     1674, 1675, 1665, 1645,  778, 1676, 1677, 2280, 1666, 1667,
     1679, 1668, 1673, 1680, 1662, 1681, 1682, 1672, 1683, 1646,
     1684, 1685, 1686, 1670, 1687, 1663, 1688, 1586, 1586, 1586,
     1674, 1675, 1690, 1691, 1698, 1676, 1677, 1671, 1700, 1701,
     1679, 2280, 2280, 1680, 1662, 1681, 1682, 2280, 1683, 2280,

     1684, 1685, 1686, 1670, 1687, 1663, 1688, 1589, 1589, 1589,
     1702, 2280, 1690, 1691, 1698, 1703, 1704, 1671, 1700, 1701,
     1705, 1689, 1693, 1693, 1693, 1693, 1694, 1694, 1694, 1694,
     1695, 1695, 1695, 1695, 1468, 1692, 1697, 1697, 1697, 1697,
     1702, 1696, 1696, 1696, 1696, 1703, 1704, 1706, 1707, 1708,
     1705, 1689, 1709, 1710, 1711, 1712, 1712, 1712, 1713, 1714,
     1622, 1622, 1622, 1715, 2280, 1692, 1617, 1617, 1617, 1617,
     1618, 1618, 1618, 1618, 1720, 1721, 1722, 1706, 1707, 1708,
     1723, 1724, 1709, 1710, 1711, 1726, 1717, 1727, 1713, 1716,
     1716, 1716, 1716, 1718, 1718, 1718, 1718, 1719, 1728, 1729,

     1623, 1730, 1624, 1731, 1720, 1721, 1722, 1627, 1627, 1627,
     1723, 1724, 1732, 2280, 2280, 1726, 2280, 1727, 1638, 1638,
     1638, 1736, 1734, 1734, 1734, 2280, 1739, 2280, 1728, 1729,
     1623, 1730, 1624, 1731,  777, 1743,  778,  778,  778,  778,
     2280, 2280, 1732,  776,  776,  776, 1733, 1742,   86,   86,
     1725, 1736, 1642, 1642, 1642,  777, 1739,  778,  778,  778,
      778, 2280,   86, 1744,  777, 1743, 2280, 1745, 1746, 1747,
      776,  776,  776, 2280, 2280,  778, 1733, 1742,   86,   86,
     1725, 1735,  777, 1748,  778,  778,  778,  778,  776,  776,
      776, 1737,   86, 1744, 1749, 1750,  778, 1745, 1746, 1747,

      777, 2280,  778,  778,  778,  778, 1751, 1752, 1738, 1754,
     1755, 1735, 2280, 1748, 2280, 2280,  776,  776,  776, 1756,
     1757, 1737, 1758,  778, 1749, 1750, 1762, 1763,  777, 1740,
      778,  778,  778,  778, 1765, 1766, 1751, 1752, 1738, 1754,
     1755,  778, 1753, 1753, 1753, 1741, 1669, 1669, 1669, 1756,
     1757, 1767, 1758, 1759, 1759, 1759, 1762, 1763, 1768, 1740,
     2280, 1678, 1678, 1678, 1765, 1766, 1769, 2280, 1770,  778,
     1771, 1772, 1772, 1772, 1774, 1741, 1670, 1773, 1773, 1773,
     1775, 1767, 1778, 1760, 1776, 1776, 1776, 2280, 1768, 1786,
     1671, 1764, 1777, 1777, 1777, 2280, 1769, 1761, 1770, 2280,

     1771, 2280, 1787, 2280, 1774, 2280, 1670, 1699, 1699, 1699,
     1775, 2280, 1778, 1760, 1779, 1779, 1779, 1779, 1788, 1786,
     1671, 1764, 1780, 1780, 1780, 1780, 1781, 1761, 1784, 1784,
     1784, 1784, 1787, 1695, 1695, 1695, 1695, 1468, 1789, 1789,
     1789, 1782, 1790, 1791, 1783, 1783, 1783, 1783, 1788, 1792,
     1794, 1785, 1712, 1712, 1712, 1796, 1801, 1801, 1801, 1801,
     1802, 1803, 1797, 1797, 1797, 1797, 1798, 1804, 1805, 1806,
     1807, 1808, 1790, 1791, 1809, 1810, 1811, 1717, 2280, 1792,
     1794, 1785, 1799, 2280, 1800, 1800, 1800, 1800, 1719, 1795,
     1802, 1803, 1814, 2280, 1815, 2280, 2280, 1804, 1805, 1806,

     1807, 1808, 1816, 2280, 1809, 1810, 1811, 1821, 1734, 1734,
     1734,  776,  776,  776, 1818, 1818, 1818, 2280, 2280, 1795,
      777, 2280, 1814,  777, 1815,  778,  778,  778,  778,   86,
       86, 1822, 1816, 1817, 1817, 1817, 2280, 1821, 1823, 1823,
     1823, 1824, 1825,   86, 1812,  777, 2280,  778,  778,  778,
      778,  776,  776,  776, 1827, 1813, 1826, 1826, 1826,   86,
       86, 1822, 2280,  777,  778,  778,  778,  778,  778, 1828,
     1830, 1824, 1825,   86, 1812, 1831, 1820, 1820, 1820, 1753,
     1753, 1753, 2280, 1832, 1827, 1813,  778, 1819,  777, 1833,
      778,  778,  778,  778, 1759, 1759, 1759, 1834, 1835, 1828,

     1830, 1836, 1837, 1839,  778, 1831, 1838, 1838, 1838, 1840,
     1841, 1842, 1829, 1832, 1843, 2280, 2280, 1819, 1847, 1833,
     1844, 1844, 1844, 1851, 1760, 2280, 2280, 1834, 1835,  778,
     2280, 1836, 1837, 1839, 1772, 1772, 1772, 1860, 1761, 1840,
     1841, 1842, 1829, 2280, 1843, 1773, 1773, 1773, 1847, 1776,
     1776, 1776, 2280, 1851, 1760, 1777, 1777, 1777, 1856, 1856,
     1856, 1856, 1861, 1862, 1468, 1864, 1865, 1860, 1761, 1866,
     1846, 1783, 1783, 1783, 1783, 1867, 1848, 1845, 2280, 1789,
     1789, 1789, 1849, 1850, 1869, 1869, 1869, 1869, 1870, 1870,
     1870, 1870, 1861, 1862, 2280, 1864, 1865, 1872, 1873, 1866,

     1846, 1871, 1871, 1871, 1871, 1867, 1848, 1845, 1863, 1796,
     1875, 1876, 1849, 1850, 1799, 1717, 1868, 1868, 1868, 1868,
     1798, 1877, 1800, 1800, 1800, 1800, 1719, 1872, 1873, 1874,
     1874, 1874, 1878, 1879, 1880, 1882, 1882, 1882, 1863, 1883,
     1875, 1876,  776,  776,  776, 1818, 1818, 1818, 1817, 1817,
     1817, 1877, 2280, 2280,  777, 2280,  778,  778,  778,  778,
      777, 1892, 1878, 1879, 1880, 1889, 1889, 1889, 2280, 1883,
     1893, 1820, 1820, 1820, 2280, 1884, 1885,  777, 1895,  778,
      778,  778,  778,  777, 1896, 1881, 1823, 1823, 1823, 1888,
     1886, 1892, 1887, 1897, 1898,  778, 1899, 1900, 1891, 1901,

     1893, 1903, 1826, 1826, 1826, 1884, 1885, 1905, 1895, 1906,
     1890, 1902, 1902, 1902, 1896, 1881, 2280, 2280,  778, 1888,
     1886, 1909, 1887, 1897, 1898, 1910, 1899, 1900, 1911, 1901,
     1912, 1903, 1838, 1838, 1838, 2280, 1913, 1905, 1914, 1906,
     1890, 1894, 1907, 1907, 1907, 1844, 1844, 1844, 1915, 2280,
     2280, 1909, 1931, 1931, 1931, 1910, 2280, 1921, 1911, 2280,
     1912, 1916, 1916, 1916, 1916, 1904, 1913, 1922, 1914, 1923,
     1924, 1894, 1917, 1917, 1917, 1917, 1925, 1926, 1915, 1918,
     1918, 1918, 1918, 1919, 1919, 1919, 1919, 1921, 1908, 1920,
     1920, 1920, 1920, 2280, 1796, 1904, 2280, 1922, 1933, 1923,

     1924, 1868, 1868, 1868, 1868, 1798, 1925, 1926, 1874, 1874,
     1874, 1934, 1927, 1935, 1936, 1932, 1929, 2280, 1908, 1928,
     1928, 1928, 1928, 1870, 1870, 1870, 1870, 1941, 1933, 1882,
     1882, 1882, 1939, 1937, 1937, 1937, 1942, 1943, 1940, 1944,
     1950, 1934, 1951, 1935, 1936,  777, 1946,  778,  778,  778,
      778, 1889, 1889, 1889, 1947, 1952, 2280, 1941, 1948, 1948,
     1948, 1953, 1939,  777, 2280, 1954, 1942, 1943, 1940, 1944,
     1950, 1955, 1951, 1938, 1956, 1958, 1946, 1959, 1960, 1963,
     1902, 1902, 1902, 1964, 1947, 1952,  778, 1957, 1949, 1965,
     1966, 1953, 1967, 2280, 1945, 1954, 1907, 1907, 1907, 2280,

     1968, 1955, 1969, 1938, 1956, 1958, 1970, 1959, 1960, 1963,
     1992, 1992, 1992, 1964, 1971, 1971, 1971, 1971, 1949, 1965,
     1966, 1977, 1967, 1961, 1945, 1972, 1972, 1972, 1972, 1962,
     1968, 1975, 1969, 1978, 1979, 1980, 1970, 2280, 1919, 1919,
     1919, 1919, 1976, 1976, 1976, 1976, 1984, 1927, 1985, 1987,
     1988, 1977, 1930, 1961, 1981, 1981, 1981, 1981, 1989, 1962,
     1990, 1991, 1994, 1978, 1979, 1980, 1982, 1982, 1982, 1982,
     1931, 1931, 1931, 1937, 1937, 1937, 1984, 1983, 1985, 1987,
     1988, 1993, 1993, 1993, 1995,  777, 1996, 1997, 1989, 1998,
     1990, 1991, 1994, 1948, 1948, 1948, 1999, 2000, 1986, 2001,

     2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
     2012, 2037, 2037, 2037, 1995, 2020, 1996, 1997, 2021, 1998,
     2024, 2280, 2025, 1949, 2280, 2280, 1999, 2000, 1986, 2001,
     2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
     2012, 2017, 2017, 2017, 2017, 2020, 2026, 1927, 2021, 2027,
     2024, 2022, 2025, 1949, 1981, 1981, 1981, 1981, 1982, 1982,
     1982, 1982, 2028, 2029, 1993, 1993, 1993, 1992, 1992, 1992,
     2035, 2036, 2280, 2038, 2039, 2040, 2026, 2041, 2042, 2027,
     2043, 2280, 2044, 2045, 2046, 2047, 2048, 2049, 2050, 2050,
     2050, 2050, 2028, 2029, 2030, 2031, 2051, 2051, 2051, 2051,

     2035, 2036, 2033, 2038, 2039, 2040, 2054, 2041, 2042, 2032,
     2043, 2034, 2044, 2045, 2046, 2047, 2048, 2049, 2052, 2052,
     2052, 2052, 2055, 2056, 2030, 2031, 2053, 2053, 2053, 2053,
     2057, 2058, 2033, 2059, 2060, 2061, 2054, 2062, 2063, 2032,
     2065, 2034, 2066, 2067, 2064, 2068, 2069, 2070, 2037, 2037,
     2037, 2072, 2055, 2056, 2073, 2074, 2075, 2076, 2077, 2078,
     2057, 2058, 2079, 2059, 2060, 2061, 2080, 2062, 2063, 2280,
     2065, 2280, 2066, 2067, 2064, 2068, 2069, 2070, 2071, 2086,
     2087, 2072, 2280, 2280, 2073, 2074, 2075, 2076, 2077, 2078,
     2088, 2089, 2079, 2090, 2090, 2090, 2080, 2081, 2081, 2081,

     2081, 2082, 2082, 2082, 2082, 2085, 2091, 2092, 2071, 2086,
     2087, 2094, 2053, 2053, 2053, 2053, 2093, 2093, 2093, 2095,
     2088, 2089, 2096, 2097, 2098, 2099, 2100, 2101, 2102, 2103,
     2104, 2105, 2106, 2107, 2108, 2109, 2091, 2092, 2110, 2116,
     2117, 2094, 2115, 2115, 2115, 2115, 2090, 2090, 2090, 2095,
     2120, 2123, 2096, 2097, 2098, 2099, 2100, 2101, 2102, 2103,
     2104, 2105, 2106, 2107, 2108, 2109, 2124, 2125, 2110, 2116,
     2117, 2121, 2121, 2121, 2118, 2093, 2093, 2093, 2126, 2119,
     2120, 2123, 2127, 2128, 2128, 2128, 2129, 2280, 2130, 2131,
     2132, 2133, 2134, 2135, 2280, 2280, 2124, 2125, 2136, 2136,

     2136, 2137, 2137, 2137, 2118, 2280, 2141, 2142, 2126, 2119,
     2143, 2144, 2127, 2121, 2121, 2121, 2129, 2122, 2130, 2131,
     2132, 2133, 2134, 2135, 2138, 2138, 2138, 2138, 2139, 2139,
     2139, 2139, 2140, 2140, 2140, 2140, 2141, 2142, 2146, 2147,
     2143, 2144, 2148, 2149, 2150, 2151, 2154, 2122, 2128, 2128,
     2128, 2155, 2155, 2155, 2156, 2157, 2145, 2136, 2136, 2136,
     2137, 2137, 2137, 2161, 2161, 2161, 2161, 2164, 2146, 2147,
     2160, 2165, 2148, 2149, 2150, 2151, 2154, 2138, 2138, 2138,
     2138, 2159, 2166, 2167, 2156, 2157, 2145, 2168, 2169, 2170,
     2158, 2171, 2172, 2174, 2175, 2152, 2176, 2164, 2173, 2173,

     2173, 2165, 2177, 2155, 2155, 2155, 2179, 2179, 2179, 2180,
     2181, 2185, 2166, 2167, 2186, 2187, 2189, 2168, 2169, 2170,
     2158, 2171, 2172, 2174, 2175, 2152, 2176, 2184, 2184, 2184,
     2184, 2190, 2177, 2188, 2188, 2188, 2191, 2192, 2195, 2180,
     2181, 2185, 2196, 2197, 2186, 2187, 2189, 2178, 2193, 2193,
     2193, 2173, 2173, 2173, 2198, 2199, 2179, 2179, 2179, 2280,
     2201, 2190, 2202, 2188, 2188, 2188, 2191, 2192, 2195, 2205,
     2206, 2207, 2196, 2197, 2209, 2280, 2211, 2178, 2203, 2203,
     2203, 2203, 2213, 2214, 2198, 2199, 2210, 2210, 2210, 2200,
     2201, 2215, 2202, 2194, 2204, 2204, 2204, 2204, 2216, 2205,

     2206, 2207, 2217, 2218, 2209, 2208, 2211, 2193, 2193, 2193,
     2219, 2220, 2213, 2214, 2224, 2225, 2226, 2221, 2227, 2200,
     2280, 2215, 2229, 2194, 2203, 2203, 2203, 2203, 2216, 2210,
     2210, 2210, 2217, 2218, 2230, 2208, 2231, 2232, 2233, 2234,
     2219, 2220, 2235, 2236, 2224, 2225, 2226, 2237, 2227, 2239,
     2212, 2240, 2229, 2238, 2238, 2238, 2238, 2241, 2242, 2243,
     2244, 2244, 2244, 2245, 2230, 2246, 2231, 2232, 2233, 2234,
     2247, 2228, 2235, 2236, 2248, 2249, 2251, 2237, 2252, 2239,
     2212, 2240, 2250, 2250, 2250, 2250, 2253, 2241, 2242, 2243,
     2254, 2255, 2257, 2245, 2259, 2246, 2244, 2244, 2244, 2262,

     2247, 2228, 2263, 2264, 2248, 2249, 2251, 2265, 2252, 2258,
     2258, 2258, 2266, 2258, 2258, 2258, 2253, 2269, 2270, 2271,
     2254, 2255, 2257, 2272, 2259, 2268, 2268, 2268, 2268, 2262,
     2274, 2275, 2263, 2264, 2276, 2277, 2273, 2265, 2256, 2278,
     2279, 2280, 2266, 2268, 2268, 2268, 2268, 2269, 2270, 2271,
     2280, 2280, 2280, 2272, 2280, 2267, 2280, 2280, 2280, 2280,
     2274, 2275, 2280, 2280, 2276, 2277, 2280, 2280, 2256, 2278,
     2279, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2267,   58,   58,   58,   64,
       64,   64,   66,   66,   66,  187,  187,  187,  779,  779,

      778,  778, 1465, 1465, 1465, 1467, 1467, 1467, 1495, 1495,
     1495, 1497, 1497, 1497,    5, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280
    } ;

static yyconst flex_int16_t yy_chk[10602] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    3,    4,    7,    7,
        7,    8,    8,    8,    9,    9,    9,   12,   12,   12,

       15,   15,   15,   18,   18,   18,   18,   20, 1779,   20,
       20,   20,   20,   69, 2285,    9,   23,   23,   23, 1779,
       24,   24,   24,   25,   25,   25,   49, 2130,   84,   49,
       49,   61,   61,   61,  185,  192,   49,   23,   23, 1984,
       12,   24, 1780,   69,   25,  193,   49, 1780,   70,   70,
       70,   72,   72,   72,   72, 1871,   49,   70,   84,   49,
       49,   56,   56,   56,  185,  192,   49, 1708,    3,    4,
       12,   28,   28,   28,   28,  193,   49,   73,   73,   73,
       73,  261,   28,   28,   28,   28,   28,   28,   28,   28,
       28,   28,   28,   28,   28,   28,   28,   28,   28,   28,

       28,   28,   28,   28,   28,   28,   28,   28, 1497, 1496,
       28,  261,   28,   28,   28,   28,   28,   28,   28,   28,
       28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
       28,   28,   28,   28,   28,   28,   28,   28,   29,   29,
       29,   29,   34,   56,   29,  333,   34,   29,  334,   29,
       29,   29,   34, 1495,   29,   34,   29,   29,  335,   35,
       29, 1467,   34,   35,  339,  339,  339,   35,   29,   29,
       29,   29,   34,   35,   29,  333,   34,   29,  334,   29,
       29,   29,   34,   35,   29,   34,   29,   29,  335,   35,
       29,   30,   34,   35, 1466,   30,  386,   35,   30,   30,

      401,  402,   37,   35,  339,   30,  409,   37,   30,   37,
      410,   30,  409,   35,   37,   30, 1971, 1465,   68,   68,
       68,   30,   62,   62,   62,   30,  386, 1971,   30,   30,
      401,  402,   37, 1365,  339,   30,  409,   37,   30,   37,
      410,   30,  409,   62,   37,   30,   31,   31,   48,  432,
       31,   48,   36, 1364,   31,  433,   48,   36,   36,   36,
       31,   68,   48,   31,   36,  179,  179,  179,  468,   36,
       31,  319,  319,  319, 1333, 1332,   31,   31,   48,  432,
       31,   48,   36,  319,   31,  433,   48,   36,   36,   36,
       31,   68,   48,   31,   36,   76,   76,   76,  468,   36,

       31,   32,  424,  424,  424,   32,  469,   38,   32,   32,
       32,   32,   38,  470,   38,   32,   76,   76,  491,   38,
       32,   32,   74,   38,   74,   74,   74,   74,  345,  345,
      345,   32,  424, 1297,  345,   32,  469,   38,   32,   32,
       32,   32,   38,  470,   38,   32, 1296,  179,  491,   38,
       32,   32,   33,   38, 1226,   39,   33,  492,   33,   39,
       33,  493,  424,   33, 1145,   39,   33,   44,  495,   33,
       40,   44,   39,   40,   40,   39,   33,   44,   40,  497,
       44,  532,   33,   44,   40,   39,   33,  492,   33,   39,
       33,  493,  989,   33,   40,   39,   33,   44,  495,   33,

       40,   44,   39,   40,   40,   39,   33,   44,   40,  497,
       44,  532,  540,   44,   40,  545,   43,  187,  546,   43,
       79,   79,   79,   43,   40,   41,  184,   41,   43,  183,
      554,   41,   43,  555,  562,   43,  178,   41,   81,   81,
       81,   79,  540,   41,   41,  545,   43,   41,  546,   43,
      417,  417,  417,   43,  563,   41,  417,   41,   43,   81,
      554,   41,   43,  555,  562,   43,   46,   41,  564,   46,
       46,   50,   83,   41,   41,   50,   46,   41,   42,   46,
       47,   50,   47,   42,  563,   47,   46,   47,   42,   47,
       42,   50,   47,  577,   42,   42,   46,   42,  564,   46,

       46,   50,  378,  378,  378,   50,   46,  580,   42,   46,
       47,   50,   47,   42,   71,   47,   46,   47,   42,   47,
       42,   50,   47,  577,   42,   42,   67,   42,   45,   51,
      378,   45,   45,   51,  582,  583,   45,  580,   45,   51,
       45,   45,   88,   45,   45,   88,   66,   86,   64,   51,
       88,   86,  731,  731,  731,   53,   88,   86,   45,   51,
      378,   45,   45,   51,  582,  583,   45,   86,   45,   51,
       45,   45,   88,   45,   45,   88,   87,   86,   87,   51,
       88,   86,   87,  418,  418,  418,   88,   86,   87,  418,
     1784,   89,  584,  171,   89, 1784,  171,   86,   87,   89,

      171, 1784,   90,  171,  588,   89,   87,   90,   87,   90,
       89, 1976,   87,  589,   90,   90, 1976,   91,   87,  607,
       91,   89,  584,  171,   89,   91,  171,  632,   87,   89,
      171,   91,   90,  171,  588,   89,   27,   90,   26,   90,
       89,   91,  633,  589,   90,   90,   92,   91,   21,  607,
       91,   92,   93,   92,  638,   91,   92,  632,   93,   94,
       17,   91,   11,   93,   94,   93,   94,  639,   93,   94,
       94,   91,  633,  464,  464,  464,   92,  640,   95,  464,
       95,   92,   93,   92,  638,   95,   92,   95,   93,   94,
       97,   97,   95,   93,   94,   93,   94,  639,   93,   94,

       94,  581,   10,  581,   97,   96,   96,  640,   95, 2052,
       95,   96,  641,   96, 2052,   95, 1972,   95,   96,   96,
       97,   97,   95,   98,   98,   99,   99, 1972,    5,  642,
      643,  581,   98,  581,   97,   96,   96,   98,  651,   99,
        0,   96,  641,   96,  100,  100,  101,  660,   96,   96,
      101,  101,  101,   98,   98,   99,   99,  100,  100,  642,
      643, 2081,   98,    0,    0,  101, 2081,   98,  651,   99,
      255,  255,  255,  102,  100,  100,  101,  660,    0, 1918,
      101,  101,  101, 1918,  102,  102,    0,  100,  100,  102,
      104,  104,  102,  105,  105,  101,  103,  103,  103,  255,

     2161, 2250,  104,  102,  104, 2161, 2250,  105,  337,  337,
      337,  103,  105,  255,  102,  102,  260,  260,  260,  102,
      104,  104,  102,  105,  105,  106,  103,  103,  103,  255,
      106,  106,  104,    0,  104,  337,  107,  105,    0,  107,
      107,  103,  105,  255,  106,  107,    0,    0,  110,  110,
      661,  662,  107,  107,  260,  106,    0,  110,  108,  664,
      106,  106,  110,  108,  108,  337,  107,  666,  109,  107,
      107,  109,  109,    0,  106,  107,  108,  108,  110,  110,
      661,  662,  107,  107,  260,  109,  109,  110,  108,  664,
      111,  111,  110,  108,  108,  112,    0,  666,  109,  112,

      112,  109,  109,  111,  111,    0,  108,  108,  113,  670,
      113,  113,  697,  112,  114,  109,  109,  114,  114,    0,
      111,  111,    0,    0,  113,  112,  481,  481,  481,  112,
      112,  114,    0,  111,  111,  501,  501,  501,  113,  670,
      113,  113,  697,  112,  114,    0,    0,  114,  114,  115,
      698,  115,  115,  115,  113,  115,  116,  116,  117,  117,
      501,  114,  116,  699,  117,    0,  115,  700,    0,  481,
      116,    0,  117, 2082,  281,  281,  281,    0,    0,  115,
      698,  115,  115,  115, 2082,  115,  116,  116,  117,  117,
      501,  118,  116,  699,  117,  118,  115,  700,  118,  481,

      116,  281,  117,  281,  118,  119,  119,  118,  120,  120,
      121,  701,  702,  121,  119,  703,  123,  123,  121,  119,
      120,  118,  120,    0,  121,  118,    0,    0,  118,  702,
      123,  281,  123,  281,  118,  119,  119,  118,  120,  120,
      121,  701,  702,  121,  119,  703,  123,  123,  121,  119,
      120,  705,  120,  122,  121,  710,  122,  124,  124,  702,
      123,  122,  123,    0,    0,  125,  125,  122,  128,  128,
      128,  124,  124,  125,  711,  126,  126,    0,  126,  125,
      714,  705,    0,  122,    0,  710,  122,  124,  124,  126,
        0,  122,    0,  129,  129,  125,  125,  122,  128,  128,

     2140,  124,  124,  125,  711,  126,  126,  129,  126,  125,
      714, 2140,  128,  130,  130,    0,  129,    0,    0,  126,
      127,  127,  127,  129,  129,  131,  131,  130,  128,  128,
      131,  715,  131,    0,    0,  133,    0,  129,  717,  131,
      133,  133,  128,  130,  130,  138,  138,  138,  127,  132,
      127,  127,  132,  132,  133,  131,  131,  130,  127,  138,
      131,  715,  131,  127,  127,  133,  132,  718,  717,  131,
      133,  133,  134,  134,  724,  138,  138,  138,  127,  132,
      127,  127,  132,  132,  133,    0,  134,    0,  127,  138,
      134,  135,  135,  127,  127,    0,  132,  718,  136,  136,

      725,    0,  134,  134,  724,  135,  136,  776,  776,  776,
      135,    0,  136,  140,  140,  137,  134,  137,  137,  776,
      134,  135,  135,  139,  139,  137,  730,  140,  136,  136,
      725,  137,  141,  141,    0,  135,  136,  139,  141,  141,
      135,  139,  136,  140,  140,  137,  141,  137,  137,  144,
      144,  144,  732,  139,  139,  137,  730,  140,  734,  142,
        0,  137,  141,  141,  142,  142,    0,  139,  141,  141,
        0,  139,    0,  143,  143,  735,  141,  143,  142,  144,
      144,  145,  732,  145,  145,  146,  146,  143,  734,  142,
      669,  669,  669,  144,  142,  142,  669,  145,  736,  146,

      683,  683,  683,  143,  143,  735,  683,  143,  142,  144,
      144,  145,    0,  145,  145,  146,  146,  143,  147,  147,
     2204,  148,  737,  144,  148,  148,  741,  145,  736,  146,
      147, 2204,  147,  149,  149,  150,  149,  743,  148,  150,
      150,  561,  561,  561,  152,  152,  744,  149,  147,  147,
      152,  148,  737,  150,  148,  148,  741,  745,  152,    0,
      147,  152,  147,  149,  149,  150,  149,  743,  148,  150,
      150,  451,  451,  451,  152,  152,  744,  149,    0,    0,
      152,  746,    0,  150,  151,  561,  151,  745,  152,  151,
      151,  152,  153,  153,    0,  748,    0,  151,  451,  151,

      153,  749,  151,  151,  750,  151,  153,  155,  155,  154,
      155,  746,  154,  154,  151,  561,  151,    0,  154,  151,
      151,  155,  153,  153,  154,  748,  154,  151,  451,  151,
      153,  749,  151,  151,  750,  151,  153,  155,  155,  154,
      155,  157,  154,  154,  156,  156,  157,  157,  154,  159,
      159,  155,  158,  158,  154,  159,  154,  754,  156,  158,
      157,  755,  160,  159,  770,    0,  158,  160,  160,    0,
        0,  157,    0,    0,  156,  156,  157,  157,    0,  159,
      159,  160,  158,  158,    0,  159,  797,  754,  156,  158,
      157,  755,  160,  159,  770,  161,  158,  160,  160,  161,

      161,  162,  162,  163,  163,  163,  161,  164,  164,  799,
        0,  160,  800,  161,  164,  162,  797,  801,  163,  162,
        0,  164,  165,  165,  165,  161,  166,  166,    0,  161,
      161,  162,  162,  163,  163,  163,  161,  164,  164,  799,
      166,  166,  800,  161,  164,  162,    0,  801,  163,  162,
      165,  164,  165,  165,  167,  167,  166,  166,  168,  168,
      168,  573,  573,  573,  167,  802,  165,  803,  167,  169,
      166,  166,    0,  169,  169,  170,  169,  170,  170,  169,
      165,    0,  165,  165,  167,  167,  573,  169,  168,  168,
        0,  170,  804,    0,  167,  802,  165,  803,  167,  169,

        0,    0,  168,  169,  169,  170,  169,  170,  170,  169,
        0,  175,  175,  172,  176,  176,  573,  169,  168,  168,
      172,  170,  804,  172,  173,  175,  805,  173,  176,  172,
      174,  173,  168,  174,  173,    0,  808,  174,  809,  811,
      174,  175,  175,  172,  176,  176,  177,  194,  194,  194,
      172,  177,  177,  172,  173,  175,  805,  173,  176,  172,
      174,  173,  194,  174,  173,  177,  808,  174,  809,  811,
      174,  195,  195,  195,  812,  816,  177,  194,  194,  194,
        0,  177,  177,  197,  197,  197,  199,  199,  196,  196,
      196,    0,  194,  823,    0,  177,  824,    0,  200,  200,

      199,  195,  195,  196,  812,  816,  198,  198,  198,  201,
      201,  201,  200,  197,  197,  195,  199,  199,  196,  196,
      196,  198,    0,  823,  201,    0,  824,  197,  200,  200,
      199,  195,  195,  196,    0,    0,  198,  198,  198,  201,
      201,  201,  200,  197,  197,  195,  202,  826,  203,  221,
      221,  198,  204,  202,  201,  203,  202,  197,  203,  204,
        0,  203,  204,  221,  205,  205,  205,    0,  204,  579,
      579,  579,    0,    0,  206,    0,  202,  826,  203,  221,
      221,  206,  204,  202,  206,  203,  202,  206,  203,  204,
      205,  203,  204,  221,    0,  207,  829,  205,  204,  209,

      205,    0,  207,  208,  206,  207,  209,    0,  210,  209,
      208,  206,  579,  208,  206,  210,  209,  206,  210,    0,
      205,  223,    0,  830,  208,  207,  829,  205,  223,  209,
      205,  223,  207,  208,  211,  207,  209,  211,  210,  209,
      208,  211,  579,  208,  211,  210,  209,    0,  210,  212,
      213,  223,  212,  830,  208,  832,  212,  213,  223,  212,
      213,  223,  214,  214,  211,    0,  213,  211,    0,  214,
        0,  211,  214,    0,  211,  636,  636,  636,    0,  212,
      213,    0,  212,    0,  215,  832,  212,  213,  833,  212,
      213,  215,  214,  214,  215,  215,  213,  216,  216,  214,

      636,  218,  214,  219,  219,  216,  218,  218,  217,  217,
      216,  216,  222,  222,  215,  219,  217,  219,  833,    0,
      218,  215,  217,    0,  215,  215,  222,  216,  216,    0,
      636,  218,    0,  219,  219,  216,  218,  218,  217,  217,
      216,  216,  222,  222,  834,  219,  217,  219,  835,  220,
      218,  836,  217,  220,  220,  220,  222,  225,  224,  224,
      225,  239,  239,  239,  225,  227,  224,  225,  220,  224,
      226,  226,  227,    0,  834,  227,  239,  226,  835,  220,
      226,  836,  839,  220,  220,  220,    0,  225,  224,  224,
      225,  239,  239,  239,  225,  227,  224,  225,  220,  224,

      226,  226,  227,  228,  228,  227,  239,  226,  229,  229,
      226,  230,  839,  228,  775,  775,  775,  228,  230,  236,
      775,  230,  229,  229,    0,  232,  236,    0,  232,  236,
      231,    0,  232,  228,  228,  232,  842,  231,  229,  229,
      231,  230,    0,  228,  231,  865,    0,  228,  230,  236,
      866,  230,  229,  229,  233,  232,  236,  233,  232,  236,
      231,  233,  232,  867,  233,  232,  842,  231,  235,  235,
      231,  234,  234,  234,  231,  865,  235,    0,  868,  235,
      866,    0,  237,  237,  233,    0,    0,  233,    0,  237,
      869,  233,  237,  867,  233,    0,    0,  234,  235,  235,

        0,  238,  238,    0,  234,  870,  235,  234,  868,  235,
      240,  240,  237,  237,  238,  238,  241,  241,  242,  237,
      869,  871,  237,  240,  240,  242,  243,  234,  242,    0,
      241,  238,  238,  243,  234,  870,  243,  234,    0,  241,
      240,  240,  244,  872,  238,  238,  241,  241,  242,  244,
        0,  871,  244,  240,  240,  242,  243,    0,  242,  244,
      241,  874,    0,  243,  247,  247,  243,  245,  245,    0,
      248,  247,  244,  872,  247,  245,    0,  248,  245,  244,
      248,  248,  244,  246,  246,  246,  798,  798,  798,  244,
        0,  874,  251,    0,  247,  247,  250,  245,  245,  251,

      248,  247,  251,  250,  247,  245,  250,  248,  245,  246,
      248,  248,  246,  249,  252,  250,  246,  877,  878,  246,
      249,  252,  251,  249,  252,  249,  250,  253,  880,  251,
      252,    0,  251,  250,  253,    0,  250,  253,    0,  246,
      253,    0,  246,  249,  252,  250,  246,  877,  878,  246,
      249,  252,  254,  249,  252,  249,    0,  253,  880,  254,
      252,  254,  254,  881,  253,  256,  257,  253,  256,  257,
      253,  258,  256,  257,  258,  256,  257,  883,  258,    0,
      884,  258,  254,  789,  789,  789,  262,  262,    0,  254,
        0,  254,  254,  881,  789,  256,  257,  259,  256,  257,

      262,  258,  256,  257,  258,  256,  257,  883,  258,  259,
      884,  258,    0,  259,    0,  887,  262,  262,  264,  259,
      263,  263,  263,    0,  265,  264,  810,  889,  264,  259,
      262,  265,  810,  265,  265,  263,    0,  266,    0,  259,
      268,  268,  268,  259,  266,  887,    0,  266,  264,  259,
      263,  263,  263,  266,  265,  264,  810,  889,  264,  259,
        0,  265,  810,  265,  265,  263,  268,  266,  267,  267,
      890,    0,  269,  268,  266,  267,  268,  266,  267,  269,
        0,  891,  269,  266,  270,  270,  270,    0,  273,  273,
      273,  944,  944,  944,  271,    0,  268,  271,  267,  267,

      890,  271,  269,  268,  271,  267,  268,    0,  267,  269,
      270,  891,  269,  272,  272,  272,  274,  270,  273,  273,
      270,  274,  274,  277,  271,  275,  275,  271,  272,  270,
      277,  271,  273,  277,  271,  274,  276,  276,  276,  275,
      270,    0,    0,  272,  272,  272,  274,  270,  273,  273,
      270,  274,  274,  277,  278,  275,  275,  278,  272,  270,
      277,  278,  273,  277,  278,  274,  276,  276,  280,  275,
      825,  280,  279,  895,    0,  280,  825,    0,  280,  279,
      276,    0,  279,  282,  278,  898,  282,  278,  279,  899,
      282,  278,    0,  282,  278,    0,  276,  276,  280,    0,

      825,  280,  279,  895,  283,  280,  825,  283,  280,  279,
      276,  283,  279,  282,  283,  898,  282,    0,  279,  899,
      282,  284,  284,  282,  285,  285,  286,  286,  284,  287,
      900,  284,  901,  286,  283,  288,  287,  283,  285,  287,
      286,  283,  288,  290,  283,  288,  290,  852,  852,  852,
      290,  284,  284,  290,  285,  285,  286,  286,  284,  287,
      900,  284,  901,  286,  289,  288,  287,  904,  285,  287,
      286,  289,  288,  290,  289,  288,  290,  289,  291,  291,
      290,    0,    0,  290,  852,  292,  291,    0,    0,  291,
        0,    0,  292,  293,  289,  292,  906,  904,  292,    0,

      293,  289,  907,  293,  289,  908,  293,  289,  291,  291,
      294,  295,  293,  909,  852,  292,  291,  294,  295,  291,
      294,  295,  292,  293,  295,  292,  906,  296,  292,  294,
      293,    0,  907,  293,  296,  908,  293,  296,  910,  297,
      294,  295,  293,  909,  911,  299,  297,  294,  295,  297,
      294,  295,  299,    0,  295,  299,    0,  296,  299,  294,
      298,  298,  298,    0,  296,  912,    0,  296,  910,  297,
      300,  301,  916,  300,  911,  299,  297,  300,  301,  297,
      300,  301,  299,  303,  303,  299,  298,  917,  299,  302,
      302,  302,    0,  298,  929,  912,  298,  303,    0,  304,

      300,  301,  916,  300,  304,  304,    0,  300,  301,  950,
      300,  301,    0,  303,  303,  302,  298,  917,  304,    0,
        0,  306,  302,  298,  929,  302,  298,  303,  306,  304,
        0,  306,  305,  305,  304,  304,  777,  777,  777,  950,
      391,  391,  391,  953,  777,  302,  305,  305,  304,  309,
      307,  306,  302,  307,  956,  302,  309,  307,  306,  309,
      307,  306,  305,  305,  308,  309,  957,  308,  310,  391,
      310,  308,    0,  953,  308,  310,  305,  305,  310,  309,
      307,    0,    0,  307,  956,  391,  309,  307,  958,  309,
      307,  311,  311,  311,  308,  309,  957,  308,  310,  391,

      310,  308,  312,  312,  308,  310,  313,  313,  310,  959,
      314,  314,  314,  960,  313,  391,  312,  311,  958,    0,
      313,  315,  315,  315,  311,  314,    0,  311,  612,  612,
      612,    0,  312,  312,    0,  961,  313,  313,    0,  959,
      314,  314,  314,  960,  313,    0,  312,  311,  315,  612,
      313,  665,  665,  665,  311,  314,  316,  311,    0,  315,
      327,  316,  316,  327,  327,  961,  315,  317,  317,  317,
      318,  318,  318,  320,  320,  316,  963,  327,  315,  665,
        0,    0,  317,    0,    0,  318,  316,  320,  320,  315,
      327,  316,  316,  327,  327,    0,  315,  317,  317,  317,

      318,  318,  318,  320,  320,  316,  963,  327,    0,  665,
      321,  321,  317,  322,  322,  318,    0,  320,  320,  321,
      323,  321,  322,  964,  321,  323,  323,  322,  324,  324,
      324,    0,  326,  326,  358,  358,  931,  931,  931,  323,
      321,  321,  931,  322,  322,  965,  326,  326,  358,  321,
      323,  321,  322,  964,  321,  323,  323,  322,  324,  324,
      325,  325,  326,  326,  358,  358,  328,  328,  325,  323,
      324,  328,  324,    0,  325,  965,  326,  326,  358,    0,
      328,  330,  330,  330,  673,  673,  673,  329,  324,  324,
      325,  325,    0,  331,  331,  330,  328,  328,  325,  329,

      324,  328,  324,  329,  325,  331,  329,  331,  336,  336,
      328,  330,  330,  330,  338,  338,  966,  329,  336,    0,
      340,  340,  336,  331,  331,  330,  338,    0,  338,  329,
      967,  673,  340,  329,  340,  331,  329,  331,  336,  336,
        0,  341,  341,  968,  338,  338,  966,  342,  336,  341,
      340,  340,  336,    0,  342,  341,  338,  342,  338,    0,
      967,  673,  340,    0,  340,  343,  343,  343,  774,  774,
      774,  341,  341,  968,    0,  344,  344,  342,    0,  341,
      360,  360,  969,  344,  342,  341,  344,  342,    0,  774,
        0,  343,  346,  348,  360,  970,  348,  347,  343,  346,

      348,  343,  346,  348,  347,  344,  344,  347,  346,  347,
      360,  360,  969,  344,    0,    0,  344,    0,  567,  567,
      567,  343,  346,  348,  360,  970,  348,  347,  343,  346,
      348,  343,  346,  348,  347,  349,  972,  347,  346,  347,
        0,  350,  349,  351,  350,  349,  351,  349,  350,  352,
      351,  350,  973,  351,  353,  567,  352,    0,    0,  352,
      355,  353,  567,  976,  353,  349,  972,  355,    0,  355,
      355,  350,  349,  351,  350,  349,  351,  349,  350,  352,
      351,  350,  973,  351,  353,  567,  352,  354,  354,  352,
      355,  353,  567,  976,  353,  354,  356,  355,  354,  355,

      355,  357,  359,  356,  357,    0,  356,    0,  357,  359,
        0,  357,  359,  361,  361,  364,  364,  354,  354,  977,
      362,  362,  362,  978,    0,  354,  356,  361,  354,  364,
      363,  357,  359,  356,  357,  362,  356,  363,  357,  359,
      363,  357,  359,  361,  361,  364,  364,  365,  365,  977,
      362,  362,  362,  978,  365,  982,    0,  361,    0,  364,
      363,  365,  367,  367,    0,  362,  983,  363,  366,  366,
      363,  984,  368,  368,  369,  369,  367,  365,  365,  368,
      370,  370,  366,  366,  365,  982,  368,    0,  369,  370,
      371,  365,  367,  367,  370,    0,  983,  371,  366,  366,

      371,  984,  368,  368,  369,  369,  367,  372,  985,  368,
      370,  370,  366,  366,  372,  373,  368,  372,  369,  370,
      371,  374,  373,    0,  370,  373,  373,  371,  374,    0,
      371,  374,    0,  375,  375,  375,    0,  372,  985,    0,
      794,  794,  794,  376,  372,  373,  986,  372,    0,  990,
      376,  374,  373,  376,    0,  373,  373,    0,  374,  375,
      377,  374,  377,  991,  379,  380,  375,  377,  794,  375,
      377,  379,  380,  376,  379,  380,  986,    0,  379,  990,
      376,    0,    0,  376,  380,  383,  383,  383,  992,  375,
      377,  993,  377,  991,  379,  380,  375,  377,  794,  375,

      377,  379,  380,  381,  379,  380,  382,  382,  379,  994,
      381,  384,  384,  381,  380,  383,  383,  995,  992,  384,
      382,  993,  381,    0,    0,  384,  778,  778,  778,  383,
      388,  388,  387,  381,  387,  387,  382,  382,  778,  994,
      381,  384,  384,  381,  388,  383,  383,  995,  387,  384,
      382,    0,  381,  389,  389,  384,  385,  385,  385,  383,
      388,  388,  387,  392,  387,  387,  971,  389,  390,  390,
      392,  385,  971,  392,  388,  393,  393,  996,  387,    0,
      394,  394,  390,  389,  389,    0,  385,  385,  385,  393,
      395,  395,    0,  392,  394,  997,  971,  389,  390,  390,

      392,  385,  971,  392,  395,  393,  393,  996,  396,  396,
      394,  394,  390,  398,  398,  397,  397,    0,  396,  393,
      395,  395,  396,  397,  394,  997,  998,  398, 1000,  397,
      859,  859,  859, 1001,  395,  399,  399, 1002,  396,  396,
      400,  400,  400,  398,  398,  397,  397,  399,  396,  399,
      403,  403,  396,  397,    0,  400,  998,  398, 1000,  397,
      859,  404,  404, 1001,  403,  399,  399, 1002,  403,    0,
      400,  400,  400,  404, 1006,  404,    0,  399,    0,  399,
      403,  403, 1010,  405,  405,  400,  439,  407,  407, 1011,
      859,  404,  404,  439,  403,  405,  439,  405,  403,  407,

     1012,  407,    0,  404, 1006,  404,  408,  408,  408,  411,
      411,  411, 1010,  405,  405, 1014,  439,  407,  407, 1011,
        0,  412,  412,  439, 1015,  405,  439,  405,    0,  407,
     1012,  407,  413,  413, 1018,  412,  408,  408, 1018,  411,
      411,  414,  414,  414,  415, 1014,  413,  415,  415, 1019,
      408,  412,  412,  411, 1015,    0,  831,  831,  831,  419,
      419,  415,  413,  413, 1018,  412,  408,  408, 1018,  411,
      411,  414,  414,  419,  415,    0,  413,  415,  415, 1019,
      408,  421,  421,  411,  831,  414,  416,  416,  416,  419,
      419,  415,  420,  420,  420,  421,  537,  537,  537,    0,

      416,  414,  414,  419,  426,  426,  426,  422,  422,    0,
        0,  421,  421,    0,  831,  414,  416,  416,  416,  425,
      425,  422,  420,  420,  537,  421,  422,  423,  423,  423,
      416,  425,  440,  425,  426,  426,  420,  422,  422,  440,
      537,  423,  440,  987,  987,  987,  428,  428,  426,  425,
      425,  422,  420,  420,  537,    0,  422,  423,  423,  423,
      428,  425,  440,  425,  426,  426,  420,    0,    0,  440,
      537,  423,  440,  888,  888,  888,  428,  428,  426,  427,
      427,  427,    0,  429,  429,  726,  726,  726,  430,    0,
      428,  430,  430, 1016,  449,  429, 1016,  429,  449,    0,

        0,  449,  888,  431,  449,  430,  431,  431,  427,  879,
      879,  879,  427,  429,  429,  427,  427,  427,  430,  726,
      431,  430,  430, 1016,  449,  429, 1016,  429,  449,  434,
      434,  449,  888,  431,  449,  430,  431,  431,  427,  435,
      435,  434,  427,  434,    0,  427,  427,  427,    0,  726,
      431,  435,  879,  435,  915,  915,  915,    0,    0,  434,
      434,  436,  436,  436,  437,  437, 1020,  441, 1025,  435,
      435,  434,    0,  434,  441, 1030,  436,  441,  437,  437,
      438,  435,  879,  435,  915,  438,  438,  441,  837,  837,
      837,  436,  436,  436,  437,  437, 1020,  441, 1025,  438,

        0,  822,  822,  822,  441, 1030,  436,  441,  437,  437,
      438,  442,  443, 1031,  915,  438,  438,  441,  442,  443,
     1032,  442,  443,  443,  444,  445,  446,  442,  822,  438,
      837,  444,  445,  446,  444,  445,  446,  446,    0, 1033,
      444,  442,  443, 1031,  445,  924,  924,  924,  442,  443,
     1032,  442,  443,  443,  444,  445,  446,  442,  822,    0,
      837,  444,  445,  446,  444,  445,  446,  446,  447, 1033,
      444,    0,  448,    0,  445,  447,    0,    0,  447,  448,
        0,  448,  448,  450,  447,  450, 1034,  452, 1035,  924,
      450,    0,    0,  450,  452,  454,  454,  452,  447,  452,

      453,  453,  448,  454, 1036,  447,  454,  453,  447,  448,
      453,  448,  448,  450,  447,  450, 1034,  452, 1035,  924,
      450,  456,  456,  450,  452,  454,  454,  452, 1037,  452,
      453,  453, 1038,  454, 1036,  456,  454,  453,    0,    0,
      453,  455,  455,  455,  999,  999,  999,  455,    0,  455,
      999,  456,  456,  933,  933,  933,    0,    0, 1037,    0,
        0,  933, 1038, 1040, 1043,  456,  455,  455,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  455,    0, 1040, 1043,    0,  455,  455,  455,  455,

      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  455,  457,  458,  459,  848,  848,  848,  460,  457,
      458,  459,  457,  458,  459,  460,  462,  462,  460,  461,
      458,  463,  974,  974,  974,    0,  461,    0,  463,  461,
      462,  463,  457,  458,  459,  461,    0,    0,  460,  457,
      458,  459,  457,  458,  459,  460,  462,  462,  460,  461,
      458,  463,  848,  473,  473,  473,  461,  465,  463,  461,
      462,  463,  466,  467,  465,  461,  974,  465,  471,  466,
      467, 1044,  466,  467,  472,  471,  475,  475,  471,  473,

      467,  472,  848, 1045,  472, 1046,  473,  465, 1047,  473,
      475,  471,  466,  467,  465, 1049,  974,  465,  471,  466,
      467, 1044,  466,  467,  472,  471,  475,  475,  471,  473,
      467,  472,    0, 1045,  472, 1046,  473,    0, 1047,  473,
      475,  471,  474,  474,  474, 1049,  476,  476,  477,  477,
        0,  896,  896,  896,  476, 1050, 1054,  478,  478,  478,
      476,    0,  477,  477,    0,    0,  480,  480,  474,  474,
        0,    0,  474,  474, 1055,  474,  476,  476,  477,  477,
      480, 1057,  474,    0,  476, 1050, 1054,  478,  478,  896,
      476,  479,  477,  477,  479,  479,  480,  480,  474,  474,

      478,  478,  474,  474, 1055,  474,  482,  482,  479,    0,
      480, 1057,  474,  483,  483, 1058,    0,  478,  478,  896,
      482,  479, 1061,    0,  479,  479,  486,  483,  486,  486,
      478,  478,  484,  484,  484,    0,  482,  482,  479,  485,
      485,  485,  486,  483,  483, 1058, 1017,  484,    0,    0,
      482, 1062, 1061,  485,    0,    0,  486,  483,  486,  486,
        0,    0,  484,  484,  484,  487,  487,  487, 1017,  485,
      485,  485,  486,  488,  488,  488, 1017,  484,  490,  490,
      487, 1062, 1063,  485,  489,  489,  489, 1064,  488,  496,
      496,  496,  490,    0,    0,  487,  487,  487, 1017,  494,

      494, 1065,    0,  488,  488,  488,    0,    0,  490,  490,
      487,    0, 1063,  494,  489,  489,    0, 1064,  488,  496,
      496, 1066,  490,  489,  498,  498,  498, 1068,  489,  494,
      494, 1065,  499,  496,  499,  499,  500,  500,  500,  505,
      505,  505,    0,  494,  489,  489,  502,  502,  499,  496,
      496, 1066, 1069,  489,  498,  498,    0, 1068,  489,    0,
      502,    0,  499,  496,  499,  499,  500,  500,  498,  505,
      505,  504,  504,  504,  507,  507,  502,  502,  499, 1070,
      500, 1071, 1069,  505,  498,  498,  504, 1072,  507,  509,
      502,  506,  506,  506,  509,  509,  500,  500,  498,  505,

      505,  504,  504,  504,  507,  507,  506, 1073,  509, 1070,
      500, 1071,    0,  505,  508,  508,  504, 1072,  507,  509,
     1075,  506,  506,  506,  509,  509,  508, 1078,  508,  510,
        0,    0,  510,  510,  511,  511,  506, 1073,  509,  512,
      512,  721,  721,  721,  508,  508,  510, 1079,  511,    0,
     1075,  513, 1080,  512,  513,  513,  508, 1078,  508,  510,
      514,  514,  510,  510,  511,  511,    0,  721,  513,  512,
      512,    0,  514, 1085,  514,    0,  510, 1079,  511,  515,
      515,  513, 1080,  512,  513,  513, 1086,  515, 1087,    0,
      514,  514, 1089,  515,  516,  516,  516,  721,  513,  517,

      517,  517,  514, 1085,  514,  518,  518, 1092,    0,  515,
      515, 1108,    0,  518,  517,  519, 1086,  515, 1087,  518,
      519,  519, 1089,  515,  516,  516,  892,  892,  892,  517,
      517,  517,  520,    0,  519,  518,  518, 1092,  516,  520,
        0, 1108,  520,  518,  517,  519, 1056, 1056, 1056,  518,
      519,  519,  521,  521,  516,  516,  905,  905,  905,  892,
      521,    0,  520,  521,  519, 1111,  522,  523,  516,  520,
      523,  524,  520,  522,  523,    0,  522,  523,  524,    0,
        0,  524,  521,  521,  525,  525,  526,    0,    0,  892,
      521,  526,  526,  521,  905, 1111,  522,  523,  525,    0,

      523,  524, 1112,  522,  523,  526,  522,  523,  524,  527,
      527,  524,    0,    0,  525,  525,  526,  527,  528,  528,
      528,  526,  526,  527,  905,  667,  667,  667,  525,  529,
      529,  529, 1112,  528, 1113,  526,  934,  934,  934,  527,
      527,  533,  533,  533,  529,    0,    0,  527,  528,  528,
      528, 1114,  531,  527,  531,  531,  533,  934,  667,  529,
      529,  529,    0,  528, 1113, 1116,  534,  534,  531,  667,
        0,  533,  533,  533,  529,  530,  530,  530,    0,  534,
      534, 1114,  531,    0,  531,  531,  533,    0,  667, 1076,
     1076, 1076,  535,  535,    0, 1116,  534,  534,  531,  667,

      530, 1117,  530,  530, 1118, 1120,  535,  548,  530,  534,
      534,  536,  536,  538,  548,  538,  538,  548,  530,  530,
     1121,  530,  535,  535,  536,  536,  539,  539,    0,  538,
      530, 1117,  530,  530, 1118, 1120,  535,  548,  530,    0,
      539,  536,  536,  538,  548,  538,  538,  548,  530,  530,
     1121,  530,  541,  541,  536,  536,  539,  539,  542,  538,
      543,  543, 1122,  542,  542, 1123,  541,  544,  544,  549,
      539,  547,  547, 1124,  543,  541,  549,  542, 1125,  549,
     1126,  544,  541,  541,    0,  547,  551,  551,  542,    0,
      543,  543, 1122,  542,  542, 1123,  541,  544,  544,  549,

      551,  547,  547, 1124,  543, 1127,  549,  542, 1125,  549,
     1126,  544,  550,  550,  550,  547,  551,  551,    0,  552,
      552,  552,  553,  553, 1128,  556,  556,  557,  557,  557,
      551,    0,  558,  558,  552, 1127,  553, 1129,  550,  556,
     1130,  975,  975,  975,    0,  550,  558, 1131,  550,  552,
      552,  552,  553,  553, 1128,  556,  556,  557,  557,  559,
      559,  559,  558,  558,  552,    0,  553, 1129,  550,  556,
     1130,  557,  566,  566,  559,  550,  558, 1131,  550,  560,
      560,  565,  565,  565,  975,    0,  566,  557,  557,  559,
      559,  559, 1132,  560, 1133,  560,    0,  568,  568,  568,

     1134,  557,  566,  566,  559, 1135,  569,  569,  569,  560,
      560,  568,  574,  574,  975,  565,  566,  572,  572,  572,
      565,  569, 1132,  560, 1133,  560,  574,  568,  568,  568,
     1134,  574,  572, 1136, 1138, 1135,  569,  569,  569,  575,
      575,  568,  574,  574,    0,  565, 1139,  572,  572,  572,
      565,  569, 1140,  575,  576,  576,  574,  578,  578,    0,
        0,  574,  572, 1136, 1138,  585, 1141,  586,  576,  575,
      575,  578,  585,  586,  586,  585, 1139,  586,  587,  587,
      590,  590, 1140,  575,  576,  576,    0,  578,  578,  923,
      923,  923,  587, 1146,  590,  585, 1141,  586,  576,  591,

      591,  578,  585,  586,  586,  585, 1147,  586,  587,  587,
      590,  590,    0,  591,  593,  593,  923,  592,  592, 1148,
      594,  594,  587, 1146,  590,  592,  593, 1149,  593,  591,
      591,  592,  594,  923,  594,  595, 1147,    0,  595,  595,
     1142, 1142, 1142,  591,  593,  593,  923,  592,  592, 1148,
      594,  594,  595,  599,  599,  592,  593, 1149,  593,    0,
     1150,  592,  594,  923,  594,  595, 1151,  599,  595,  595,
      596,  596,  596,  597,  597,  597,  598,  598,  598,  610,
      600,  600,  595,  599,  599,  596,  610, 1152,  597,  610,
     1150,  598,  600, 1153,  600,    0, 1151,  599, 1154,    0,

      596,  596,  596,  597,  597,  597,  598,  598,  598,  610,
      600,  600,  601,  601,  601,  596,  610, 1152,  597,  610,
        0,  598,  600, 1153,  600,  602,  602,  601, 1154,  604,
      603,  603,  603,  602,  604,  604,    0,  605,  605,  602,
      606,  606,  601,  601,  601,  603,  605, 1156,  604, 1157,
      608,  605,  608,  608,  606,  602,  602,  601,    0,  604,
      603,  603,  603,  602,  604,  604,  608,  605,  605,  602,
      606,  606,  609,  609,    0,  603,  605, 1156,  604, 1157,
      608,  605,  608,  608,  606,    0,  609,  864,  864,  864,
        0,    0,  613,  613,  613,    0,  608,    0,  614,  614,

      614,    0,  609,  609,  613,    0,  613,  613,  613,  613,
      614,    0,  614,  614,  614,  614,  609,  615,  615,  615,
     1081, 1081, 1081,  616,  616,  616, 1081,  864,    0,  615,
        0,  615,  615,  615,  615,  616,    0,  616,  616,  616,
      616,  631,  631,  614, 1158,  613,  617,  617,  617,    0,
     1162,  614,  616, 1165, 1166,  631,  615,  864,  617,    0,
      617,  617,  617,  617,    0,    0, 1093, 1093, 1093,    0,
      615,  631,  631,  614, 1158,    0,  616,  926,  926,  926,
     1162,    0,  616, 1165, 1166,  631,  615, 1093,  618,  618,
      618, 1051, 1051, 1051,  617,  619,  619,  619,    0,  617,

      618,    0,  618,  618,  618,  618,    0,  619,    0,  619,
      619,  619,  619,  620,  620,  620, 1167,  926,  954,  954,
      954,  621,  621,  621,  617,  620, 1051,  620,  620,  620,
      620,  618, 1168,  621,  619,  621,  621,  621,  621,    0,
        0,  618, 1144, 1144, 1144,  954, 1167,  926,  619, 1169,
      624, 1170,  620,  622,  622,  622, 1051,  624,    0,  621,
      624,  618, 1168,    0,  619,  622,  620,  622,  622,  622,
      622,  623,  623,  623,  621,  954,    0,    0,  622, 1169,
      624, 1170,  620, 1171,  625, 1144,  627,  624,  626,  621,
      624,  625,  626,  627,  625,  626,  627,  623,  626, 1172,

      625, 1173,  627, 1174,  623,    0,  622,  623,  622,  628,
      628,  628,    0, 1171,  625, 1144,  627,    0,  626,    0,
     1175,  625,  626,  627,  625,  626,  627,  623,  626, 1172,
      625, 1173,  627, 1174,  623,  628,    0,  623,  629,  629,
      635,  635,  628,  644,  644,  628,  629,  645,  645,  629,
     1175,  646,  646,  646,  635, 1176, 1177,  644,  648,  648,
      648,  645, 1083, 1083, 1083,  628,  646,    0,  629,  629,
      635,  635,  628,  644,  644,  628,  629,  645,  645,  629,
        0,  646,  646,  646,  635, 1176, 1177,  644,  648,  648,
     1178,  645,  650,  650,  650,    0,  646,  647,  647,  647,

      649,  649,  648, 1179,    0,  649, 1083,  650,  652,  652,
      652, 1180,  656,  656,  649, 1027, 1027, 1027,  648,  648,
     1178,    0,  650,  650,  650,  647,  656, 1181,  656,  647,
      649,  649,  648, 1179,  647,  649, 1083,  650,  652,  652,
      647, 1180,  656,  656,  649, 1182,  647,  653,  653, 1082,
     1082, 1082,  652, 1027,    0,  647,  656, 1181,  656,  647,
      653,  653, 1184,    0,  647, 1185,  654,    0,  652,  652,
      647,  654,  654, 1186,  655, 1182,  647,  653,  653,  655,
      655,    0,  652, 1027, 1082,  654,  657,  657,  657,    0,
      653,  653, 1184,  655,    0, 1185,  654,  658,  658,  658,

        0,  654,  654, 1186,  655,    0,  659,  659,    0,  655,
      655,  663,  663,  663, 1082,  654,  657,  657,  674,  674,
      659,  659, 1187,  655,  658,    0,  674, 1189,  658, 1190,
      657, 1191,  674,  658, 1192,  658,  659,  659,  668,  668,
      668,  663,  663, 1104, 1104, 1104,  657,  657,  674,  674,
      659,  659, 1187, 1193,  658,  663,  674, 1189,  658, 1190,
      657, 1191,  674,  658, 1192,  658,    0, 1194,  668,  668,
        0,  663,  663,  671,  671,  671,  672,  672,  672,  675,
      675,  675,  668, 1193,    0,  663,  676, 1104,  671, 1094,
     1094, 1094,    0,  676,  675, 1094,  676, 1194,  668,  668,

      678,  678,    0,  671,  671,  671,  672,  672, 1195,  675,
      675,  675,  668, 1196,  678,  677,  676, 1104,  671,    0,
      672, 1197,  677,  676,  675,  677,  676,  677,  680,  680,
      678,  678,  679,  679,  679,  681,  672,  672, 1195, 1199,
      681,  681,  680, 1196,  678,  677,    0,  817,  817,  817,
      672, 1197,  677, 1201,  681,  677,    0,  677,  680,  680,
      682,  682,  679,  679,    0,  681,  684,  684,  684, 1199,
      681,  681,  680,  817,  682,  682,  679,    0,    0, 1202,
        0,  685,  685, 1201,  681,  686,  686,  687,  687,  817,
      682,  682,  679,  679,  687,  685,  684,  684,  686,  686,

     1203,  687,    0,  817,  682,  682,  679,  689,  689, 1202,
      684,  685,  685,  688,    0,  686,  686,  687,  687,  817,
      688,  689, 1205,  688,  687,  685,  684,  684,  686,  686,
     1203,  687,  690,  690,  690,  691,  691,  689,  689, 1206,
      684,  692,  692,  688,  694,    0,    0,  694,  694,  691,
      688,  689, 1205,  688, 1207,  692,  693,  693, 1210,  695,
      695,  694,  690,  690,    0,  691,  691,  695,    0, 1206,
      693,  692,  692,  695,  694,  693,  690,  694,  694,  691,
      696,  696,  696,    0, 1207,  692,  693,  693, 1210,  695,
      695,  694,  690,  690, 1143, 1143, 1143,  695,  706,  706,

      693, 1211, 1212,  695, 1213,  693,  690,  704,  704,  704,
      696,  696,  706,  707, 1209, 1209, 1209, 1215,    0, 1216,
      707,    0,  704,  707,  696,    0,  709,    0,  706,  706,
     1143, 1211, 1212,  709, 1213, 1219,  709,  704,  704,  704,
      696,  696,  706,  707,  713,  713,  713, 1215,  708, 1216,
      707,  708,  704,  707,  696,  708,  709,  712,  708,    0,
     1143,  716,  716,  709,  712, 1219,  709,  712,  716, 1221,
      713,  716,  719, 1222, 1222, 1222,  720,  713,  708,  719,
      713,  708,  719,  720,  719,  708,  720,  712,  708,  720,
        0,  716,  716, 1223,  712,    0, 1225,  712,  716, 1221,

      713,  716,  719,  723,  723,  723,  720,  713,  722,  719,
      713,    0,  719,  720,  719,  722,  720,  728,  722,  720,
      727,  727,  727, 1223,  728,  740, 1225,  728,    0,  723,
        0,    0,  740,  728, 1228,  740,  723,    0,  722,  723,
        0,  729,  729,    0,    0,  722,  727,  728,  722,  729,
      738,  738,  729,  727,  728,  740,  727,  728,  738,  723,
      739,  738,  740,  728, 1228,  740,  723,  739,    0,  723,
      739,  729,  729,  742,  742,  742,  727,  739,    0,  729,
      738,  738,  729,  727, 1230,    0,  727,    0,  738,    0,
      739,  738,    0,    0,  751,  751, 1232,  739,  791,  742,

      739,  751,  752,  752,  751,  791,  742,  739,  791,  742,
      752,    0, 1234,  752, 1230,  753,  753,  753, 1009, 1009,
     1009, 1231, 1231, 1231,  751,  751, 1232,    0,  791,  742,
        0,  751,  752,  752,  751,  791,  742,    0,  791,  742,
      752,  753, 1234,  752,  756,  756,  758,  758,  753,  759,
      759,  753,  757,  757,  757, 1009,  760,  760,  756, 1236,
      758,    0,    0,  759, 1237,  758, 1231,  757,  760,    0,
      760,  753,    0,    0,  756,  756,  758,  758,  753,  759,
      759,  753,  757,  757,  757, 1009,  760,  760,  756, 1236,
      758,  761,  761,  759, 1237,  758, 1231,  757,  760,  761,

      760,  762,  762,  762, 1239,  761,  763,  763,  763,  764,
      766,  766,  764,  764, 1240,    0,  765,  765,  765, 1242,
        0,  761,  761, 1245,  766,    0,  764, 1257,    0,  761,
        0,  762,  762,    0, 1239,  761,  763,  763,    0,  764,
      766,  766,  764,  764, 1240,  762,  765,  765,    0, 1242,
      763,  767,  767, 1245,  766,  768,  764, 1257,  768,  768,
      765,  762,  762, 1013, 1013,  767,  763,  763, 1241, 1241,
     1241, 1013,  768, 1260,    0,  762,  765,  765,  771,  771,
      763,  767,  767,  772,  772,  768,  769,  769,  768,  768,
      765,  773,  771, 1013, 1013,  767,    0,  772,  769, 1263,

      769, 1013,  768, 1260,  773,  773,    0,    0,  771,  771,
     1304, 1304, 1304,  772,  772,    0,  769,  769,  773, 1264,
        0,    0,  771, 1265,  779,  779,  779,  772,  769, 1263,
      769, 1246, 1246, 1246,  773,  773,  779, 1246,  779,  779,
      779,  779,  780,  780,  780,  790,  790,    0,  773, 1264,
      781,  781,  781, 1265,  780,    0,  780,  780,  780,  780,
      790,  790,  781, 1266,  781,  781,  781,  781,  782,  782,
      782, 1268,  780,    0,  790,  827,  827,  779,    0, 1269,
      782,    0,  782,  782,  782,  782,    0, 1272,  781,  827,
      790,  790,    0, 1266,  782,  780,  783,  783,  783,    0,

        0, 1268,  780,  781,  790,  827,  827, 1273,  783, 1269,
      783,  783,  783,  783,  784,  784,  784, 1272,  781,  827,
     1274,  782, 1183, 1183,  782, 1275,  784,    0,  784,  784,
      784,  784, 1183, 1183, 1183, 1183,  783, 1273, 1276,    0,
     1277,  793,  785,  785,  785, 1318, 1318, 1318,  793,  783,
     1274,  793,  793,  784,  785, 1275,  785,  785,  785,  785,
      786,  786,  786, 1278, 1279,    0,  783,  784, 1276,  785,
     1277,  793,  786,    0,  786,  786,  786,  786,  793,    0,
        0,  793,  793,  784,  843,  843,  844,  844,    0,    0,
      787,  787,  787, 1278, 1279,  785,    0,    0,  843,  785,

      844, 1280,  787,  786,  787,  787,  787,  787,  788,  788,
      788, 1281,    0,  786,  843,  843,  844,  844,  787,  795,
      788, 1282,  788,  788,  788,  788,  795,  792,  843,  795,
      844, 1280, 1283,  786,  792,  806, 1284,  792,  806,  792,
      807, 1281,  806,  787,  788,  806, 1285,  807,  787,  795,
      807, 1282,  796,  796,    0,    0,  795,  792,    0,  795,
      796,  788, 1283,  796,  792,  806, 1284,  792,  806,  792,
      807,  818,  806, 1286,  788,  806, 1285,  807,  818,    0,
      807,  818,  796,  796,  814,  814,  814, 1214, 1214, 1214,
      796, 1287,    0,  796,  813,  813,  813,  815,  815,  815,

        0,  818,  819, 1286, 1289,    0, 1290,    0,  818,  819,
      814,  818,  819, 1341, 1341, 1341,    0,  814,  819, 1291,
      814, 1287,  813,  815, 1214, 1292,  813, 1294,  820,    0,
      815,  813,  819,  815, 1289,  820, 1290,  813,  820,  819,
      814,    0,  819,  813,  840,  840,  840,  814,  819, 1291,
      814,  820,  813,  815, 1214, 1292,  813, 1294,  820,  821,
      815,  813,  821,  815, 1295,  820,  821,  813,  820,  821,
      841,  841,  841,  813,  840,  840,  846,  846,  845, 1298,
        0,  820,    0,  845,  845,  847,  847,  847,  840,  821,
      846, 1299,  821,    0, 1295,    0,  821,  845,  841,  821,

      847, 1288, 1288, 1288,  840,  840,  846,  846,  845, 1298,
      841,  849,  849,  845,  845,  847,  847,  847,  840,  850,
      846, 1299, 1042, 1042, 1042,  849,  850,  845,  841,  850,
      847,  854,  854,  854,    0, 1300,  851,    0, 1301,  851,
      841,  849,  849,  851, 1288, 1302,  851,    0,    0,  850,
     1303,  855, 1042,  857,  855,  849,  850,  854,  855,  850,
      857,  855, 1042,  857,  854, 1300,  851,  854, 1301,  851,
     1305, 1306,    0,  851, 1288, 1302,  851,  853,  853,  853,
     1303,  855, 1042,  857,  855, 1307, 1310,  854,  855, 1312,
      857,  855, 1042,  857,  854, 1313,  856,  854,    0,  856,

     1305, 1306,  853,  856,  853,  853,  856,  853,    0,    0,
      853,    0,  858,  858,  858, 1307, 1310,  853,    0, 1312,
      853,  853,  853,  853,    0, 1313,  856,  862,  862,  856,
      863,  863,  853,  856,  853,  853,  856,  853,  858,  860,
      853,  862,  860, 1314,  863,  858,  860,  853,  858,  860,
      853,  853,  853,  853,  861,  861,  861,  862,  862,    0,
      863,  863,  876,  876,  876,  885,  885,  885,  858,  860,
     1315,  862,  860, 1314,  863,  858,  860,    0,  858,  860,
      861,  873, 1316,  873,  873,  875,  875,  861,  882,  882,
      861,    0,  876,  876,  893,  885,  885,  873, 1317,  875,

     1315,  875,  882, 1346, 1346, 1346,  876,  893,  893,  885,
      861,  873, 1316,  873,  873,  875,  875,  861,  882,  882,
      861,  893,  876,  876, 1319,  885,  885,  873, 1317,  875,
        0,  875,  882,  886,  886,  894,  876,  893,  893,  885,
        0,  886,  894,  902, 1320,  894,    0,  886,  903,    0,
      902,  893, 1321,  902, 1319,  903,    0, 1322,  903,  902,
      913,    0,    0,  886,  886,  894,    0,  913,    0,  919,
      913,  886,  894,  902, 1320,  894,  919,  886,  903,  919,
      902,    0, 1321,  902, 1323,  903,  914, 1322,  903,  902,
      913,  922,  922,  914, 1324, 1325,  914,  913,  922,  919,

      913,  922,  914,  918,  918,  918,  919,    0,    0,  919,
        0,  920,  920,  920, 1323,    0,  914,  921,  921,  921,
        0,  922,  922,  914, 1324, 1325,  914,    0,  922,  918,
     1326,  922,  914,    0, 1327,  925,  918,  920,  925,  918,
      948,  948,  925,  921,  920,  925, 1328,  920,  927,    0,
      921, 1329, 1330,  921,  948,  927,    0,  927,  927,  918,
     1326, 1293, 1293, 1293, 1327,  925,  918,  920,  925,  918,
      948,  948,  925,  921,  920,  925, 1328,  920,  927,  928,
      921, 1329, 1330,  921,  948,  927,  928,  927,  927,  928,
      935,  935,  935,    0, 1293, 1331,  936,  936,  936, 1335,

      928, 1336,  935,    0,  935,  935,  935,  935,  936,  928,
      936,  936,  936,  936, 1337, 1338,  928,    0,    0,  928,
      935,  937,  937,  937, 1293, 1331, 1357, 1357, 1357, 1335,
      928, 1336,    0,  937, 1339,  937,  937,  937,  937,  936,
      938,  938,  938,  935, 1337, 1338,  939,  939,  939,  936,
      935, 1340,  938, 1342,  938,  938,  938,  938,  939, 1343,
      939,  939,  939,  939, 1339, 1345,  937, 1217, 1217,  936,
     1366, 1366, 1366, 1366,  937, 1217,  938, 1217, 1217, 1217,
     1217, 1340,  939, 1342,    0,    0,  940,  940,  940, 1343,
     1369, 1369, 1369,  938,    0, 1345,  937, 1347,  940,  939,

      940,  940,  940,  940,    0, 1349,  938, 1350,  941,  941,
      941, 1351,  939,    0,  942,  942,  942, 1426, 1426, 1426,
      941,  940,  941,  941,  941,  941,  942, 1347,  942,  942,
      942,  942,  943,  943,  943, 1349,    0, 1350, 1352,  940,
        0, 1351, 1353,  942,  943,    0,  943,  943,  943,  943,
      947,  940,  941,    0, 1243, 1243, 1243,  947,    0, 1354,
      947,  941, 1358,  947,  949,  949,  949,  942, 1352,  951,
      951,    0, 1353,  942,  952,  952, 1359,  943,  951,  949,
      947,  952,  941,  951,    0,  943,    0,  947,  952, 1354,
      947,    0, 1358,  947,  949,  949,  949,    0,    0,  951,

      951, 1243,  962,  962,  952,  952, 1359,  943,  951,  949,
     1360,  952,    0,  951,  962,    0,  962,    0,  952,    0,
      979,  979,  980,  980, 1361,  981,  981,  988,  988,  988,
     1363, 1243,  962,  962,  979, 1004,  980,  981, 1368,  981,
     1360,    0, 1004,    0,  962, 1004,  962, 1003, 1003, 1003,
      979,  979,  980,  980, 1361,  981,  981,  988,  988,    0,
     1363, 1372, 1003, 1373,  979, 1004,  980,  981, 1368,  981,
        0,  988, 1004, 1005, 1007, 1004,    0, 1003, 1003, 1003,
     1005, 1007,    0, 1005, 1007,    0, 1007,  988,  988, 1005,
        0, 1372, 1003, 1373, 1008, 1008, 1008,    0, 1021, 1021,

     1021,  988, 1022, 1005, 1007, 1375, 1023, 1376, 1028, 1022,
     1005, 1007, 1022, 1005, 1007, 1028, 1007, 1377, 1028, 1005,
     1008,    0, 1378, 1024, 1024, 1024, 1023, 1008, 1021, 1379,
     1008,    0, 1022, 1023, 1380, 1375, 1023, 1376, 1028, 1022,
     1021,    0, 1022, 1382, 1029, 1028,    0, 1377, 1028,    0,
     1008, 1029, 1378,    0, 1029, 1026, 1023, 1008, 1021, 1379,
     1008, 1024, 1026, 1023, 1380, 1026, 1023, 1024, 1024, 1039,
     1021, 1026, 1383, 1382, 1029,    0, 1039, 1385, 1386, 1039,
     1041, 1029,    0, 1041, 1029, 1026, 1052, 1041,    0, 1394,
     1041, 1024, 1026, 1052, 1060, 1026, 1052, 1024, 1024, 1039,

     1397, 1026, 1383,    0,    0, 1048, 1039, 1385, 1386, 1039,
     1041,    0, 1048, 1041, 1060, 1048, 1052, 1041, 1048, 1394,
     1041, 1060, 1067, 1052, 1060, 1400, 1052, 1077, 1402, 1067,
     1397, 1088, 1067, 1084, 1077, 1048, 1084, 1077, 1088, 1403,
     1084, 1088, 1048, 1084, 1060, 1048,    0, 1404, 1048,    0,
     1405, 1060, 1067,    0, 1060, 1400,    0, 1077, 1402, 1067,
        0, 1088, 1067, 1084, 1077,    0, 1084, 1077, 1088, 1403,
     1084, 1088, 1406, 1084, 1090, 1090, 1090, 1404, 1091, 1091,
     1405,    0, 1095, 1095, 1095, 1106, 1091, 1409, 1410, 1091,
     1109, 1109, 1106, 1411, 1095, 1106, 1095, 1095, 1095, 1095,

     1090,    0, 1406,    0, 1109,    0, 1412, 1090, 1091, 1091,
     1090, 1095, 1096, 1096, 1096, 1106, 1091, 1409, 1410, 1091,
     1109, 1109, 1106, 1411, 1096, 1106, 1096, 1096, 1096, 1096,
     1090, 1097, 1097, 1097, 1109, 1095, 1412, 1090,    0,    0,
     1090, 1095,    0, 1097,    0, 1097, 1097, 1097, 1097, 1427,
     1427, 1427, 1098, 1098, 1098, 1414, 1096,    0, 1099, 1099,
     1099,    0, 1097,    0, 1098, 1096, 1098, 1098, 1098, 1098,
     1099,    0, 1099, 1099, 1099, 1099, 1415, 1098,    0, 1100,
     1100, 1100, 1416, 1099, 1097, 1414, 1096, 1101, 1101, 1101,
        0, 1100, 1097, 1100, 1100, 1100, 1100, 1417,    0, 1101,

        0, 1101, 1101, 1101, 1101, 1098, 1415, 1098, 1102, 1102,
     1102, 1099, 1416, 1099, 1103, 1103, 1103,    0, 1101, 1418,
     1102, 1419, 1102, 1102, 1102, 1102, 1103, 1417, 1103, 1103,
     1103, 1103, 1100, 1105, 1105, 1107, 1420,    0,    0, 1421,
     1101, 1105, 1107, 1103, 1105, 1107, 1110, 1110, 1101, 1418,
     1102, 1419, 1107, 1119, 1119, 1119, 1110, 1137, 1137, 1137,
     1110, 1102,    0, 1105, 1105, 1107, 1420, 1103, 1119, 1421,
        0, 1105, 1107, 1103, 1105, 1107, 1110, 1110, 1422,    0,
     1102,    0, 1107, 1119, 1119, 1119, 1110, 1137, 1137, 1423,
     1110, 1159, 1159, 1160, 1160, 1161, 1161, 1424, 1119, 1163,

     1163, 1137, 1425, 1159, 1428, 1159, 1429, 1160, 1422, 1161,
     1164, 1164, 1164, 1163, 1188, 1188, 1430, 1137, 1137, 1423,
        0, 1159, 1159, 1160, 1160, 1161, 1161, 1424, 1188, 1163,
     1163, 1137, 1425, 1159, 1428, 1159, 1429, 1160, 1164, 1161,
     1431, 1200, 1200, 1163, 1188, 1188, 1430, 1208, 1208, 1238,
     1238, 1434, 1244, 1244, 1164, 1200,    0,    0, 1188, 1208,
     1435, 1208, 1238, 1238, 1244, 1436, 1244, 1437, 1164, 1442,
     1431, 1200, 1200, 1356, 1356, 1356,    0, 1208, 1208, 1238,
     1238, 1434, 1244, 1244, 1164, 1200, 1248, 1248, 1248, 1208,
     1435, 1208, 1238, 1238, 1244, 1436, 1244, 1437, 1248, 1442,

     1248, 1248, 1248, 1248, 1249, 1249, 1249, 1441, 1441, 1441,
     1250, 1250, 1250, 1356, 1443,    0, 1249,    0, 1249, 1249,
     1249, 1249, 1250,    0, 1250, 1250, 1250, 1250, 1248, 1445,
     1440, 1440, 1440, 1251, 1251, 1251, 1460, 1460, 1460, 1248,
     1253, 1253, 1253, 1356, 1443, 1251, 1249, 1251, 1251, 1251,
     1251, 1440, 1253, 1252, 1252, 1252,    0, 1249, 1248, 1445,
        0, 1446, 1447, 1250, 1448, 1252, 1251, 1252, 1252, 1252,
     1252, 1334,    0, 1254, 1254, 1254, 1249, 1253, 1334, 1334,
     1334, 1334,    0, 1449,    0, 1254, 1251, 1254, 1254, 1254,
     1254, 1446, 1447,    0, 1448,    0, 1251, 1252, 1258, 1258,

     1450, 1452, 1255, 1255, 1255,    0, 1252, 1253, 1256, 1256,
     1256,    0, 1258, 1449, 1255, 1254, 1255, 1255, 1255, 1255,
     1256,    0, 1256, 1256, 1256, 1256, 1254, 1252, 1258, 1258,
     1450, 1452, 1453, 1259, 1259, 1261, 1261, 1454, 1255, 1262,
     1262, 1270, 1258, 1270, 1270, 1254, 1259, 1259, 1455, 1261,
     1370, 1370, 1370, 1262,    0, 1255, 1370, 1270, 1309, 1309,
        0, 1256, 1453, 1259, 1259, 1261, 1261, 1454, 1255, 1262,
     1262, 1270, 1309, 1270, 1270,    0, 1259, 1259, 1455, 1261,
     1311, 1311,    0, 1262, 1355, 1355,    0, 1270, 1309, 1309,
     1370, 1367, 1370, 1456, 1311, 1457, 1367, 1458, 1355, 1459,

     1367, 1367, 1309, 1367, 1367, 1367, 1367, 1367,    0,    0,
     1311, 1311, 1381, 1381, 1355, 1355, 1384, 1384, 1384,    0,
     1370,    0, 1370, 1456, 1311, 1457, 1381, 1458, 1355, 1459,
     1461,    0, 1387, 1463, 1387, 1387,    0, 1389, 1389, 1389,
     1470,    0, 1381, 1381,    0, 1471, 1384, 1472, 1387, 1389,
        0, 1389, 1389, 1389, 1389,    0, 1381, 1390, 1390, 1390,
     1461, 1384, 1387, 1463, 1387, 1387, 1389, 1474,    0, 1390,
     1470, 1390, 1390, 1390, 1390, 1471, 1384, 1472, 1387, 1464,
     1464, 1464, 1390, 1391, 1391, 1391, 1392, 1392, 1392, 1475,
     1389, 1384, 1393, 1393, 1393, 1391, 1389, 1474, 1392,    0,

     1392, 1392, 1392, 1392, 1393,    0, 1393, 1393, 1393, 1393,
     1390,    0, 1390, 1391,    0, 1395, 1395, 1395,    0, 1475,
     1499, 1499, 1499, 1499, 1392, 1393,    0, 1395,    0, 1395,
     1395, 1395, 1395,    0, 1396, 1396, 1396,    0,    0, 1392,
     1451, 1451, 1451, 1391, 1395, 1393, 1396, 1477, 1396, 1396,
     1396, 1396, 1398, 1398, 1392, 1393, 1399,    0, 1407, 1407,
     1478, 1399, 1399, 1476, 1476, 1476, 1398, 1396, 1395,    0,
     1451, 1479, 1407, 1481, 1395, 1399, 1482, 1477,    0,    0,
     1451,    0, 1398, 1398,    0,    0, 1399, 1396, 1407, 1407,
     1478, 1399, 1399, 1476, 1483, 1486, 1398, 1396, 1487, 1469,

     1451, 1479, 1407, 1481, 1469, 1399, 1482, 1488, 1469, 1469,
     1451, 1469, 1469, 1469, 1469, 1469, 1480, 1480, 1480, 1489,
     1489, 1489, 1491, 1476, 1483, 1486, 1492, 1493, 1487,    0,
        0, 1498, 1501, 1501, 1501, 1501,    0, 1488, 1498, 1498,
     1498, 1498, 1503, 1503, 1503, 1503, 1505, 1505, 1505, 1480,
     1502, 1507, 1491, 1508, 1510, 1502, 1492, 1493, 1489, 1502,
     1502, 1512, 1502, 1502, 1502, 1502, 1502, 1506, 1506, 1506,
     1509, 1509, 1509, 1513, 1514, 1516, 1517,    0, 1518, 1480,
     1505, 1507, 1519, 1508, 1510, 1520, 1522,    0, 1489,    0,
     1526, 1512, 1523, 1523, 1523, 1529, 1573, 1573, 1573,    0,

     1534,    0,    0, 1513, 1514, 1516, 1517, 1506, 1518, 1506,
     1505,    0, 1519,    0, 1535, 1520, 1522, 1524, 1524, 1524,
     1526, 1537, 1523, 1523, 1538, 1529, 1525, 1525, 1525, 1524,
     1534, 1524, 1524, 1524, 1524, 1539, 1523, 1506, 1525, 1506,
     1525, 1525, 1525, 1525, 1535, 1524, 1527, 1527, 1527,    0,
        0, 1537, 1523, 1523, 1538, 1599, 1599, 1599, 1527, 1525,
     1527, 1527, 1527, 1527,    0, 1539, 1523,    0, 1540,    0,
     1524, 1528, 1528, 1528, 1542, 1524, 1533, 1533, 1545, 1525,
     1530, 1530, 1530, 1528, 1546, 1528, 1528, 1528, 1528, 1525,
     1533, 1547, 1530,    0, 1530, 1530, 1530, 1530, 1540, 1527,

     1549, 1531, 1531, 1531, 1542, 1550, 1533, 1533, 1545,    0,
     1528, 1554, 1555, 1531, 1546, 1531, 1531, 1531, 1531, 1558,
     1533, 1547, 1561, 1530, 1528, 1556, 1556, 1556, 1562, 1563,
     1549, 1565, 1568, 1530,    0, 1550, 1557, 1557, 1557, 1531,
     1528, 1554, 1555, 1566, 1566, 1566, 1567, 1567, 1567, 1558,
     1569, 1570, 1561, 1530, 1531, 1571, 1572,    0, 1562, 1563,
     1574, 1565, 1568, 1575, 1556, 1576, 1577, 1567, 1578, 1531,
     1579, 1581, 1582, 1566, 1583, 1557, 1584, 1586, 1586, 1586,
     1569, 1570, 1587, 1588, 1597, 1571, 1572, 1566, 1600, 1601,
     1574,    0,    0, 1575, 1556, 1576, 1577,    0, 1578,    0,

     1579, 1581, 1582, 1566, 1583, 1557, 1584, 1589, 1589, 1589,
     1602,    0, 1587, 1588, 1597, 1603, 1605, 1566, 1600, 1601,
     1607, 1586, 1591, 1591, 1591, 1591, 1592, 1592, 1592, 1592,
     1593, 1593, 1593, 1593, 1594, 1589, 1595, 1595, 1595, 1595,
     1602, 1594, 1594, 1594, 1594, 1603, 1605, 1608, 1609, 1610,
     1607, 1586, 1611, 1612, 1613, 1614, 1614, 1614, 1615, 1617,
     1622, 1622, 1622, 1618,    0, 1589, 1617, 1617, 1617, 1617,
     1618, 1618, 1618, 1618, 1621, 1623, 1624, 1608, 1609, 1610,
     1625, 1626, 1611, 1612, 1613, 1628, 1620, 1629, 1615, 1619,
     1619, 1619, 1619, 1620, 1620, 1620, 1620, 1620, 1630, 1632,

     1622, 1633, 1622, 1635, 1621, 1623, 1624, 1627, 1627, 1627,
     1625, 1626, 1637,    0,    0, 1628,    0, 1629, 1638, 1638,
     1638, 1641, 1639, 1639, 1639,    0, 1644,    0, 1630, 1632,
     1622, 1633, 1622, 1635, 1639, 1648, 1639, 1639, 1639, 1639,
        0,    0, 1637, 1640, 1640, 1640, 1638, 1647, 1647, 1647,
     1627, 1641, 1642, 1642, 1642, 1640, 1644, 1640, 1640, 1640,
     1640,    0, 1647, 1649, 1642, 1648,    0, 1651, 1655, 1657,
     1643, 1643, 1643,    0,    0, 1639, 1638, 1647, 1647, 1647,
     1627, 1640, 1643, 1659, 1643, 1643, 1643, 1643, 1645, 1645,
     1645, 1642, 1647, 1649, 1660, 1661, 1640, 1651, 1655, 1657,

     1645,    0, 1645, 1645, 1645, 1645, 1662, 1663, 1643, 1665,
     1667, 1640,    0, 1659,    0,    0, 1646, 1646, 1646, 1668,
     1670, 1642, 1671, 1643, 1660, 1661, 1675, 1677, 1646, 1645,
     1646, 1646, 1646, 1646, 1679, 1680, 1662, 1663, 1643, 1665,
     1667, 1645, 1664, 1664, 1664, 1646, 1669, 1669, 1669, 1668,
     1670, 1681, 1671, 1672, 1672, 1672, 1675, 1677, 1682, 1645,
        0, 1678, 1678, 1678, 1679, 1680, 1683,    0, 1684, 1646,
     1685, 1686, 1686, 1686, 1688, 1646, 1669, 1687, 1687, 1687,
     1689, 1681, 1692, 1672, 1690, 1690, 1690,    0, 1682, 1700,
     1669, 1678, 1691, 1691, 1691,    0, 1683, 1672, 1684,    0,

     1685,    0, 1701,    0, 1688,    0, 1669, 1699, 1699, 1699,
     1689,    0, 1692, 1672, 1693, 1693, 1693, 1693, 1702, 1700,
     1669, 1678, 1694, 1694, 1694, 1694, 1695, 1672, 1697, 1697,
     1697, 1697, 1701, 1695, 1695, 1695, 1695, 1696, 1704, 1704,
     1704, 1696, 1705, 1706, 1696, 1696, 1696, 1696, 1702, 1707,
     1709, 1699, 1712, 1712, 1712, 1716, 1719, 1719, 1719, 1719,
     1720, 1721, 1716, 1716, 1716, 1716, 1716, 1722, 1723, 1725,
     1726, 1727, 1705, 1706, 1728, 1731, 1733, 1718,    0, 1707,
     1709, 1699, 1718,    0, 1718, 1718, 1718, 1718, 1718, 1712,
     1720, 1721, 1736,    0, 1737,    0,    0, 1722, 1723, 1725,

     1726, 1727, 1737,    0, 1728, 1731, 1733, 1743, 1734, 1734,
     1734, 1735, 1735, 1735, 1739, 1739, 1739,    0,    0, 1712,
     1734,    0, 1736, 1735, 1737, 1735, 1735, 1735, 1735, 1742,
     1742, 1744, 1737, 1738, 1738, 1738,    0, 1743, 1745, 1745,
     1745, 1748, 1749, 1742, 1734, 1738,    0, 1738, 1738, 1738,
     1738, 1740, 1740, 1740, 1751, 1735, 1750, 1750, 1750, 1742,
     1742, 1744,    0, 1740, 1735, 1740, 1740, 1740, 1740, 1752,
     1754, 1748, 1749, 1742, 1734, 1757, 1741, 1741, 1741, 1753,
     1753, 1753,    0, 1758, 1751, 1735, 1738, 1740, 1741, 1760,
     1741, 1741, 1741, 1741, 1759, 1759, 1759, 1761, 1762, 1752,

     1754, 1763, 1764, 1766, 1740, 1757, 1765, 1765, 1765, 1767,
     1768, 1769, 1753, 1758, 1770,    0,    0, 1740, 1775, 1760,
     1771, 1771, 1771, 1778, 1759,    0,    0, 1761, 1762, 1741,
        0, 1763, 1764, 1766, 1772, 1772, 1772, 1785, 1759, 1767,
     1768, 1769, 1753,    0, 1770, 1773, 1773, 1773, 1775, 1776,
     1776, 1776,    0, 1778, 1759, 1777, 1777, 1777, 1782, 1782,
     1782, 1782, 1786, 1788, 1783, 1790, 1791, 1785, 1759, 1793,
     1773, 1783, 1783, 1783, 1783, 1795, 1776, 1772,    0, 1789,
     1789, 1789, 1776, 1777, 1798, 1798, 1798, 1798, 1799, 1799,
     1799, 1799, 1786, 1788,    0, 1790, 1791, 1802, 1803, 1793,

     1773, 1801, 1801, 1801, 1801, 1795, 1776, 1772, 1789, 1797,
     1806, 1807, 1776, 1777, 1797, 1800, 1797, 1797, 1797, 1797,
     1797, 1808, 1800, 1800, 1800, 1800, 1800, 1802, 1803, 1804,
     1804, 1804, 1809, 1811, 1812, 1814, 1814, 1814, 1789, 1815,
     1806, 1807, 1813, 1813, 1813, 1818, 1818, 1818, 1817, 1817,
     1817, 1808,    0,    0, 1813,    0, 1813, 1813, 1813, 1813,
     1817, 1824, 1809, 1811, 1812, 1819, 1819, 1819,    0, 1815,
     1825, 1820, 1820, 1820,    0, 1817, 1817, 1819, 1827, 1819,
     1819, 1819, 1819, 1820, 1828, 1813, 1823, 1823, 1823, 1818,
     1817, 1824, 1817, 1829, 1831, 1813, 1832, 1833, 1823, 1834,

     1825, 1837, 1826, 1826, 1826, 1817, 1817, 1840, 1827, 1841,
     1820, 1836, 1836, 1836, 1828, 1813,    0,    0, 1819, 1818,
     1817, 1845, 1817, 1829, 1831, 1846, 1832, 1833, 1847, 1834,
     1848, 1837, 1838, 1838, 1838,    0, 1849, 1840, 1850, 1841,
     1820, 1826, 1842, 1842, 1842, 1844, 1844, 1844, 1851,    0,
        0, 1845, 1873, 1873, 1873, 1846,    0, 1861, 1847,    0,
     1848, 1853, 1853, 1853, 1853, 1838, 1849, 1863, 1850, 1864,
     1865, 1826, 1854, 1854, 1854, 1854, 1866, 1867, 1851, 1856,
     1856, 1856, 1856, 1858, 1858, 1858, 1858, 1861, 1844, 1859,
     1859, 1859, 1859,    0, 1868, 1838,    0, 1863, 1875, 1864,

     1865, 1868, 1868, 1868, 1868, 1868, 1866, 1867, 1874, 1874,
     1874, 1876, 1869, 1879, 1880, 1874, 1870,    0, 1844, 1869,
     1869, 1869, 1869, 1870, 1870, 1870, 1870, 1885, 1875, 1882,
     1882, 1882, 1884, 1881, 1881, 1881, 1886, 1887, 1884, 1888,
     1892, 1876, 1894, 1879, 1880, 1881, 1890, 1881, 1881, 1881,
     1881, 1889, 1889, 1889, 1890, 1895,    0, 1885, 1891, 1891,
     1891, 1896, 1884, 1889,    0, 1898, 1886, 1887, 1884, 1888,
     1892, 1900, 1894, 1882, 1901, 1904, 1890, 1905, 1906, 1908,
     1902, 1902, 1902, 1909, 1890, 1895, 1881, 1902, 1891, 1910,
     1911, 1896, 1912,    0, 1889, 1898, 1907, 1907, 1907,    0,

     1913, 1900, 1914, 1882, 1901, 1904, 1915, 1905, 1906, 1908,
     1943, 1943, 1943, 1909, 1916, 1916, 1916, 1916, 1891, 1910,
     1911, 1922, 1912, 1907, 1889, 1917, 1917, 1917, 1917, 1907,
     1913, 1919, 1914, 1924, 1925, 1926, 1915,    0, 1919, 1919,
     1919, 1919, 1920, 1920, 1920, 1920, 1934, 1928, 1935, 1938,
     1939, 1922, 1928, 1907, 1928, 1928, 1928, 1928, 1940, 1907,
     1941, 1942, 1945, 1924, 1925, 1926, 1930, 1930, 1930, 1930,
     1931, 1931, 1931, 1937, 1937, 1937, 1934, 1931, 1935, 1938,
     1939, 1944, 1944, 1944, 1946, 1937, 1949, 1950, 1940, 1952,
     1941, 1942, 1945, 1948, 1948, 1948, 1953, 1955, 1937, 1958,

     1959, 1960, 1961, 1962, 1963, 1964, 1965, 1967, 1968, 1969,
     1970, 1997, 1997, 1997, 1946, 1977, 1949, 1950, 1979, 1952,
     1985,    0, 1986, 1948,    0,    0, 1953, 1955, 1937, 1958,
     1959, 1960, 1961, 1962, 1963, 1964, 1965, 1967, 1968, 1969,
     1970, 1974, 1974, 1974, 1974, 1977, 1988, 1981, 1979, 1989,
     1985, 1982, 1986, 1948, 1981, 1981, 1981, 1981, 1982, 1982,
     1982, 1982, 1990, 1991, 1993, 1993, 1993, 1992, 1992, 1992,
     1994, 1996,    0, 2001, 2002, 2003, 1988, 2004, 2005, 1989,
     2006,    0, 2007, 2008, 2009, 2010, 2011, 2012, 2014, 2014,
     2014, 2014, 1990, 1991, 1992, 1992, 2016, 2016, 2016, 2016,

     1994, 1996, 1993, 2001, 2002, 2003, 2020, 2004, 2005, 1992,
     2006, 1993, 2007, 2008, 2009, 2010, 2011, 2012, 2017, 2017,
     2017, 2017, 2021, 2023, 1992, 1992, 2019, 2019, 2019, 2019,
     2024, 2025, 1993, 2026, 2027, 2028, 2020, 2029, 2030, 1992,
     2031, 1993, 2032, 2033, 2030, 2034, 2035, 2036, 2037, 2037,
     2037, 2038, 2021, 2023, 2040, 2041, 2042, 2043, 2044, 2045,
     2024, 2025, 2046, 2026, 2027, 2028, 2048, 2029, 2030,    0,
     2031,    0, 2032, 2033, 2030, 2034, 2035, 2036, 2037, 2054,
     2055, 2038,    0,    0, 2040, 2041, 2042, 2043, 2044, 2045,
     2056, 2057, 2046, 2058, 2058, 2058, 2048, 2050, 2050, 2050,

     2050, 2051, 2051, 2051, 2051, 2053, 2059, 2060, 2037, 2054,
     2055, 2062, 2053, 2053, 2053, 2053, 2061, 2061, 2061, 2063,
     2056, 2057, 2064, 2065, 2066, 2067, 2068, 2069, 2070, 2071,
     2074, 2075, 2076, 2077, 2078, 2079, 2059, 2060, 2080, 2087,
     2088, 2062, 2083, 2083, 2083, 2083, 2090, 2090, 2090, 2063,
     2091, 2094, 2064, 2065, 2066, 2067, 2068, 2069, 2070, 2071,
     2074, 2075, 2076, 2077, 2078, 2079, 2095, 2096, 2080, 2087,
     2088, 2092, 2092, 2092, 2090, 2093, 2093, 2093, 2097, 2090,
     2091, 2094, 2098, 2099, 2099, 2099, 2100,    0, 2101, 2102,
     2103, 2104, 2106, 2108,    0,    0, 2095, 2096, 2109, 2109,

     2109, 2110, 2110, 2110, 2090,    0, 2117, 2118, 2097, 2090,
     2119, 2120, 2098, 2121, 2121, 2121, 2100, 2093, 2101, 2102,
     2103, 2104, 2106, 2108, 2112, 2112, 2112, 2112, 2114, 2114,
     2114, 2114, 2115, 2115, 2115, 2115, 2117, 2118, 2122, 2123,
     2119, 2120, 2124, 2125, 2126, 2127, 2131, 2093, 2128, 2128,
     2128, 2132, 2132, 2132, 2133, 2135, 2121, 2136, 2136, 2136,
     2137, 2137, 2137, 2139, 2139, 2139, 2139, 2141, 2122, 2123,
     2138, 2142, 2124, 2125, 2126, 2127, 2131, 2138, 2138, 2138,
     2138, 2137, 2143, 2144, 2133, 2135, 2121, 2145, 2146, 2147,
     2136, 2148, 2149, 2151, 2152, 2128, 2153, 2141, 2150, 2150,

     2150, 2142, 2154, 2155, 2155, 2155, 2156, 2156, 2156, 2157,
     2158, 2164, 2143, 2144, 2165, 2166, 2168, 2145, 2146, 2147,
     2136, 2148, 2149, 2151, 2152, 2128, 2153, 2163, 2163, 2163,
     2163, 2169, 2154, 2167, 2167, 2167, 2170, 2171, 2174, 2157,
     2158, 2164, 2175, 2176, 2165, 2166, 2168, 2155, 2172, 2172,
     2172, 2173, 2173, 2173, 2177, 2178, 2179, 2179, 2179,    0,
     2180, 2169, 2181, 2188, 2188, 2188, 2170, 2171, 2174, 2185,
     2186, 2187, 2175, 2176, 2189,    0, 2192, 2155, 2183, 2183,
     2183, 2183, 2194, 2195, 2177, 2178, 2191, 2191, 2191, 2179,
     2180, 2196, 2181, 2173, 2184, 2184, 2184, 2184, 2197, 2185,

     2186, 2187, 2199, 2200, 2189, 2188, 2192, 2193, 2193, 2193,
     2201, 2202, 2194, 2195, 2206, 2207, 2208, 2203, 2209, 2179,
        0, 2196, 2211, 2173, 2203, 2203, 2203, 2203, 2197, 2210,
     2210, 2210, 2199, 2200, 2212, 2188, 2213, 2214, 2216, 2217,
     2201, 2202, 2218, 2219, 2206, 2207, 2208, 2220, 2209, 2224,
     2193, 2225, 2211, 2223, 2223, 2223, 2223, 2226, 2227, 2228,
     2229, 2229, 2229, 2230, 2212, 2231, 2213, 2214, 2216, 2217,
     2232, 2210, 2218, 2219, 2234, 2235, 2239, 2220, 2240, 2224,
     2193, 2225, 2238, 2238, 2238, 2238, 2241, 2226, 2227, 2228,
     2242, 2243, 2245, 2230, 2249, 2231, 2244, 2244, 2244, 2252,

     2232, 2210, 2254, 2255, 2234, 2235, 2239, 2256, 2240, 2247,
     2247, 2247, 2257, 2258, 2258, 2258, 2241, 2263, 2265, 2266,
     2242, 2243, 2245, 2267, 2249, 2261, 2261, 2261, 2261, 2252,
     2270, 2271, 2254, 2255, 2272, 2275, 2268, 2256, 2244, 2276,
     2277,    0, 2257, 2268, 2268, 2268, 2268, 2263, 2265, 2266,
        0,    0,    0, 2267,    0, 2258,    0,    0,    0,    0,
     2270, 2271,    0,    0, 2272, 2275,    0,    0, 2244, 2276,
     2277,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 2258, 2281, 2281, 2281, 2282,
     2282, 2282, 2283, 2283, 2283, 2284, 2284, 2284, 2286, 2286,

     2287, 2287, 2288, 2288, 2288, 2289, 2289, 2289, 2290, 2290,
     2290, 2291, 2291, 2291, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[403] =
    {   0,
0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 
    0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 
    0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 
    0, 0, 0,     };

extern int yy_flex_debug;
int yy_flex_debug = 0;

static yy_state_type *yy_state_buf=0, *yy_state_ptr=0;
static char *yy_full_match;
static int yy_lp;
#define REJECT \
{ \
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */ \
yy_cp = (yy_full_match); /* restore poss. backed-over text */ \
++(yy_lp); \
goto find_rule; \
}

static int yy_more_flag = 0;
static int yy_more_len = 0;
#define yymore() ((yy_more_flag) = 1)
#define YY_MORE_ADJ (yy_more_len)
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "m2.lex"
#line 4 "m2.lex"
static int ign_kw(int yystate,int kw);
/*
Generated by gen_lex
*/

#line 3755 "lex.yy.c"

#define INITIAL 0
#define comment 1

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * _in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * _out_str  );

yy_size_t yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
    static void yyunput (int c,char *buf_ptr  );
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

        /* Create the reject buffer large enough to save one state per allowed character. */
        if ( ! (yy_state_buf) )
            (yy_state_buf) = (yy_state_type *)yyalloc(YY_STATE_BUF_SIZE  );
            if ( ! (yy_state_buf) )
                YY_FATAL_ERROR( "out of dynamic memory in yylex()" );

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	{
#line 25 "m2.lex"


#line 3983 "lex.yy.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		(yy_more_len) = 0;
		if ( (yy_more_flag) )
			{
			(yy_more_len) = (yy_c_buf_p) - (yytext_ptr);
			(yy_more_flag) = 0;
			}
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);

		(yy_state_ptr) = (yy_state_buf);
		*(yy_state_ptr)++ = yy_current_state;

yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 2281 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*(yy_state_ptr)++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 10515 );

yy_find_action:
		yy_current_state = *--(yy_state_ptr);
		(yy_lp) = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( (yy_lp) && (yy_lp) < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[(yy_lp)];
					{
					(yy_full_match) = yy_cp;
					break;
					}
				}
			--yy_cp;
			yy_current_state = *--(yy_state_ptr);
			(yy_lp) = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			yy_size_t yyl;
			for ( yyl = (yy_more_len); yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
case 1:
YY_RULE_SETUP
#line 27 "m2.lex"
{BEGIN INITIAL;}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 28 "m2.lex"
;
	YY_BREAK
case 3:
/* rule 3 can match eol */
YY_RULE_SETUP
#line 29 "m2.lex"
;
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 30 "m2.lex"
{ BEGIN comment; yymore(); }
	YY_BREAK
case 5:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 31 "m2.lex"
{yymore();}
	YY_BREAK
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 32 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 34 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 36 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 37 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 38 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 39 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 40 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 41 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 43 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 44 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 45 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 46 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 47 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 49 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 50 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 51 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 52 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 54 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 55 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 56 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 58 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 59 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME_VALUE;}
	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 62 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);   return INTERVAL_VALUE;}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 63 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);   return INTERVAL_VALUE;}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 64 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTERVAL_VALUE;}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 65 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTERVAL_VALUE;}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 66 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);   return INTERVAL_VALUE;}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 67 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);   return INTERVAL_VALUE;}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 68 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTERVAL_VALUE;}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 69 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);   return INTERVAL_VALUE;}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 70 "m2.lex"
{ a4gl_upshift(yytext); strcpy(yylval.str,yytext);   return INTERVAL_VALUE;}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 72 "m2.lex"
{ return DOUBLE_COLON;}
	YY_BREAK
case 38:
/* rule 38 can match eol */
YY_RULE_SETUP
#line 75 "m2.lex"
{ if (ign_kw(yystate, END_DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return END_DIALOG;} /* 1 */
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 77 "m2.lex"
{ if (ign_kw(yystate, KW_TYPE_AS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_TYPE_AS;} /* 1 */
	YY_BREAK
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 79 "m2.lex"
{ if (ign_kw(yystate, ACCEPT_DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ACCEPT_DIALOG;} /* 1 */
	YY_BREAK
case 41:
/* rule 41 can match eol */
YY_RULE_SETUP
#line 81 "m2.lex"
{ if (ign_kw(yystate, EXIT_DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXIT_DIALOG;} /* 1 */
	YY_BREAK
case 42:
/* rule 42 can match eol */
YY_RULE_SETUP
#line 83 "m2.lex"
{ if (ign_kw(yystate, CONTINUE_DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CONTINUE_DIALOG;} /* 1 */
	YY_BREAK
case 43:
/* rule 43 can match eol */
YY_RULE_SETUP
#line 85 "m2.lex"
{ if (ign_kw(yystate, AFTER_DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return AFTER_DIALOG;} /* 1 */
	YY_BREAK
case 44:
/* rule 44 can match eol */
YY_RULE_SETUP
#line 87 "m2.lex"
{ if (ign_kw(yystate, BEFORE_DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return BEFORE_DIALOG;} /* 1 */
	YY_BREAK
case 45:
/* rule 45 can match eol */
YY_RULE_SETUP
#line 89 "m2.lex"
{ if (ign_kw(yystate, BEFORE_PROMPT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return BEFORE_PROMPT;} /* 1 */
	YY_BREAK
case 46:
/* rule 46 can match eol */
YY_RULE_SETUP
#line 91 "m2.lex"
{ if (ign_kw(yystate, COUNT_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return COUNT_OB;} /* 1 */
	YY_BREAK
case 47:
/* rule 47 can match eol */
YY_RULE_SETUP
#line 93 "m2.lex"
{ if (ign_kw(yystate, SUM_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SUM_OB;} /* 1 */
	YY_BREAK
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 95 "m2.lex"
{ if (ign_kw(yystate, XMAX_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XMAX_OB;} /* 1 */
	YY_BREAK
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 97 "m2.lex"
{ if (ign_kw(yystate, XMIN_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XMIN_OB;} /* 1 */
	YY_BREAK
case 50:
/* rule 50 can match eol */
YY_RULE_SETUP
#line 99 "m2.lex"
{ if (ign_kw(yystate, AVG_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return AVG_OB;} /* 1 */
	YY_BREAK
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 101 "m2.lex"
{ if (ign_kw(yystate, AVG_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return AVG_OB;} /* 2 */
	YY_BREAK
case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 103 "m2.lex"
{ if (ign_kw(yystate, PERCENT_OB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return PERCENT_OB;} /* 1 */
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 105 "m2.lex"
{ if (ign_kw(yystate, WITH_LISTING_IN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WITH_LISTING_IN;} /* 1 */
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 107 "m2.lex"
{ if (ign_kw(yystate, BACKQUOTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return BACKQUOTE;} /* 1 */
	YY_BREAK
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 109 "m2.lex"
{ if (ign_kw(yystate, SET_UNDERLINE_ON)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_UNDERLINE_ON;} /* 1 */
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 111 "m2.lex"
{ if (ign_kw(yystate, SET_UNDERLINE_OFF)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_UNDERLINE_OFF;} /* 1 */
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 113 "m2.lex"
{ if (ign_kw(yystate, SET_POSTGRESQL_SEARCH_PATH)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_POSTGRESQL_SEARCH_PATH;} /* 1 */
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 115 "m2.lex"
{ if (ign_kw(yystate, SET_CONSTRAINTS_ALL_DEFERRED)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_CONSTRAINTS_ALL_DEFERRED;} /* 1 */
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 117 "m2.lex"
{ if (ign_kw(yystate, KW_LIMIT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_LIMIT;} /* 1 */
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 119 "m2.lex"
{ if (ign_kw(yystate, DOCUMENT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DOCUMENT;} /* 1 */
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 121 "m2.lex"
{ if (ign_kw(yystate, ON_EXCEPTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ON_EXCEPTION;} /* 1 */
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 123 "m2.lex"
{ if (ign_kw(yystate, SET_DEBUG_FILE_TO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_DEBUG_FILE_TO;} /* 1 */
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 125 "m2.lex"
{ if (ign_kw(yystate, CREATE_DBA_PROCEDURE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_DBA_PROCEDURE;} /* 1 */
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 127 "m2.lex"
{ if (ign_kw(yystate, CREATE_FUNCTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_FUNCTION;} /* 1 */
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 129 "m2.lex"
{ if (ign_kw(yystate, CREATE_DBA_FUNCTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_DBA_FUNCTION;} /* 1 */
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 131 "m2.lex"
{ if (ign_kw(yystate, USE_SESSION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return USE_SESSION;} /* 1 */
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 133 "m2.lex"
{ if (ign_kw(yystate, KW_RUN_CLIENT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_RUN_CLIENT;} /* 1 */
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 135 "m2.lex"
{ if (ign_kw(yystate, LEFT_JOIN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LEFT_JOIN;} /* 1 */
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 137 "m2.lex"
{ if (ign_kw(yystate, LEFT_JOIN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LEFT_JOIN;} /* 2 */
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 139 "m2.lex"
{ if (ign_kw(yystate, IGNORE_ERRORS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return IGNORE_ERRORS;} /* 1 */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 141 "m2.lex"
{ if (ign_kw(yystate, IGNORE_ERRORS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return IGNORE_ERRORS;} /* 2 */
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 143 "m2.lex"
{ if (ign_kw(yystate, SQLERRMESSAGE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLERRMESSAGE;} /* 1 */
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 145 "m2.lex"
{ if (ign_kw(yystate, DISPLAY_NULL_TO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DISPLAY_NULL_TO;} /* 1 */
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 147 "m2.lex"
{ if (ign_kw(yystate, UNBUFFERED)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNBUFFERED;} /* 1 */
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 149 "m2.lex"
{ if (ign_kw(yystate, KW_PICTURE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_PICTURE;} /* 1 */
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 151 "m2.lex"
{ if (ign_kw(yystate, ON_CHANGE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ON_CHANGE;} /* 1 */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 153 "m2.lex"
{ if (ign_kw(yystate, INNER_JOIN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INNER_JOIN;} /* 1 */
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 155 "m2.lex"
{ if (ign_kw(yystate, UI_INTERFACE_DOT_FRONTCALL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UI_INTERFACE_DOT_FRONTCALL;} /* 1 */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 157 "m2.lex"
{ if (ign_kw(yystate, UICOMBOBOX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UICOMBOBOX;} /* 1 */
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 159 "m2.lex"
{ if (ign_kw(yystate, UIBROWSER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UIBROWSER;} /* 1 */
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 161 "m2.lex"
{ if (ign_kw(yystate, UIPROGRESS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UIPROGRESS;} /* 1 */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 163 "m2.lex"
{ if (ign_kw(yystate, UIGANTT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UIGANTT;} /* 1 */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 165 "m2.lex"
{ if (ign_kw(yystate, UIFORM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UIFORM;} /* 1 */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 167 "m2.lex"
{ if (ign_kw(yystate, USING_BTREE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return USING_BTREE;} /* 1 */
	YY_BREAK
case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 169 "m2.lex"
{ if (ign_kw(yystate, USING_RTREE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return USING_RTREE;} /* 1 */
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 171 "m2.lex"
{ if (ign_kw(yystate, RESUME_PAGE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return RESUME_PAGE;} /* 1 */
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 173 "m2.lex"
{ if (ign_kw(yystate, FOR_EVERY_PAGE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FOR_EVERY_PAGE;} /* 1 */
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 175 "m2.lex"
{ if (ign_kw(yystate, SET_BUFFERED_LOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_BUFFERED_LOG;} /* 1 */
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 178 "m2.lex"
{ if (ign_kw(yystate, MDY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MDY;} /* 1 */
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 180 "m2.lex"
{ if (ign_kw(yystate, WEEKDAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WEEKDAY;} /* 1 */
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 182 "m2.lex"
{ if (ign_kw(yystate, MODE_ANSI)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MODE_ANSI;} /* 1 */
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 184 "m2.lex"
{ if (ign_kw(yystate, START_DATABASE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return START_DATABASE;} /* 1 */
	YY_BREAK
case 93:
/* rule 93 can match eol */
YY_RULE_SETUP
#line 186 "m2.lex"
{ if (ign_kw(yystate, WITH_LOG_IN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WITH_LOG_IN;} /* 1 */
	YY_BREAK
case 94:
/* rule 94 can match eol */
YY_RULE_SETUP
#line 188 "m2.lex"
{ if (ign_kw(yystate, SET_CONSTRAINTS_ALL_IMMEDIATE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_CONSTRAINTS_ALL_IMMEDIATE;} /* 1 */
	YY_BREAK
case 95:
/* rule 95 can match eol */
YY_RULE_SETUP
#line 190 "m2.lex"
{ if (ign_kw(yystate, RECOVER_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return RECOVER_TABLE;} /* 1 */
	YY_BREAK
case 96:
/* rule 96 can match eol */
YY_RULE_SETUP
#line 192 "m2.lex"
{ if (ign_kw(yystate, ROLLFORWARD_DATABASE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ROLLFORWARD_DATABASE;} /* 1 */
	YY_BREAK
case 97:
/* rule 97 can match eol */
YY_RULE_SETUP
#line 194 "m2.lex"
{ if (ign_kw(yystate, CONCAT_PIPES)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CONCAT_PIPES;} /* 1 */
	YY_BREAK
case 98:
/* rule 98 can match eol */
YY_RULE_SETUP
#line 196 "m2.lex"
{ if (ign_kw(yystate, DROP_TRIGGER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_TRIGGER;} /* 1 */
	YY_BREAK
case 99:
/* rule 99 can match eol */
YY_RULE_SETUP
#line 198 "m2.lex"
{ if (ign_kw(yystate, DROP_AUDIT_FOR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_AUDIT_FOR;} /* 1 */
	YY_BREAK
case 100:
/* rule 100 can match eol */
YY_RULE_SETUP
#line 200 "m2.lex"
{ if (ign_kw(yystate, CREATE_AUDIT_FOR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_AUDIT_FOR;} /* 1 */
	YY_BREAK
case 101:
/* rule 101 can match eol */
YY_RULE_SETUP
#line 202 "m2.lex"
{ if (ign_kw(yystate, EXECUTE_PROCEDURE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXECUTE_PROCEDURE;} /* 1 */
	YY_BREAK
case 102:
/* rule 102 can match eol */
YY_RULE_SETUP
#line 204 "m2.lex"
{ if (ign_kw(yystate, EXECUTE_PROCEDURE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXECUTE_PROCEDURE;} /* 2 */
	YY_BREAK
case 103:
/* rule 103 can match eol */
YY_RULE_SETUP
#line 206 "m2.lex"
{ if (ign_kw(yystate, APPEND_ROW_EQUAL_FALSE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return APPEND_ROW_EQUAL_FALSE;} /* 1 */
	YY_BREAK
case 104:
/* rule 104 can match eol */
YY_RULE_SETUP
#line 208 "m2.lex"
{ if (ign_kw(yystate, APPEND_ROW_EQUAL_TRUE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return APPEND_ROW_EQUAL_TRUE;} /* 1 */
	YY_BREAK
case 105:
/* rule 105 can match eol */
YY_RULE_SETUP
#line 210 "m2.lex"
{ if (ign_kw(yystate, AUTO_APPEND_EQUAL_FALSE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return AUTO_APPEND_EQUAL_FALSE;} /* 1 */
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 212 "m2.lex"
{ if (ign_kw(yystate, AUTO_APPEND_EQUAL_TRUE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return AUTO_APPEND_EQUAL_TRUE;} /* 1 */
	YY_BREAK
case 107:
/* rule 107 can match eol */
YY_RULE_SETUP
#line 214 "m2.lex"
{ if (ign_kw(yystate, CURRENT_FIELD_DISPLAY_EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CURRENT_FIELD_DISPLAY_EQUAL;} /* 1 */
	YY_BREAK
case 108:
/* rule 108 can match eol */
YY_RULE_SETUP
#line 216 "m2.lex"
{ if (ign_kw(yystate, CURRENT_FIELD_DISPLAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CURRENT_FIELD_DISPLAY;} /* 1 */
	YY_BREAK
case 109:
/* rule 109 can match eol */
YY_RULE_SETUP
#line 218 "m2.lex"
{ if (ign_kw(yystate, CURRENT_ROW_DISPLAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CURRENT_ROW_DISPLAY;} /* 1 */
	YY_BREAK
case 110:
/* rule 110 can match eol */
YY_RULE_SETUP
#line 220 "m2.lex"
{ if (ign_kw(yystate, ALTER_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ALTER_TABLE;} /* 1 */
	YY_BREAK
case 111:
/* rule 111 can match eol */
YY_RULE_SETUP
#line 222 "m2.lex"
{ if (ign_kw(yystate, ALTER_INDEX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ALTER_INDEX;} /* 1 */
	YY_BREAK
case 112:
/* rule 112 can match eol */
YY_RULE_SETUP
#line 224 "m2.lex"
{ if (ign_kw(yystate, NEXT_SIZE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NEXT_SIZE;} /* 1 */
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 226 "m2.lex"
{ if (ign_kw(yystate, KW_WHENEVER_SIGNAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_WHENEVER_SIGNAL;} /* 1 */
	YY_BREAK
case 114:
YY_RULE_SETUP
#line 228 "m2.lex"
{ if (ign_kw(yystate, KW_SIGNAL_TOKEN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_SIGNAL_TOKEN;} /* 1 */
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 230 "m2.lex"
{ if (ign_kw(yystate, KW_SIGNAL_TOKEN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_SIGNAL_TOKEN;} /* 2 */
	YY_BREAK
case 116:
/* rule 116 can match eol */
YY_RULE_SETUP
#line 232 "m2.lex"
{ if (ign_kw(yystate, XSET_MULTIPLY_EQUAL_OPEN_BRACKET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XSET_MULTIPLY_EQUAL_OPEN_BRACKET;} /* 1 */
	YY_BREAK
case 117:
/* rule 117 can match eol */
YY_RULE_SETUP
#line 234 "m2.lex"
{ if (ign_kw(yystate, XSET_ident_DOT_MULTIPLY_EQUAL_OPEN_BRACKET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XSET_ident_DOT_MULTIPLY_EQUAL_OPEN_BRACKET;} /* 1 */
	YY_BREAK
case 118:
/* rule 118 can match eol */
YY_RULE_SETUP
#line 236 "m2.lex"
{ if (ign_kw(yystate, XSET_ident_DOT_MULTIPLY_EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XSET_ident_DOT_MULTIPLY_EQUAL;} /* 1 */
	YY_BREAK
case 119:
/* rule 119 can match eol */
YY_RULE_SETUP
#line 238 "m2.lex"
{ if (ign_kw(yystate, XSET_MULTIPLY_EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XSET_MULTIPLY_EQUAL;} /* 1 */
	YY_BREAK
case 120:
/* rule 120 can match eol */
YY_RULE_SETUP
#line 240 "m2.lex"
{ if (ign_kw(yystate, XSET_OPEN_BRACKET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XSET_OPEN_BRACKET;} /* 1 */
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
#line 242 "m2.lex"
{ if (ign_kw(yystate, CREATE_DATABASE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_DATABASE;} /* 1 */
	YY_BREAK
case 122:
/* rule 122 can match eol */
YY_RULE_SETUP
#line 244 "m2.lex"
{ if (ign_kw(yystate, DROP_DATABASE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_DATABASE;} /* 1 */
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 246 "m2.lex"
{ if (ign_kw(yystate, ADD_CONSTRAINT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ADD_CONSTRAINT;} /* 1 */
	YY_BREAK
case 124:
/* rule 124 can match eol */
YY_RULE_SETUP
#line 248 "m2.lex"
{ if (ign_kw(yystate, DROP_CONSTRAINT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_CONSTRAINT;} /* 1 */
	YY_BREAK
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
#line 250 "m2.lex"
{ if (ign_kw(yystate, DROP_SYNONYM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_SYNONYM;} /* 1 */
	YY_BREAK
case 126:
YY_RULE_SETUP
#line 252 "m2.lex"
{ if (ign_kw(yystate, CONSTRAINT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CONSTRAINT;} /* 1 */
	YY_BREAK
case 127:
/* rule 127 can match eol */
YY_RULE_SETUP
#line 254 "m2.lex"
{ if (ign_kw(yystate, NOT_FIELD_TOUCHED_CURRENT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_FIELD_TOUCHED_CURRENT;} /* 1 */
	YY_BREAK
case 128:
YY_RULE_SETUP
#line 256 "m2.lex"
{ if (ign_kw(yystate, FIELD_TOUCHED_CURRENT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FIELD_TOUCHED_CURRENT;} /* 1 */
	YY_BREAK
case 129:
/* rule 129 can match eol */
YY_RULE_SETUP
#line 258 "m2.lex"
{ if (ign_kw(yystate, OBJECT_FUNCTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return OBJECT_FUNCTION;} /* 1 */
	YY_BREAK
case 130:
/* rule 130 can match eol */
YY_RULE_SETUP
#line 260 "m2.lex"
{ if (ign_kw(yystate, DOUBLE_PRECISION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DOUBLE_PRECISION;} /* 1 */
	YY_BREAK
case 131:
/* rule 131 can match eol */
YY_RULE_SETUP
#line 262 "m2.lex"
{ if (ign_kw(yystate, COUNT_MULTIPLY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return COUNT_MULTIPLY;} /* 1 */
	YY_BREAK
case 132:
/* rule 132 can match eol */
YY_RULE_SETUP
#line 264 "m2.lex"
{ if (ign_kw(yystate, KW_ASCII_OPEN_BRACKET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_ASCII_OPEN_BRACKET;} /* 1 */
	YY_BREAK
case 133:
/* rule 133 can match eol */
YY_RULE_SETUP
#line 266 "m2.lex"
{ if (ign_kw(yystate, MODIFY_NEXT_SIZE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MODIFY_NEXT_SIZE;} /* 1 */
	YY_BREAK
case 134:
/* rule 134 can match eol */
YY_RULE_SETUP
#line 268 "m2.lex"
{ if (ign_kw(yystate, LOCK_MODE_PAGE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LOCK_MODE_PAGE;} /* 1 */
	YY_BREAK
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 270 "m2.lex"
{ if (ign_kw(yystate, LOCK_MODE_PAGE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LOCK_MODE_PAGE;} /* 2 */
	YY_BREAK
case 136:
/* rule 136 can match eol */
YY_RULE_SETUP
#line 272 "m2.lex"
{ if (ign_kw(yystate, LOCK_MODE_ROW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LOCK_MODE_ROW;} /* 1 */
	YY_BREAK
case 137:
/* rule 137 can match eol */
YY_RULE_SETUP
#line 274 "m2.lex"
{ if (ign_kw(yystate, LOCK_MODE_ROW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LOCK_MODE_ROW;} /* 2 */
	YY_BREAK
case 138:
/* rule 138 can match eol */
YY_RULE_SETUP
#line 276 "m2.lex"
{ if (ign_kw(yystate, TO_UI)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return TO_UI;} /* 1 */
	YY_BREAK
case 139:
/* rule 139 can match eol */
YY_RULE_SETUP
#line 278 "m2.lex"
{ if (ign_kw(yystate, UNITS_YEAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_YEAR;} /* 1 */
	YY_BREAK
case 140:
/* rule 140 can match eol */
YY_RULE_SETUP
#line 280 "m2.lex"
{ if (ign_kw(yystate, UNITS_YEAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_YEAR;} /* 2 */
	YY_BREAK
case 141:
/* rule 141 can match eol */
YY_RULE_SETUP
#line 282 "m2.lex"
{ if (ign_kw(yystate, UNITS_YEAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_YEAR;} /* 3 */
	YY_BREAK
case 142:
/* rule 142 can match eol */
YY_RULE_SETUP
#line 284 "m2.lex"
{ if (ign_kw(yystate, UNITS_YEAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_YEAR;} /* 4 */
	YY_BREAK
case 143:
/* rule 143 can match eol */
YY_RULE_SETUP
#line 286 "m2.lex"
{ if (ign_kw(yystate, UNITS_MONTH)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MONTH;} /* 1 */
	YY_BREAK
case 144:
/* rule 144 can match eol */
YY_RULE_SETUP
#line 288 "m2.lex"
{ if (ign_kw(yystate, UNITS_MONTH)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MONTH;} /* 2 */
	YY_BREAK
case 145:
/* rule 145 can match eol */
YY_RULE_SETUP
#line 290 "m2.lex"
{ if (ign_kw(yystate, UNITS_MONTH)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MONTH;} /* 3 */
	YY_BREAK
case 146:
/* rule 146 can match eol */
YY_RULE_SETUP
#line 292 "m2.lex"
{ if (ign_kw(yystate, UNITS_MONTH)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MONTH;} /* 4 */
	YY_BREAK
case 147:
/* rule 147 can match eol */
YY_RULE_SETUP
#line 294 "m2.lex"
{ if (ign_kw(yystate, UNITS_DAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_DAY;} /* 1 */
	YY_BREAK
case 148:
/* rule 148 can match eol */
YY_RULE_SETUP
#line 296 "m2.lex"
{ if (ign_kw(yystate, UNITS_DAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_DAY;} /* 2 */
	YY_BREAK
case 149:
/* rule 149 can match eol */
YY_RULE_SETUP
#line 298 "m2.lex"
{ if (ign_kw(yystate, UNITS_DAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_DAY;} /* 3 */
	YY_BREAK
case 150:
/* rule 150 can match eol */
YY_RULE_SETUP
#line 300 "m2.lex"
{ if (ign_kw(yystate, UNITS_DAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_DAY;} /* 4 */
	YY_BREAK
case 151:
/* rule 151 can match eol */
YY_RULE_SETUP
#line 302 "m2.lex"
{ if (ign_kw(yystate, UNITS_HOUR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_HOUR;} /* 1 */
	YY_BREAK
case 152:
/* rule 152 can match eol */
YY_RULE_SETUP
#line 304 "m2.lex"
{ if (ign_kw(yystate, UNITS_HOUR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_HOUR;} /* 2 */
	YY_BREAK
case 153:
/* rule 153 can match eol */
YY_RULE_SETUP
#line 306 "m2.lex"
{ if (ign_kw(yystate, UNITS_HOUR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_HOUR;} /* 3 */
	YY_BREAK
case 154:
/* rule 154 can match eol */
YY_RULE_SETUP
#line 308 "m2.lex"
{ if (ign_kw(yystate, UNITS_HOUR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_HOUR;} /* 4 */
	YY_BREAK
case 155:
/* rule 155 can match eol */
YY_RULE_SETUP
#line 310 "m2.lex"
{ if (ign_kw(yystate, UNITS_MINUTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MINUTE;} /* 1 */
	YY_BREAK
case 156:
/* rule 156 can match eol */
YY_RULE_SETUP
#line 312 "m2.lex"
{ if (ign_kw(yystate, UNITS_MINUTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MINUTE;} /* 2 */
	YY_BREAK
case 157:
/* rule 157 can match eol */
YY_RULE_SETUP
#line 314 "m2.lex"
{ if (ign_kw(yystate, UNITS_MINUTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MINUTE;} /* 3 */
	YY_BREAK
case 158:
/* rule 158 can match eol */
YY_RULE_SETUP
#line 316 "m2.lex"
{ if (ign_kw(yystate, UNITS_MINUTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_MINUTE;} /* 4 */
	YY_BREAK
case 159:
/* rule 159 can match eol */
YY_RULE_SETUP
#line 318 "m2.lex"
{ if (ign_kw(yystate, UNITS_SECOND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_SECOND;} /* 1 */
	YY_BREAK
case 160:
/* rule 160 can match eol */
YY_RULE_SETUP
#line 320 "m2.lex"
{ if (ign_kw(yystate, UNITS_SECOND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_SECOND;} /* 2 */
	YY_BREAK
case 161:
/* rule 161 can match eol */
YY_RULE_SETUP
#line 322 "m2.lex"
{ if (ign_kw(yystate, UNITS_SECOND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_SECOND;} /* 3 */
	YY_BREAK
case 162:
/* rule 162 can match eol */
YY_RULE_SETUP
#line 324 "m2.lex"
{ if (ign_kw(yystate, UNITS_SECOND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNITS_SECOND;} /* 4 */
	YY_BREAK
case 163:
/* rule 163 can match eol */
YY_RULE_SETUP
#line 326 "m2.lex"
{ if (ign_kw(yystate, TO_CLUSTER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return TO_CLUSTER;} /* 1 */
	YY_BREAK
case 164:
/* rule 164 can match eol */
YY_RULE_SETUP
#line 328 "m2.lex"
{ if (ign_kw(yystate, TO_NOT_CLUSTER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return TO_NOT_CLUSTER;} /* 1 */
	YY_BREAK
case 165:
/* rule 165 can match eol */
YY_RULE_SETUP
#line 330 "m2.lex"
{ if (ign_kw(yystate, CREATE_UC_IDX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_UC_IDX;} /* 1 */
	YY_BREAK
case 166:
/* rule 166 can match eol */
YY_RULE_SETUP
#line 332 "m2.lex"
{ if (ign_kw(yystate, CREATE_UC_IDX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_UC_IDX;} /* 2 */
	YY_BREAK
case 167:
/* rule 167 can match eol */
YY_RULE_SETUP
#line 334 "m2.lex"
{ if (ign_kw(yystate, CREATE_U_IDX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_U_IDX;} /* 1 */
	YY_BREAK
case 168:
/* rule 168 can match eol */
YY_RULE_SETUP
#line 336 "m2.lex"
{ if (ign_kw(yystate, CREATE_U_IDX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_U_IDX;} /* 2 */
	YY_BREAK
case 169:
/* rule 169 can match eol */
YY_RULE_SETUP
#line 338 "m2.lex"
{ if (ign_kw(yystate, CREATE_C_IDX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_C_IDX;} /* 1 */
	YY_BREAK
case 170:
/* rule 170 can match eol */
YY_RULE_SETUP
#line 340 "m2.lex"
{ if (ign_kw(yystate, CREATE_IDX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_IDX;} /* 1 */
	YY_BREAK
case 171:
/* rule 171 can match eol */
YY_RULE_SETUP
#line 342 "m2.lex"
{ if (ign_kw(yystate, SQLSICS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSICS;} /* 1 */
	YY_BREAK
case 172:
/* rule 172 can match eol */
YY_RULE_SETUP
#line 344 "m2.lex"
{ if (ign_kw(yystate, SQLSICS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSICS;} /* 2 */
	YY_BREAK
case 173:
/* rule 173 can match eol */
YY_RULE_SETUP
#line 346 "m2.lex"
{ if (ign_kw(yystate, CREATE_SCHEMA)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_SCHEMA;} /* 1 */
	YY_BREAK
case 174:
/* rule 174 can match eol */
YY_RULE_SETUP
#line 348 "m2.lex"
{ if (ign_kw(yystate, SQLSIRR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSIRR;} /* 1 */
	YY_BREAK
case 175:
/* rule 175 can match eol */
YY_RULE_SETUP
#line 350 "m2.lex"
{ if (ign_kw(yystate, SQLSIRR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSIRR;} /* 2 */
	YY_BREAK
case 176:
/* rule 176 can match eol */
YY_RULE_SETUP
#line 352 "m2.lex"
{ if (ign_kw(yystate, UPDATESTATS_T)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UPDATESTATS_T;} /* 1 */
	YY_BREAK
case 177:
/* rule 177 can match eol */
YY_RULE_SETUP
#line 354 "m2.lex"
{ if (ign_kw(yystate, SQLSICR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSICR;} /* 1 */
	YY_BREAK
case 178:
/* rule 178 can match eol */
YY_RULE_SETUP
#line 356 "m2.lex"
{ if (ign_kw(yystate, SQLSICR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSICR;} /* 2 */
	YY_BREAK
case 179:
/* rule 179 can match eol */
YY_RULE_SETUP
#line 358 "m2.lex"
{ if (ign_kw(yystate, SQLSIDR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSIDR;} /* 1 */
	YY_BREAK
case 180:
/* rule 180 can match eol */
YY_RULE_SETUP
#line 360 "m2.lex"
{ if (ign_kw(yystate, SQLSIDR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSIDR;} /* 2 */
	YY_BREAK
case 181:
/* rule 181 can match eol */
YY_RULE_SETUP
#line 362 "m2.lex"
{ if (ign_kw(yystate, CREATE_TEMP_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_TEMP_TABLE;} /* 1 */
	YY_BREAK
case 182:
/* rule 182 can match eol */
YY_RULE_SETUP
#line 364 "m2.lex"
{ if (ign_kw(yystate, WITH_CHECK_OPTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WITH_CHECK_OPTION;} /* 1 */
	YY_BREAK
case 183:
/* rule 183 can match eol */
YY_RULE_SETUP
#line 366 "m2.lex"
{ if (ign_kw(yystate, WITH_GRANT_OPTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WITH_GRANT_OPTION;} /* 1 */
	YY_BREAK
case 184:
/* rule 184 can match eol */
YY_RULE_SETUP
#line 368 "m2.lex"
{ if (ign_kw(yystate, SQLSLMNW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSLMNW;} /* 1 */
	YY_BREAK
case 185:
/* rule 185 can match eol */
YY_RULE_SETUP
#line 370 "m2.lex"
{ if (ign_kw(yystate, WHERE_CURRENT_OF)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WHERE_CURRENT_OF;} /* 1 */
	YY_BREAK
case 186:
/* rule 186 can match eol */
YY_RULE_SETUP
#line 372 "m2.lex"
{ if (ign_kw(yystate, NOT_NULL_UNIQUE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_NULL_UNIQUE;} /* 1 */
	YY_BREAK
case 187:
/* rule 187 can match eol */
YY_RULE_SETUP
#line 374 "m2.lex"
{ if (ign_kw(yystate, SQLSLMW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSLMW;} /* 1 */
	YY_BREAK
case 188:
/* rule 188 can match eol */
YY_RULE_SETUP
#line 376 "m2.lex"
{ if (ign_kw(yystate, ALL_PRIVILEGES)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ALL_PRIVILEGES;} /* 1 */
	YY_BREAK
case 189:
/* rule 189 can match eol */
YY_RULE_SETUP
#line 378 "m2.lex"
{ if (ign_kw(yystate, CREATE_SYNONYM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_SYNONYM;} /* 1 */
	YY_BREAK
case 190:
/* rule 190 can match eol */
YY_RULE_SETUP
#line 380 "m2.lex"
{ if (ign_kw(yystate, CREATE_SYNONYM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_SYNONYM;} /* 2 */
	YY_BREAK
case 191:
/* rule 191 can match eol */
YY_RULE_SETUP
#line 382 "m2.lex"
{ if (ign_kw(yystate, CREATE_SYNONYM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_SYNONYM;} /* 3 */
	YY_BREAK
case 192:
/* rule 192 can match eol */
YY_RULE_SETUP
#line 384 "m2.lex"
{ if (ign_kw(yystate, DROP_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_TABLE;} /* 1 */
	YY_BREAK
case 193:
/* rule 193 can match eol */
YY_RULE_SETUP
#line 386 "m2.lex"
{ if (ign_kw(yystate, DROP_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_TABLE;} /* 2 */
	YY_BREAK
case 194:
/* rule 194 can match eol */
YY_RULE_SETUP
#line 388 "m2.lex"
{ if (ign_kw(yystate, INEXCLUSIVE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INEXCLUSIVE;} /* 1 */
	YY_BREAK
case 195:
/* rule 195 can match eol */
YY_RULE_SETUP
#line 390 "m2.lex"
{ if (ign_kw(yystate, REPORT_TO_FILE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return REPORT_TO_FILE;} /* 1 */
	YY_BREAK
case 196:
/* rule 196 can match eol */
YY_RULE_SETUP
#line 392 "m2.lex"
{ if (ign_kw(yystate, REPORT_TO_UI)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return REPORT_TO_UI;} /* 1 */
	YY_BREAK
case 197:
/* rule 197 can match eol */
YY_RULE_SETUP
#line 394 "m2.lex"
{ if (ign_kw(yystate, UPDATESTATS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UPDATESTATS;} /* 1 */
	YY_BREAK
case 198:
/* rule 198 can match eol */
YY_RULE_SETUP
#line 396 "m2.lex"
{ if (ign_kw(yystate, CREATE_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_TABLE;} /* 1 */
	YY_BREAK
case 199:
/* rule 199 can match eol */
YY_RULE_SETUP
#line 398 "m2.lex"
{ if (ign_kw(yystate, DEFAULT_NULL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DEFAULT_NULL;} /* 1 */
	YY_BREAK
case 200:
/* rule 200 can match eol */
YY_RULE_SETUP
#line 400 "m2.lex"
{ if (ign_kw(yystate, DEFAULT_TODAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DEFAULT_TODAY;} /* 1 */
	YY_BREAK
case 201:
/* rule 201 can match eol */
YY_RULE_SETUP
#line 402 "m2.lex"
{ if (ign_kw(yystate, DEFAULT_USER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DEFAULT_USER;} /* 1 */
	YY_BREAK
case 202:
/* rule 202 can match eol */
YY_RULE_SETUP
#line 404 "m2.lex"
{ if (ign_kw(yystate, EXIT_TODO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXIT_TODO;} /* 1 */
	YY_BREAK
case 203:
/* rule 203 can match eol */
YY_RULE_SETUP
#line 406 "m2.lex"
{ if (ign_kw(yystate, CONTINUE_TODO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CONTINUE_TODO;} /* 1 */
	YY_BREAK
case 204:
/* rule 204 can match eol */
YY_RULE_SETUP
#line 408 "m2.lex"
{ if (ign_kw(yystate, UNLOCK_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNLOCK_TABLE;} /* 1 */
	YY_BREAK
case 205:
/* rule 205 can match eol */
YY_RULE_SETUP
#line 410 "m2.lex"
{ if (ign_kw(yystate, ROLLBACK_W)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ROLLBACK_W;} /* 1 */
	YY_BREAK
case 206:
/* rule 206 can match eol */
YY_RULE_SETUP
#line 412 "m2.lex"
{ if (ign_kw(yystate, SQLSEON)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSEON;} /* 1 */
	YY_BREAK
case 207:
/* rule 207 can match eol */
YY_RULE_SETUP
#line 414 "m2.lex"
{ if (ign_kw(yystate, SQLSEOFF)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SQLSEOFF;} /* 1 */
	YY_BREAK
case 208:
/* rule 208 can match eol */
YY_RULE_SETUP
#line 416 "m2.lex"
{ if (ign_kw(yystate, CREATE_VIEW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CREATE_VIEW;} /* 1 */
	YY_BREAK
case 209:
/* rule 209 can match eol */
YY_RULE_SETUP
#line 418 "m2.lex"
{ if (ign_kw(yystate, DELETE_FROM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DELETE_FROM;} /* 1 */
	YY_BREAK
case 210:
/* rule 210 can match eol */
YY_RULE_SETUP
#line 420 "m2.lex"
{ if (ign_kw(yystate, EXTENT_SIZE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXTENT_SIZE;} /* 1 */
	YY_BREAK
case 211:
/* rule 211 can match eol */
YY_RULE_SETUP
#line 422 "m2.lex"
{ if (ign_kw(yystate, FOREIGN_KEY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FOREIGN_KEY;} /* 1 */
	YY_BREAK
case 212:
/* rule 212 can match eol */
YY_RULE_SETUP
#line 424 "m2.lex"
{ if (ign_kw(yystate, INSERT_INTO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INSERT_INTO;} /* 1 */
	YY_BREAK
case 213:
/* rule 213 can match eol */
YY_RULE_SETUP
#line 426 "m2.lex"
{ if (ign_kw(yystate, IS_NOT_NULL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return IS_NOT_NULL;} /* 1 */
	YY_BREAK
case 214:
/* rule 214 can match eol */
YY_RULE_SETUP
#line 428 "m2.lex"
{ if (ign_kw(yystate, NOT_MATCHES)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_MATCHES;} /* 1 */
	YY_BREAK
case 215:
/* rule 215 can match eol */
YY_RULE_SETUP
#line 430 "m2.lex"
{ if (ign_kw(yystate, PRIMARY_KEY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return PRIMARY_KEY;} /* 1 */
	YY_BREAK
case 216:
/* rule 216 can match eol */
YY_RULE_SETUP
#line 432 "m2.lex"
{ if (ign_kw(yystate, WITH_NO_LOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WITH_NO_LOG;} /* 1 */
	YY_BREAK
case 217:
/* rule 217 can match eol */
YY_RULE_SETUP
#line 434 "m2.lex"
{ if (ign_kw(yystate, INSHARE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INSHARE;} /* 1 */
	YY_BREAK
case 218:
/* rule 218 can match eol */
YY_RULE_SETUP
#line 436 "m2.lex"
{ if (ign_kw(yystate, BEGIN_WORK)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return BEGIN_WORK;} /* 1 */
	YY_BREAK
case 219:
/* rule 219 can match eol */
YY_RULE_SETUP
#line 438 "m2.lex"
{ if (ign_kw(yystate, DROP_INDEX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_INDEX;} /* 1 */
	YY_BREAK
case 220:
/* rule 220 can match eol */
YY_RULE_SETUP
#line 440 "m2.lex"
{ if (ign_kw(yystate, FOR_UPDATE_OF)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FOR_UPDATE_OF;} /* 1 */
	YY_BREAK
case 221:
/* rule 221 can match eol */
YY_RULE_SETUP
#line 442 "m2.lex"
{ if (ign_kw(yystate, FOR_UPDATE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FOR_UPDATE;} /* 1 */
	YY_BREAK
case 222:
/* rule 222 can match eol */
YY_RULE_SETUP
#line 444 "m2.lex"
{ if (ign_kw(yystate, LOCK_TABLE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LOCK_TABLE;} /* 1 */
	YY_BREAK
case 223:
/* rule 223 can match eol */
YY_RULE_SETUP
#line 446 "m2.lex"
{ if (ign_kw(yystate, NOT_EXISTS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_EXISTS;} /* 1 */
	YY_BREAK
case 224:
YY_RULE_SETUP
#line 448 "m2.lex"
{ if (ign_kw(yystate, REFERENCES)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return REFERENCES;} /* 1 */
	YY_BREAK
case 225:
/* rule 225 can match eol */
YY_RULE_SETUP
#line 450 "m2.lex"
{ if (ign_kw(yystate, RENCOL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return RENCOL;} /* 1 */
	YY_BREAK
case 226:
YY_RULE_SETUP
#line 452 "m2.lex"
{ if (ign_kw(yystate, SMALLFLOAT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SMALLFLOAT;} /* 1 */
	YY_BREAK
case 227:
/* rule 227 can match eol */
YY_RULE_SETUP
#line 454 "m2.lex"
{ if (ign_kw(yystate, COMMIT_W)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return COMMIT_W;} /* 1 */
	YY_BREAK
case 228:
/* rule 228 can match eol */
YY_RULE_SETUP
#line 456 "m2.lex"
{ if (ign_kw(yystate, RENTAB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return RENTAB;} /* 1 */
	YY_BREAK
case 229:
YY_RULE_SETUP
#line 458 "m2.lex"
{ if (ign_kw(yystate, KW_CHAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_CHAR;} /* 1 */
	YY_BREAK
case 230:
YY_RULE_SETUP
#line 460 "m2.lex"
{ if (ign_kw(yystate, KW_CHAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_CHAR;} /* 2 */
	YY_BREAK
case 231:
YY_RULE_SETUP
#line 462 "m2.lex"
{ if (ign_kw(yystate, NCHAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NCHAR;} /* 1 */
	YY_BREAK
case 232:
YY_RULE_SETUP
#line 464 "m2.lex"
{ if (ign_kw(yystate, NVARCHAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NVARCHAR;} /* 1 */
	YY_BREAK
case 233:
YY_RULE_SETUP
#line 466 "m2.lex"
{ if (ign_kw(yystate, LVARCHAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LVARCHAR;} /* 1 */
	YY_BREAK
case 234:
YY_RULE_SETUP
#line 468 "m2.lex"
{ if (ign_kw(yystate, DELIMITER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DELIMITER;} /* 1 */
	YY_BREAK
case 235:
/* rule 235 can match eol */
YY_RULE_SETUP
#line 470 "m2.lex"
{ if (ign_kw(yystate, DROP_VIEW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP_VIEW;} /* 1 */
	YY_BREAK
case 236:
YY_RULE_SETUP
#line 472 "m2.lex"
{ if (ign_kw(yystate, EXCLUSIVE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXCLUSIVE;} /* 1 */
	YY_BREAK
case 237:
/* rule 237 can match eol */
YY_RULE_SETUP
#line 474 "m2.lex"
{ if (ign_kw(yystate, GREATER_THAN_EQ)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return GREATER_THAN_EQ;} /* 1 */
	YY_BREAK
case 238:
/* rule 238 can match eol */
YY_RULE_SETUP
#line 476 "m2.lex"
{ if (ign_kw(yystate, INTO_TEMP)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTO_TEMP;} /* 1 */
	YY_BREAK
case 239:
YY_RULE_SETUP
#line 478 "m2.lex"
{ if (ign_kw(yystate, DATABASE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATABASE;} /* 1 */
	YY_BREAK
case 240:
YY_RULE_SETUP
#line 480 "m2.lex"
{ if (ign_kw(yystate, DATETIME)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DATETIME;} /* 1 */
	YY_BREAK
case 241:
YY_RULE_SETUP
#line 482 "m2.lex"
{ if (ign_kw(yystate, DISTINCT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DISTINCT;} /* 1 */
	YY_BREAK
case 242:
YY_RULE_SETUP
#line 484 "m2.lex"
{ if (ign_kw(yystate, FRACTION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FRACTION;} /* 1 */
	YY_BREAK
case 243:
/* rule 243 can match eol */
YY_RULE_SETUP
#line 486 "m2.lex"
{ if (ign_kw(yystate, GROUP_BY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return GROUP_BY;} /* 1 */
	YY_BREAK
case 244:
YY_RULE_SETUP
#line 488 "m2.lex"
{ if (ign_kw(yystate, INTERVAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTERVAL;} /* 1 */
	YY_BREAK
case 245:
/* rule 245 can match eol */
YY_RULE_SETUP
#line 490 "m2.lex"
{ if (ign_kw(yystate, NOT_LIKE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_LIKE;} /* 1 */
	YY_BREAK
case 246:
/* rule 246 can match eol */
YY_RULE_SETUP
#line 492 "m2.lex"
{ if (ign_kw(yystate, NOT_ILIKE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_ILIKE;} /* 1 */
	YY_BREAK
case 247:
/* rule 247 can match eol */
YY_RULE_SETUP
#line 494 "m2.lex"
{ if (ign_kw(yystate, NOT_NULL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_NULL;} /* 1 */
	YY_BREAK
case 248:
YY_RULE_SETUP
#line 496 "m2.lex"
{ if (ign_kw(yystate, RESOURCE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return RESOURCE;} /* 1 */
	YY_BREAK
case 249:
YY_RULE_SETUP
#line 498 "m2.lex"
{ if (ign_kw(yystate, SMALLINT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SMALLINT;} /* 1 */
	YY_BREAK
case 250:
/* rule 250 can match eol */
YY_RULE_SETUP
#line 500 "m2.lex"
{ if (ign_kw(yystate, IS_NULL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return IS_NULL;} /* 1 */
	YY_BREAK
case 251:
/* rule 251 can match eol */
YY_RULE_SETUP
#line 502 "m2.lex"
{ if (ign_kw(yystate, LESS_THAN_EQ)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LESS_THAN_EQ;} /* 1 */
	YY_BREAK
case 252:
YY_RULE_SETUP
#line 504 "m2.lex"
{ if (ign_kw(yystate, BETWEEN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return BETWEEN;} /* 1 */
	YY_BREAK
case 253:
YY_RULE_SETUP
#line 506 "m2.lex"
{ if (ign_kw(yystate, CLOSE_BRACKET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CLOSE_BRACKET;} /* 1 */
	YY_BREAK
case 254:
YY_RULE_SETUP
#line 508 "m2.lex"
{ if (ign_kw(yystate, CONNECT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CONNECT;} /* 1 */
	YY_BREAK
case 255:
YY_RULE_SETUP
#line 510 "m2.lex"
{ if (ign_kw(yystate, KW_CURRENT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_CURRENT;} /* 1 */
	YY_BREAK
case 256:
YY_RULE_SETUP
#line 512 "m2.lex"
{ if (ign_kw(yystate, KW_DECIMAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DECIMAL;} /* 1 */
	YY_BREAK
case 257:
YY_RULE_SETUP
#line 514 "m2.lex"
{ if (ign_kw(yystate, KW_DECIMAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DECIMAL;} /* 2 */
	YY_BREAK
case 258:
YY_RULE_SETUP
#line 516 "m2.lex"
{ if (ign_kw(yystate, KW_DECIMAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DECIMAL;} /* 3 */
	YY_BREAK
case 259:
YY_RULE_SETUP
#line 518 "m2.lex"
{ if (ign_kw(yystate, KW_DEFAULT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DEFAULT;} /* 1 */
	YY_BREAK
case 260:
YY_RULE_SETUP
#line 520 "m2.lex"
{ if (ign_kw(yystate, FGL_SYNCFIELDS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FGL_SYNCFIELDS;} /* 1 */
	YY_BREAK
case 261:
YY_RULE_SETUP
#line 522 "m2.lex"
{ if (ign_kw(yystate, INTEGER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTEGER;} /* 1 */
	YY_BREAK
case 262:
YY_RULE_SETUP
#line 524 "m2.lex"
{ if (ign_kw(yystate, INTEGER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTEGER;} /* 2 */
	YY_BREAK
case 263:
YY_RULE_SETUP
#line 526 "m2.lex"
{ if (ign_kw(yystate, INTEGER8)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTEGER8;} /* 1 */
	YY_BREAK
case 264:
YY_RULE_SETUP
#line 528 "m2.lex"
{ if (ign_kw(yystate, INTEGER8)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTEGER8;} /* 2 */
	YY_BREAK
case 265:
YY_RULE_SETUP
#line 530 "m2.lex"
{ if (ign_kw(yystate, INTEGER8)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTEGER8;} /* 3 */
	YY_BREAK
case 266:
YY_RULE_SETUP
#line 532 "m2.lex"
{ if (ign_kw(yystate, INTEGER8)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTEGER8;} /* 4 */
	YY_BREAK
case 267:
YY_RULE_SETUP
#line 534 "m2.lex"
{ if (ign_kw(yystate, SERIAL8)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SERIAL8;} /* 1 */
	YY_BREAK
case 268:
YY_RULE_SETUP
#line 536 "m2.lex"
{ if (ign_kw(yystate, SERIAL8)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SERIAL8;} /* 2 */
	YY_BREAK
case 269:
YY_RULE_SETUP
#line 538 "m2.lex"
{ if (ign_kw(yystate, MATCHES)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MATCHES;} /* 1 */
	YY_BREAK
case 270:
YY_RULE_SETUP
#line 540 "m2.lex"
{ if (ign_kw(yystate, VARCHAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return VARCHAR;} /* 1 */
	YY_BREAK
case 271:
YY_RULE_SETUP
#line 542 "m2.lex"
{ if (ign_kw(yystate, CLOSE_SQUARE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CLOSE_SQUARE;} /* 1 */
	YY_BREAK
case 272:
YY_RULE_SETUP
#line 544 "m2.lex"
{ if (ign_kw(yystate, GREATER_THAN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return GREATER_THAN;} /* 1 */
	YY_BREAK
case 273:
YY_RULE_SETUP
#line 546 "m2.lex"
{ if (ign_kw(yystate, KW_FALSE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_FALSE;} /* 1 */
	YY_BREAK
case 274:
/* rule 274 can match eol */
YY_RULE_SETUP
#line 548 "m2.lex"
{ if (ign_kw(yystate, NOT_IN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_IN;} /* 1 */
	YY_BREAK
case 275:
/* rule 275 can match eol */
YY_RULE_SETUP
#line 550 "m2.lex"
{ if (ign_kw(yystate, OPEN_BRACKET_SELECT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return OPEN_BRACKET_SELECT;} /* 1 */
	YY_BREAK
case 276:
YY_RULE_SETUP
#line 552 "m2.lex"
{ if (ign_kw(yystate, OPEN_BRACKET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return OPEN_BRACKET;} /* 1 */
	YY_BREAK
case 277:
YY_RULE_SETUP
#line 554 "m2.lex"
{ if (ign_kw(yystate, KW_DELETE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DELETE;} /* 1 */
	YY_BREAK
case 278:
YY_RULE_SETUP
#line 556 "m2.lex"
{ if (ign_kw(yystate, KW_ESCAPE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_ESCAPE;} /* 1 */
	YY_BREAK
case 279:
YY_RULE_SETUP
#line 558 "m2.lex"
{ if (ign_kw(yystate, KW_ESCAPE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_ESCAPE;} /* 2 */
	YY_BREAK
case 280:
YY_RULE_SETUP
#line 560 "m2.lex"
{ if (ign_kw(yystate, EXISTS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXISTS;} /* 1 */
	YY_BREAK
case 281:
YY_RULE_SETUP
#line 562 "m2.lex"
{ if (ign_kw(yystate, EXTEND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EXTEND;} /* 1 */
	YY_BREAK
case 282:
YY_RULE_SETUP
#line 564 "m2.lex"
{ if (ign_kw(yystate, HAVING)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return HAVING;} /* 1 */
	YY_BREAK
case 283:
YY_RULE_SETUP
#line 566 "m2.lex"
{ if (ign_kw(yystate, KW_INSERT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_INSERT;} /* 1 */
	YY_BREAK
case 284:
YY_RULE_SETUP
#line 568 "m2.lex"
{ if (ign_kw(yystate, MINUTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MINUTE;} /* 1 */
	YY_BREAK
case 285:
YY_RULE_SETUP
#line 570 "m2.lex"
{ if (ign_kw(yystate, MODIFY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MODIFY;} /* 1 */
	YY_BREAK
case 286:
/* rule 286 can match eol */
YY_RULE_SETUP
#line 572 "m2.lex"
{ if (ign_kw(yystate, EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EQUAL;} /* 1 */
	YY_BREAK
case 287:
YY_RULE_SETUP
#line 574 "m2.lex"
{ if (ign_kw(yystate, EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return EQUAL;} /* 2 */
	YY_BREAK
case 288:
/* rule 288 can match eol */
YY_RULE_SETUP
#line 576 "m2.lex"
{ if (ign_kw(yystate, NOT_EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_EQUAL;} /* 1 */
	YY_BREAK
case 289:
/* rule 289 can match eol */
YY_RULE_SETUP
#line 578 "m2.lex"
{ if (ign_kw(yystate, NOT_EQUAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return NOT_EQUAL;} /* 2 */
	YY_BREAK
case 290:
YY_RULE_SETUP
#line 580 "m2.lex"
{ if (ign_kw(yystate, OPEN_SQUARE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return OPEN_SQUARE;} /* 1 */
	YY_BREAK
case 291:
YY_RULE_SETUP
#line 582 "m2.lex"
{ if (ign_kw(yystate, PUBLIC)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return PUBLIC;} /* 1 */
	YY_BREAK
case 292:
YY_RULE_SETUP
#line 584 "m2.lex"
{ if (ign_kw(yystate, KW_RETURN_KEY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_RETURN_KEY;} /* 1 */
	YY_BREAK
case 293:
YY_RULE_SETUP
#line 586 "m2.lex"
{ if (ign_kw(yystate, REVOKE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return REVOKE;} /* 1 */
	YY_BREAK
case 294:
YY_RULE_SETUP
#line 588 "m2.lex"
{ if (ign_kw(yystate, SECOND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SECOND;} /* 1 */
	YY_BREAK
case 295:
YY_RULE_SETUP
#line 590 "m2.lex"
{ if (ign_kw(yystate, KW_SELECT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_SELECT;} /* 1 */
	YY_BREAK
case 296:
YY_RULE_SETUP
#line 592 "m2.lex"
{ if (ign_kw(yystate, SERIAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SERIAL;} /* 1 */
	YY_BREAK
case 297:
YY_RULE_SETUP
#line 594 "m2.lex"
{ if (ign_kw(yystate, UNIQUE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNIQUE;} /* 1 */
	YY_BREAK
case 298:
YY_RULE_SETUP
#line 596 "m2.lex"
{ if (ign_kw(yystate, KW_UPDATE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_UPDATE;} /* 1 */
	YY_BREAK
case 299:
YY_RULE_SETUP
#line 598 "m2.lex"
{ if (ign_kw(yystate, VALUES)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return VALUES;} /* 1 */
	YY_BREAK
case 300:
YY_RULE_SETUP
#line 600 "m2.lex"
{ if (ign_kw(yystate, KW_NULL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_NULL;} /* 1 */
	YY_BREAK
case 301:
YY_RULE_SETUP
#line 602 "m2.lex"
{ if (ign_kw(yystate, KW_TRUE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_TRUE;} /* 1 */
	YY_BREAK
case 302:
YY_RULE_SETUP
#line 604 "m2.lex"
{ if (ign_kw(yystate, ALTER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ALTER;} /* 1 */
	YY_BREAK
case 303:
YY_RULE_SETUP
#line 606 "m2.lex"
{ if (ign_kw(yystate, CHECK)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CHECK;} /* 1 */
	YY_BREAK
case 304:
YY_RULE_SETUP
#line 608 "m2.lex"
{ if (ign_kw(yystate, KW_FIRST)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_FIRST;} /* 1 */
	YY_BREAK
case 305:
YY_RULE_SETUP
#line 610 "m2.lex"
{ if (ign_kw(yystate, KW_FLOAT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_FLOAT;} /* 1 */
	YY_BREAK
case 306:
YY_RULE_SETUP
#line 612 "m2.lex"
{ if (ign_kw(yystate, GRANT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return GRANT;} /* 1 */
	YY_BREAK
case 307:
YY_RULE_SETUP
#line 614 "m2.lex"
{ if (ign_kw(yystate, INDEX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INDEX;} /* 1 */
	YY_BREAK
case 308:
YY_RULE_SETUP
#line 616 "m2.lex"
{ if (ign_kw(yystate, LESS_THAN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LESS_THAN;} /* 1 */
	YY_BREAK
case 309:
YY_RULE_SETUP
#line 618 "m2.lex"
{ if (ign_kw(yystate, MONEY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MONEY;} /* 1 */
	YY_BREAK
case 310:
YY_RULE_SETUP
#line 620 "m2.lex"
{ if (ign_kw(yystate, MONTH)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return MONTH;} /* 1 */
	YY_BREAK
case 311:
YY_RULE_SETUP
#line 622 "m2.lex"
{ if (ign_kw(yystate, KW_MULTIPLY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_MULTIPLY;} /* 1 */
	YY_BREAK
case 312:
YY_RULE_SETUP
#line 624 "m2.lex"
{ if (ign_kw(yystate, ORDER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ORDER;} /* 1 */
	YY_BREAK
case 313:
YY_RULE_SETUP
#line 626 "m2.lex"
{ if (ign_kw(yystate, OUTER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return OUTER;} /* 1 */
	YY_BREAK
case 314:
YY_RULE_SETUP
#line 628 "m2.lex"
{ if (ign_kw(yystate, UNION)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return UNION;} /* 1 */
	YY_BREAK
case 315:
YY_RULE_SETUP
#line 630 "m2.lex"
{ if (ign_kw(yystate, WHERE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WHERE;} /* 1 */
	YY_BREAK
case 316:
YY_RULE_SETUP
#line 632 "m2.lex"
{ if (ign_kw(yystate, KW_BYTE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_BYTE;} /* 1 */
	YY_BREAK
case 317:
YY_RULE_SETUP
#line 634 "m2.lex"
{ if (ign_kw(yystate, CASE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return CASE;} /* 1 */
	YY_BREAK
case 318:
YY_RULE_SETUP
#line 636 "m2.lex"
{ if (ign_kw(yystate, KW_DATE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DATE;} /* 1 */
	YY_BREAK
case 319:
YY_RULE_SETUP
#line 638 "m2.lex"
{ if (ign_kw(yystate, DESC)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DESC;} /* 1 */
	YY_BREAK
case 320:
YY_RULE_SETUP
#line 640 "m2.lex"
{ if (ign_kw(yystate, KW_DIVIDE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DIVIDE;} /* 1 */
	YY_BREAK
case 321:
/* rule 321 can match eol */
YY_RULE_SETUP
#line 642 "m2.lex"
{ if (ign_kw(yystate, KW_SHTAB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_SHTAB;} /* 1 */
	YY_BREAK
case 322:
YY_RULE_SETUP
#line 644 "m2.lex"
{ if (ign_kw(yystate, KW_SHTAB)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_SHTAB;} /* 2 */
	YY_BREAK
case 323:
YY_RULE_SETUP
#line 646 "m2.lex"
{ if (ign_kw(yystate, DROP)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DROP;} /* 1 */
	YY_BREAK
case 324:
YY_RULE_SETUP
#line 648 "m2.lex"
{ if (ign_kw(yystate, ELSE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ELSE;} /* 1 */
	YY_BREAK
case 325:
YY_RULE_SETUP
#line 650 "m2.lex"
{ if (ign_kw(yystate, FROM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FROM;} /* 1 */
	YY_BREAK
case 326:
YY_RULE_SETUP
#line 652 "m2.lex"
{ if (ign_kw(yystate, HOUR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return HOUR;} /* 1 */
	YY_BREAK
case 327:
YY_RULE_SETUP
#line 654 "m2.lex"
{ if (ign_kw(yystate, INTO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return INTO;} /* 1 */
	YY_BREAK
case 328:
YY_RULE_SETUP
#line 656 "m2.lex"
{ if (ign_kw(yystate, LIKE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return LIKE;} /* 1 */
	YY_BREAK
case 329:
YY_RULE_SETUP
#line 658 "m2.lex"
{ if (ign_kw(yystate, REAL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return REAL;} /* 1 */
	YY_BREAK
case 330:
YY_RULE_SETUP
#line 660 "m2.lex"
{ if (ign_kw(yystate, SOME)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SOME;} /* 1 */
	YY_BREAK
case 331:
YY_RULE_SETUP
#line 662 "m2.lex"
{ if (ign_kw(yystate, KW_TEXT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_TEXT;} /* 1 */
	YY_BREAK
case 332:
YY_RULE_SETUP
#line 664 "m2.lex"
{ if (ign_kw(yystate, KW_THEN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_THEN;} /* 1 */
	YY_BREAK
case 333:
YY_RULE_SETUP
#line 666 "m2.lex"
{ if (ign_kw(yystate, USER)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return USER;} /* 1 */
	YY_BREAK
case 334:
YY_RULE_SETUP
#line 668 "m2.lex"
{ if (ign_kw(yystate, WHEN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WHEN;} /* 1 */
	YY_BREAK
case 335:
YY_RULE_SETUP
#line 670 "m2.lex"
{ if (ign_kw(yystate, YEAR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return YEAR;} /* 1 */
	YY_BREAK
case 336:
YY_RULE_SETUP
#line 672 "m2.lex"
{ if (ign_kw(yystate, KW_DOW)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DOW;} /* 1 */
	YY_BREAK
case 337:
YY_RULE_SETUP
#line 674 "m2.lex"
{ if (ign_kw(yystate, XSET)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XSET;} /* 1 */
	YY_BREAK
case 338:
YY_RULE_SETUP
#line 676 "m2.lex"
{ if (ign_kw(yystate, ADD)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ADD;} /* 1 */
	YY_BREAK
case 339:
YY_RULE_SETUP
#line 678 "m2.lex"
{ if (ign_kw(yystate, ALL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ALL;} /* 1 */
	YY_BREAK
case 340:
YY_RULE_SETUP
#line 680 "m2.lex"
{ if (ign_kw(yystate, KW_AND)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_AND;} /* 1 */
	YY_BREAK
case 341:
YY_RULE_SETUP
#line 682 "m2.lex"
{ if (ign_kw(yystate, ANY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ANY;} /* 1 */
	YY_BREAK
case 342:
YY_RULE_SETUP
#line 684 "m2.lex"
{ if (ign_kw(yystate, ASC)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ASC;} /* 1 */
	YY_BREAK
case 343:
YY_RULE_SETUP
#line 686 "m2.lex"
{ if (ign_kw(yystate, AVG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return AVG;} /* 1 */
	YY_BREAK
case 344:
YY_RULE_SETUP
#line 688 "m2.lex"
{ if (ign_kw(yystate, COLON)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return COLON;} /* 1 */
	YY_BREAK
case 345:
YY_RULE_SETUP
#line 690 "m2.lex"
{ if (ign_kw(yystate, KW_COMMA)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_COMMA;} /* 1 */
	YY_BREAK
case 346:
YY_RULE_SETUP
#line 692 "m2.lex"
{ if (ign_kw(yystate, DAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DAY;} /* 1 */
	YY_BREAK
case 347:
YY_RULE_SETUP
#line 694 "m2.lex"
{ if (ign_kw(yystate, DBA)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DBA;} /* 1 */
	YY_BREAK
case 348:
YY_RULE_SETUP
#line 696 "m2.lex"
{ if (ign_kw(yystate, KW_FOR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_FOR;} /* 1 */
	YY_BREAK
case 349:
YY_RULE_SETUP
#line 698 "m2.lex"
{ if (ign_kw(yystate, XMAX)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XMAX;} /* 1 */
	YY_BREAK
case 350:
YY_RULE_SETUP
#line 700 "m2.lex"
{ if (ign_kw(yystate, XMIN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return XMIN;} /* 1 */
	YY_BREAK
case 351:
YY_RULE_SETUP
#line 702 "m2.lex"
{ if (ign_kw(yystate, KW_MINUS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_MINUS;} /* 1 */
	YY_BREAK
case 352:
YY_RULE_SETUP
#line 704 "m2.lex"
{ if (ign_kw(yystate, KW_MOD)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_MOD;} /* 1 */
	YY_BREAK
case 353:
YY_RULE_SETUP
#line 706 "m2.lex"
{ if (ign_kw(yystate, KW_NOT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_NOT;} /* 1 */
	YY_BREAK
case 354:
YY_RULE_SETUP
#line 708 "m2.lex"
{ if (ign_kw(yystate, KW_SUM)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_SUM;} /* 1 */
	YY_BREAK
case 355:
YY_RULE_SETUP
#line 710 "m2.lex"
{ if (ign_kw(yystate, ATSIGN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ATSIGN;} /* 1 */
	YY_BREAK
case 356:
YY_RULE_SETUP
#line 712 "m2.lex"
{ if (ign_kw(yystate, KW_PLUS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_PLUS;} /* 1 */
	YY_BREAK
case 357:
/* rule 357 can match eol */
YY_RULE_SETUP
#line 714 "m2.lex"
{ if (ign_kw(yystate, KW_PLUS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_PLUS;} /* 2 */
	YY_BREAK
case 358:
YY_RULE_SETUP
#line 716 "m2.lex"
{ if (ign_kw(yystate, KW_AS)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_AS;} /* 1 */
	YY_BREAK
case 359:
YY_RULE_SETUP
#line 718 "m2.lex"
{ if (ign_kw(yystate, KW_BY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_BY;} /* 1 */
	YY_BREAK
case 360:
YY_RULE_SETUP
#line 720 "m2.lex"
{ if (ign_kw(yystate, KW_DOT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_DOT;} /* 1 */
	YY_BREAK
case 361:
YY_RULE_SETUP
#line 722 "m2.lex"
{ if (ign_kw(yystate, KW_IN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_IN;} /* 1 */
	YY_BREAK
case 362:
YY_RULE_SETUP
#line 724 "m2.lex"
{ if (ign_kw(yystate, KW_ON)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_ON;} /* 1 */
	YY_BREAK
case 363:
YY_RULE_SETUP
#line 726 "m2.lex"
{ if (ign_kw(yystate, KW_OR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_OR;} /* 1 */
	YY_BREAK
case 364:
YY_RULE_SETUP
#line 728 "m2.lex"
{ if (ign_kw(yystate, KW_TO)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_TO;} /* 1 */
	YY_BREAK
case 365:
YY_RULE_SETUP
#line 730 "m2.lex"
{ if (ign_kw(yystate, BEFORE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return BEFORE;} /* 1 */
	YY_BREAK
case 366:
YY_RULE_SETUP
#line 732 "m2.lex"
{ if (ign_kw(yystate, END)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return END;} /* 1 */
	YY_BREAK
case 367:
YY_RULE_SETUP
#line 734 "m2.lex"
{ if (ign_kw(yystate, TILDE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return TILDE;} /* 1 */
	YY_BREAK
case 368:
YY_RULE_SETUP
#line 736 "m2.lex"
{ if (ign_kw(yystate, ILIKE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return ILIKE;} /* 1 */
	YY_BREAK
case 369:
YY_RULE_SETUP
#line 738 "m2.lex"
{ if (ign_kw(yystate, FILLFACTOR)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return FILLFACTOR;} /* 1 */
	YY_BREAK
case 370:
YY_RULE_SETUP
#line 740 "m2.lex"
{ if (ign_kw(yystate, TIME)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return TIME;} /* 1 */
	YY_BREAK
case 371:
YY_RULE_SETUP
#line 742 "m2.lex"
{ if (ign_kw(yystate, KW_TODAY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_TODAY;} /* 1 */
	YY_BREAK
case 372:
YY_RULE_SETUP
#line 744 "m2.lex"
{ if (ign_kw(yystate, KW_ROWID)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_ROWID;} /* 1 */
	YY_BREAK
case 373:
YY_RULE_SETUP
#line 746 "m2.lex"
{ if (ign_kw(yystate, TIMESTAMP)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return TIMESTAMP;} /* 1 */
	YY_BREAK
case 374:
YY_RULE_SETUP
#line 748 "m2.lex"
{ if (ign_kw(yystate, KWPIPE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KWPIPE;} /* 1 */
	YY_BREAK
case 375:
YY_RULE_SETUP
#line 750 "m2.lex"
{ if (ign_kw(yystate, COUNT)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return COUNT;} /* 1 */
	YY_BREAK
case 376:
YY_RULE_SETUP
#line 752 "m2.lex"
{ if (ign_kw(yystate, DIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return DIALOG;} /* 1 */
	YY_BREAK
case 377:
YY_RULE_SETUP
#line 754 "m2.lex"
{ if (ign_kw(yystate, SUBDIALOG)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SUBDIALOG;} /* 1 */
	YY_BREAK
case 378:
YY_RULE_SETUP
#line 756 "m2.lex"
{ if (ign_kw(yystate, PDF_XY)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return PDF_XY;} /* 1 */
	YY_BREAK
case 379:
/* rule 379 can match eol */
YY_RULE_SETUP
#line 758 "m2.lex"
{ if (ign_kw(yystate, SET_VALUE)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return SET_VALUE;} /* 1 */
	YY_BREAK
case 380:
YY_RULE_SETUP
#line 760 "m2.lex"
{ if (ign_kw(yystate, KW_EMBEDDED)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_EMBEDDED;} /* 1 */
	YY_BREAK
case 381:
YY_RULE_SETUP
#line 762 "m2.lex"
{ if (ign_kw(yystate, KW_BOOLEAN)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return KW_BOOLEAN;} /* 1 */
	YY_BREAK
case 382:
/* rule 382 can match eol */
YY_RULE_SETUP
#line 764 "m2.lex"
{ if (ign_kw(yystate, WITHOUT_SCROLL)) REJECT; a4gl_upshift(yytext); strcpy(yylval.str,yytext);  return WITHOUT_SCROLL;} /* 1 */
	YY_BREAK
case 383:
/* rule 383 can match eol */
YY_RULE_SETUP
#line 766 "m2.lex"
;
	YY_BREAK
case 384:
/* rule 384 can match eol */
YY_RULE_SETUP
#line 767 "m2.lex"
;
	YY_BREAK
case 385:
YY_RULE_SETUP
#line 768 "m2.lex"
{strcpy(yylval.str,";"); return SEMICOLON;}
	YY_BREAK
case 386:
YY_RULE_SETUP
#line 769 "m2.lex"
{strcpy(yylval.str,"?"); return QUESTION_MARK;}
	YY_BREAK
case 387:
YY_RULE_SETUP
#line 770 "m2.lex"
{strcpy(yylval.str,"?"); return QUESTION_MARK;}
	YY_BREAK
case 388:
YY_RULE_SETUP
#line 771 "m2.lex"
{strcpy(yylval.str,yytext);return NAMED;}
	YY_BREAK
case 389:
YY_RULE_SETUP
#line 773 "m2.lex"
{  strcpy(yylval.str,yytext); return NOT_EQUAL;}
	YY_BREAK
case 390:
YY_RULE_SETUP
#line 774 "m2.lex"
{  strcpy(yylval.str,yytext); return NOT_EQUAL;}
	YY_BREAK
case 391:
YY_RULE_SETUP
#line 775 "m2.lex"
{  strcpy(yylval.str,yytext); return LESS_THAN_EQ;}
	YY_BREAK
case 392:
YY_RULE_SETUP
#line 776 "m2.lex"
{  strcpy(yylval.str,yytext); return GREATER_THAN_EQ;}
	YY_BREAK
case 393:
/* rule 393 can match eol */
YY_RULE_SETUP
#line 777 "m2.lex"
{  strcpy(yylval.str,yytext); return CHAR_VALUE;}
	YY_BREAK
case 394:
YY_RULE_SETUP
#line 778 "m2.lex"
{  strcpy(yylval.str,yytext); return CHAR_VALUE;}
	YY_BREAK
case 395:
/* rule 395 can match eol */
YY_RULE_SETUP
#line 779 "m2.lex"
{  strcpy(yylval.str,yytext); return CHAR_VALUE;}
	YY_BREAK
case 396:
YY_RULE_SETUP
#line 780 "m2.lex"
{  strcpy(yylval.str,yytext); return CHAR_VALUE;}
	YY_BREAK
case 397:
YY_RULE_SETUP
#line 781 "m2.lex"
{return MARK_VAR;}
	YY_BREAK
case 398:
YY_RULE_SETUP
#line 782 "m2.lex"
{return END_MARK_VAR;}
	YY_BREAK
case 399:
YY_RULE_SETUP
#line 785 "m2.lex"
{strcpy(yylval.str, yytext); return(INT_VALUE);}
	YY_BREAK
case 400:
YY_RULE_SETUP
#line 786 "m2.lex"
{strcpy(yylval.str, yytext); return(NUMBER_VALUE);}
	YY_BREAK
case 401:
YY_RULE_SETUP
#line 788 "m2.lex"
{strcpy(yylval.str,yytext);return CH;}
	YY_BREAK
case 402:
YY_RULE_SETUP
#line 790 "m2.lex"
ECHO;
	YY_BREAK
#line 6274 "lex.yy.c"
			case YY_STATE_EOF(INITIAL):
			case YY_STATE_EOF(comment):
				yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	yy_size_t number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (yy_size_t) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			yy_size_t num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((int) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	(yy_state_ptr) = (yy_state_buf);
	*(yy_state_ptr)++ = yy_current_state;

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 2281 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*(yy_state_ptr)++ = yy_current_state;
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    
	YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 2281 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 2280);
	if ( ! yy_is_jam )
		*(yy_state_ptr)++ = yy_current_state;

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

    static void yyunput (int c, char * yy_bp )
{
	char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up yytext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		yy_size_t number_to_move = (yy_n_chars) + 2;
		char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

    if ( c == '\n' ){
        --yylineno;
    }

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			yy_size_t offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	if ( c == '\n' )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = (yy_size_t)size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, yy_size_t  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	yy_size_t i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
			(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
yy_size_t yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

    (yy_state_buf) = 0;
    (yy_state_ptr) = 0;
    (yy_full_match) = 0;
    (yy_lp) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    yyfree ( (yy_state_buf) );
    (yy_state_buf)  = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 790 "m2.lex"


#include "mk_sstates.c"
static int ign_kw(int yystate,int kw) {
        if (!SQLPARSE_allow_token_state(yystate,kw)) {
			return 1;
	} 
        return 0;

}


